SystemOrganization addCategory: #'SqSave-Base'!
SystemOrganization addCategory: #'SqSave-Tests'!
SystemOrganization addCategory: #'SqSave-Connection'!
SystemOrganization addCategory: #'SqSave-UsageExamples'!
SystemOrganization addCategory: #'SqSave-Base-Structures'!
SystemOrganization addCategory: #'SqSave-Analysis'!
SystemOrganization addCategory: #'SqSave-Query'!
SystemOrganization addCategory: #'SqSave-Apps'!
SystemOrganization addCategory: #'SqSave-Apps-OO7'!

Trait named: #TSqsSearch
	uses: {}
	category: 'SqSave-Base'!

!TSqsSearch methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 19:32'!
doesNotUnderstand: aMessage 
	| attributes limit |
	attributes := self findAttributesInSelector: aMessage selector forClass: self.
	attributes 
		ifNil: [ ^ super doesNotUnderstand: aMessage ]
		ifNotNil: 
			[ limit := self findLimitInSelector: aMessage selector.
			^ (SqsSearch for: self) 
				searchBy: attributes
				withValues: aMessage arguments
				limit: limit ]! !

!TSqsSearch methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 19:33'!
findAttributesInSelector: aSelector forClass: aClass
	| finderMethod all startWord attributes |

	finderMethod := aSelector prefixMatchesRegex: 'find[[:alpha:]]*By'.
	finderMethod ifTrue: [
		all := aSelector prefixMatchesRegex: 'findAllBy[[:upper:]]+'.
		startWord := all ifTrue:['findAllBy'] ifFalse: [	startWord := 'findBy'].
		attributes := self findAttributesInSelector: aSelector forClass: aClass beginWith: startWord.
	].
	^ attributes! !

!TSqsSearch methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 19:34'!
findAttributesInSelector: aSelector forClass: aClass beginWith: aString
	| elements searchedAttributes attrName |
	elements := aSelector subStrings: ':'.
	searchedAttributes := OrderedCollection new.
	elements at: 1 put: ((elements first) allButFirst: (aString size)).
	elements do:[ :el |
		attrName := el.
		(el beginsWith: 'and') ifTrue:[attrName := el allButFirst: 3].
		attrName := attrName withFirstCharacterDownshifted.
		((aClass allInstVarNames includes: attrName) or: [attrName = SqsSearch searchForIdField]) ifTrue: [
			searchedAttributes add: attrName.	
		] ifFalse: [			
			^nil
		]
	].
	^searchedAttributes! !

!TSqsSearch methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 19:34'!
findLimitInSelector: aSelector
	| limit |
	limit := nil.
	(aSelector prefixMatchesRegex: 'findAllBy[[:upper:]]+') ifFalse: [
		limit := 1.	
	].
	^ limit! !

Trait named: #TSqsSelfPrinting
	uses: {}
	category: 'SqSave-Base-Structures'!

!TSqsSelfPrinting methodsFor: 'printing' stamp: 'test 1/27/2009 11:29'!
codeForObjectCreation
	| aStream |
	aStream := TextStream on: String new.
	aStream nextPut: $(.
	aStream nextPutAll: self class name , ' new'.
	aStream nextPutAll: String crlf , String tab.
	1 
		to: self class instSize
		do: 
			[ :i | 
			(self instVarAt: i) ifNotNil: 
				[ aStream
					nextPutAll: String cr , String tab;
					nextPutAll: ' ' , (self class allInstVarNames at: i) , ': ';
					store: (self instVarAt: i);
					nextPut: $; ] ].
	aStream nextPutAll: String cr , String tab , ' yourself)'.
	^ aStream contents! !

!TSqsSelfPrinting methodsFor: 'printing' stamp: 'test 1/27/2009 11:28'!
storeOn: aStream
	aStream nextPutAll: self codeForObjectCreation! !

!String class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:29'!
sqsType
	^#string! !

!String methodsFor: '*sqsave' stamp: 'lr 7/14/2003 11:34'!
asEscapedSql
	^String streamContents: [ :stream |
		self do: [ :char |
			(#($' $\) includes: char)
				ifTrue: [ stream nextPut: char ].
			stream nextPut: char ] ]! !

!String methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:39'!
asSqSaveDescriptionSelector
	| selector |
	selector := self copy asString.
	self ifNotEmpty: [
		selector at: 1 put: (((self at: 1) asUppercase)).	
	].
	^('sqsDescr',selector) asSymbol.! !

!String methodsFor: '*sqsave' stamp: 'tkow 10/6/2008 11:31'!
asSqSaveDescriptorClassName
	^(self capitalized, 'PersistenceDescriptor') asSymbol! !

!String methodsFor: '*sqsave' stamp: 'tk 7/7/2008 15:19'!
asSqSaveTableName
	| |
	^self decamelized,'s'! !

!String methodsFor: '*sqsave' stamp: 'wh 3/2/2006 11:13'!
asSqlValueString
	^'''',self asEscapedSql,''''.! !

!String methodsFor: '*sqsave' stamp: 'tkow 11/18/2008 18:11'!
camelized
	| result prevChar |
	result := WriteStream on: String new.
	prevChar := $t.
	self do: [:char |
		char ~= $_ ifTrue: [
			result nextPut: ((prevChar = $_) ifTrue: [char asUppercase] ifFalse: [char ]).
		]. 
		prevChar := char.		
	].
	^result contents! !

!String methodsFor: '*sqsave' stamp: 'tk 7/7/2008 15:19'!
decamelized
	| result nextChar |
	result := WriteStream on: String new.
	self withIndexDo: [:char :index |
		nextChar := self at: (index + 1) ifAbsent: [$t].
		(((nextChar isLowercase) and: [char isUppercase]) and:[index > 1]) ifTrue: [
			result nextPutAll: '_'.
		].
		result nextPutAll: char asLowercase asString.
	].
	^result contents! !

!String methodsFor: '*sqsave' stamp: 'tkow 12/11/2008 18:22'!
splitBy: aString
	| curPosition results nextString nextPosition |
	(self size < 3) ifTrue: [^self].
	curPosition := 1.
	results := OrderedCollection new.
	[curPosition < self size] whileTrue: [
		nextPosition := self findString: aString startingAt: curPosition.
		(nextPosition = 0) ifTrue: [
			nextString := self copyFrom: curPosition to: self size.
			curPosition := self size.	
		] ifFalse: [
			nextString := self copyFrom: curPosition to: (nextPosition - 1).	
			curPosition := nextPosition + aString size.
		].
		nextString ifNotEmpty:[results add: nextString]
	].
	^ results! !

!JdmConnection methodsFor: '*sqsave' stamp: 'tkow 10/29/2008 14:11'!
finalize
	[self close] ifError: []! !

!JdmConnection methodsFor: '*sqsave' stamp: 'tk 7/18/2008 16:02'!
socket
	^socket! !

!Time class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:31'!
sqsType
	^#time! !

!Time methodsFor: '*sqsave' stamp: 'wh 8/9/2006 01:01'!
asSqlValueString
	^'''',self asString,''''.! !

ProtoObject subclass: #SqsProxy
	instanceVariableNames: 'sqsProxiedObject sqsProxyOwner sqsProxiedVariable sqsInitialized'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqsProxy subclass: #SqsCollectionProxy
	instanceVariableNames: 'sqsSimpleValues sqsCollectionMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsCollectionProxy class methodsFor: 'cached-creation' stamp: 'tkow 12/2/2008 14:14'!
for: aCollection ofInstVar: anIvarName in: anObject simpleValues: aBool 
	| |
	^ self basicNew
		sqsProxyOwner: anObject;
		sqsSimpleValues: aBool;
		sqsProxiedObject: aCollection;
		sqsProxiedVariable: anIvarName;
		sqsInitialized: true.! !

!SqsCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:38'!
sqSaveClass
	^ sqsProxiedObject class! !

!SqsCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/2/2008 14:06'!
sqsCollectionMap
	^ sqsCollectionMap! !

!SqsCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/2/2008 14:13'!
sqsCreateCollectionMap
	| tmpMap |
	sqsProxiedObject ifNotNil: 
		[ tmpMap := OrderedCollection new.
		sqsProxiedObject do: 
			[ :obj | 
			| value |
			value := obj ifNotNil: 
				[ sqsSimpleValues 
					ifTrue: [ obj ]
					ifFalse: [ obj oid ] ].
			tmpMap add: value ] ].
	^ tmpMap! !

!SqsCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/12/2008 17:38'!
sqsGetCollectionChanges
	| counter changes newCollectionMap |
	counter := 0.
	newCollectionMap := self sqsCreateCollectionMap.
	changes := SqsCollectionChanges new.
	sqsCollectionMap ifNil: [ ^ changes ].
	sqsCollectionMap do: 
		[ :oid | 
		| newOid |
		counter := counter + 1.
		counter > newCollectionMap size 
			ifTrue: 
				[ changes deletedObjects add: (OrderedCollection 
						with: oid
						with: counter) ]
			ifFalse: 
				[ newOid := newCollectionMap at: counter.
				newOid ~= oid ifTrue: 
					[ changes movedObjects add: (OrderedCollection 
							with: newOid
							with: counter) ] ] ].
	[ counter < newCollectionMap size ] whileTrue: 
		[ counter := counter + 1.
		changes addedObjects add: (OrderedCollection 
				with: (newCollectionMap at: counter)
				with: counter) ].
	sqsCollectionMap := newCollectionMap.
	^ changes! !

!SqsCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/12/2008 17:45'!
sqsLoadProxiedObject
	sqsInitialized ifNotNil: 
		[ sqsProxiedObject ifNil: 
			[ sqsProxiedObject := (SqsStorage for: sqsProxyOwner) loadProxiedCollectionFor: sqsProxiedVariable.
			sqsCollectionMap := self sqsCreateCollectionMap ] ]! !

!SqsCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/2/2008 14:23'!
sqsProxiedObject: anObject 
	super sqsProxiedObject: anObject.
	"only update the map when there is not already one present"
	sqsCollectionMap := self sqsCreateCollectionMap.! !

!SqsCollectionProxy methodsFor: 'accessing' stamp: 'tkow 9/23/2008 17:35'!
sqsSimpleValues: anObject
	sqsSimpleValues := anObject! !

!SqsProxy class methodsFor: 'cached-creation' stamp: 'tkow 12/1/2008 11:42'!
for: aCollection ofInstVar: anIvarName in: anObject 
	^ self basicNew
		sqsProxyOwner: anObject;
		sqsProxiedObject: aCollection;
		sqsProxiedVariable: anIvarName;
		sqsInitialized: true! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 17:45'!
doesNotUnderstand: aMessage 
	"TODO: handling for fancy load strategies here"
	self sqsLoadProxiedObject.
	"TODO: implement some sort of access loggin here"
	^ aMessage sendTo: sqsProxiedObject! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:41'!
sqSaveClass
	^ sqsProxiedObject class! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:36'!
sqsInitialized: aBool
	sqsInitialized := aBool ! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 12/12/2008 17:45'!
sqsLoadProxiedObject
	"rather dirty, but since we don't proxy integers, we can use them as an indicator'
	this way we only have one place that gets more complicated and the rest remains
	untouched"
	(sqsProxiedObject isNil or: [ sqsProxiedObject isInteger ]) ifTrue: 
		[ sqsProxiedObject := (SqsStorage for: sqsProxyOwner) 
			loadProxiedObjectFor: sqsProxiedVariable
			withOid: sqsProxiedObject ]! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 12/2/2008 18:44'!
sqsProxiedObject
	^ sqsProxiedObject! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:42'!
sqsProxiedObject: anObject 
	sqsProxiedObject := anObject! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:42'!
sqsProxiedVariable: anObject 
	sqsProxiedVariable := anObject! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:41'!
sqsProxyOwner: anObject 
	sqsProxyOwner := anObject! !

ProtoObject subclass: #SqsQueryValue
	instanceVariableNames: 'query whereBuffer depictedClass referencedColumn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

SqsQueryValue subclass: #SqsQueryBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryBoolean methodsFor: 'logical operations' stamp: 'tkow 10/30/2008 16:25'!
& anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: 'AND'! !

!SqsQueryBoolean methodsFor: 'testing' stamp: 'tkow 10/30/2008 16:25'!
isFalse
	^ self 
		booleanCompair: 0
		with: '='! !

!SqsQueryBoolean methodsFor: 'testing' stamp: 'tkow 10/30/2008 16:25'!
isTrue
	^ self 
		booleanCompair: 1
		with: '='! !

!SqsQueryBoolean methodsFor: 'logical operations' stamp: 'tkow 10/30/2008 16:25'!
| anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: 'OR'! !

SqsQueryValue subclass: #SqsQueryCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'test 1/30/2009 15:58'!
anySatisfy: aBlock
	| nextQuery |

	self sqsConcatQueryForSatisfy: aBlock andNegate: false.
	nextQuery := self query newForType: Boolean.
	nextQuery whereBuffer: self whereBuffer.
	^ nextQuery
! !

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'test 1/29/2009 17:42'!
includes: anObject
	| valueField joinTable suffix sql nextQuery |
	"find the value field within the current join table"
	valueField := (SqsClassInfo for: self query previousQueryObject depictedClass) configuration collectionConfiguration valueField.
	joinTable := self sqsReferencedColumn tableName.
	suffix := self query aliasSuffixForTableOfClass: Collection.
	
	"create the sql query necessary to check if there is a value within the table that either directly
	matches anObject or matches anObject's oid (i.e. a reference to another complex object)"
	sql := '', joinTable, suffix, '.', valueField, ' = '.
	sql := sql, (self sqsReferencedColumn simpleValues ifTrue: [anObject] ifFalse: [anObject oid	]) asSqlValueString.

	"add the query to the where buffer and return the the query object for our result - a boolean"
	self addToWhereBuffer: ('AND (', sql,')').
	nextQuery := self query newForType: Boolean.
	nextQuery whereBuffer: self whereBuffer.
	^ nextQuery
	! !

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'test 1/30/2009 15:59'!
noneSatisfy: aBlock
	| nextQuery |
	self sqsConcatQueryForSatisfy: aBlock andNegate: true.
	nextQuery := self query newForType: Boolean.
	nextQuery whereBuffer: self whereBuffer.
	^ nextQuery

	! !

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'test 1/29/2009 17:43'!
size
	| sql tableName ownerColumn refColumn refTable nextQuery suffix refSuffix adapter |

	suffix := self query aliasSuffixForTableOfClass: self depictedClass.
	tableName := self sqsReferencedColumn tableName, suffix.
	
	adapter := (SqsClassInfo for: self query queryClass) sqsSession sqsDbAdapter. 
		
	sql := 'SELECT ',adapter class completeCount ,' FROM ', tableName, ' WHERE '.

	ownerColumn := self sqsReferencedColumn ownerColumn columnName.
	refColumn := self sqsReferencedColumn ownerColumn foreignKey referencedColumns first.
	refTable := self sqsReferencedColumn ownerColumn foreignKey referencedTable.
	refSuffix := self query aliasSuffixForTableOfClass: (self query previousQueryObject depictedClass ).
	
	sql := sql,'(', tableName, '.', ownerColumn, ' = ', refTable,refSuffix, '.', refColumn, ')'.
	
	self addToWhereBuffer: ('AND (', sql,')').
	nextQuery := self query newForType: Number.
	nextQuery whereBuffer: self whereBuffer.
	^ nextQuery! !

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'test 2/2/2009 14:21'!
sqsConcatQueryForSatisfy: aBlock andNegate: aBool
	
	| sql nextQuery negate |
	
	negate := aBool ifTrue: ['NOT '] ifFalse: [''].

	sql := self sqsCustomSqlToScopeToCollection.
	nextQuery := self sqsQueryForCollectionScoping: aBlock.
	
	referencedColumn simpleValues ifTrue: [
		self addToWhereBuffer: ('AND ',negate,'(', sql, nextQuery whereBuffer,')').
	] ifFalse: [
		self addToWhereBuffer: ('AND (', sql, ') AND ',negate,'(', nextQuery whereBuffer,')').
	].! !

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'test 2/2/2009 14:23'!
sqsCustomSqlToScopeToCollection

	| valueField joinTable suffix refClass sql refTable refSuffix |
	valueField := (SqsClassInfo for: self query previousQueryObject depictedClass) configuration collectionConfiguration valueField.
	joinTable := self sqsReferencedColumn tableName.
	suffix := self query aliasSuffixForTableOfClass: Collection.

	refClass := Smalltalk at: referencedColumn referencedClass.	
	referencedColumn simpleValues ifTrue: [
		sql := '', joinTable, suffix, '.', valueField.
	] ifFalse: [
		sql := '', joinTable, suffix, '.', valueField, ' = '.
		refTable := (SqsClassInfo for: refClass) tableName.
		refSuffix := query newAliasSuffixForTableOfClass: refClass.
		query queryTables add: (SqsQueryTable table: (SqsClassInfo for: refClass) classTable alias: refSuffix field: nil class: refClass ignoreValues: true ).
		sql := sql, (refTable, refSuffix, '.', (SqsClassInfo for: refClass) configuration tableConfiguration idField).
	].
	^ sql
! !

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'test 2/2/2009 14:20'!
sqsQueryForCollectionScoping: aBlock
	
	| refClass nextQuery |
	refClass := Smalltalk at: referencedColumn referencedClass.
	nextQuery := SqsQuery new
		queryLevel: query queryLevel;
		queryClass: refClass;
		yourself.
	nextQuery analyze: aBlock.
	^ nextQuery! !

SqsQueryValue subclass: #SqsQueryDate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryDate methodsFor: 'accessing' stamp: 'wh 8/16/2006 20:12'!
day
	^self dayOfYear.! !

!SqsQueryDate methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:12'!
dayOfMonth
^(self newForType: Integer)  whereBuffer: 
			'DAY(',self encapsulatedWhere,')'.! !

!SqsQueryDate methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:11'!
dayOfWeek
^(self newForType: Integer)  whereBuffer: 
			'DAYOFWEEK(',self encapsulatedWhere,')'.! !

!SqsQueryDate methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:11'!
dayOfYear
^(self newForType: Integer)  whereBuffer: 
			'DAYOFYEAR(',self encapsulatedWhere,')'.! !

!SqsQueryDate methodsFor: 'smalltalk-80' stamp: 'wh 8/16/2006 20:11'!
monthIndex
^(self newForType: Integer)  whereBuffer: 
			'MONTH(',self encapsulatedWhere,')'.! !

!SqsQueryDate methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:10'!
monthName
^(self newForType: Integer)  whereBuffer: 
			'MONTHNAME(',self encapsulatedWhere,')'.! !

!SqsQueryDate methodsFor: 'accessing' stamp: 'wh 8/16/2006 20:10'!
year
^(self newForType: Integer)  whereBuffer: 
			'YEAR(',self encapsulatedWhere,')'.! !

SqsQueryDate subclass: #SqsQueryDateTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryDateTime methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:12'!
hour
^(self newForType: Integer)  whereBuffer: 
			'HOUR(',self encapsulatedWhere,')'.! !

!SqsQueryDateTime methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:12'!
hour24
	^self hour.! !

!SqsQueryDateTime methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:13'!
minute
^(self newForType: Integer)  whereBuffer: 
			'MINUTE(',self encapsulatedWhere,')'.! !

!SqsQueryDateTime methodsFor: 'accessing' stamp: 'wh 8/16/2006 20:13'!
second
^(self newForType: Integer)  whereBuffer: 
			'SECOND(',self encapsulatedWhere,')'.! !

SqsQueryValue subclass: #SqsQueryNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:36'!
* aNumber
	^self mathWith: aNumber doOperator: '*'.! !

!SqsQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:35'!
+ aNumber
	^self mathWith: aNumber doOperator: '+'.! !

!SqsQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:35'!
- aNumber
	^self mathWith: aNumber doOperator: '-'.! !

!SqsQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:36'!
/ aNumber
	^self mathWith: aNumber doOperator: '/'.! !

!SqsQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:08'!
\\ anAttrib
	^self mathWith: anAttrib doOperator: '%'.! !

!SqsQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:05'!
abs
^(self newForType: Integer) whereBuffer: 
			'ABS(',self encapsulatedWhere,')'.! !

!SqsQueryNumber methodsFor: 'mathematical functions' stamp: 'wh 8/16/2006 20:05'!
arcCos
^(self newForType: Integer) whereBuffer: 
			'ACOS(',self encapsulatedWhere,')'.! !

!SqsQueryNumber methodsFor: 'mathematical functions' stamp: 'wh 8/16/2006 20:05'!
arcSin
^(self newForType: Integer)  whereBuffer: 
			'ASIN(',self encapsulatedWhere,')'.! !

!SqsQueryNumber methodsFor: 'mathematical functions' stamp: 'wh 8/16/2006 20:06'!
arcTan
^(self newForType: Integer)  whereBuffer: 
			'ATAN(',self encapsulatedWhere,')'.! !

!SqsQueryNumber methodsFor: 'mathematical functions' stamp: 'wh 8/16/2006 20:06'!
cos
^(self newForType: Integer)  whereBuffer: 
			'COS(',self encapsulatedWhere,')'.! !

!SqsQueryNumber methodsFor: 'as yet unclassified' stamp: 'wh 8/16/2006 20:29'!
mathWith: anAttrib doOperator: anOperator
	^self operator: anOperator returnType: Integer attribute: anAttrib! !

!SqsQueryNumber methodsFor: 'mathematical functions' stamp: 'wh 8/16/2006 20:06'!
sin
^(self newForType: Integer)  whereBuffer: 
			'SIN(',self encapsulatedWhere,')'.! !

!SqsQueryNumber methodsFor: 'mathematical functions' stamp: 'wh 8/16/2006 20:07'!
tan
^(self newForType: Integer ) new whereBuffer: 
			'TAN(',self encapsulatedWhere,')'.! !

SqsQueryValue subclass: #SqsQueryObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryObject methodsFor: 'error handling' stamp: 'test 1/26/2009 16:06'!
doesNotUnderstand: aMessage 
	| col nextObject |
	aMessage arguments size < 1 ifTrue: [ 
		col := (SqsClassInfo for: self depictedClass) descriptionHandler sqsDescriptionForInstVar: aMessage selector asString.
		col ifNotNil: [ 
			nextObject := col describesCollection ifTrue: [
				self sqsNextQueryCollection: col 
			] ifFalse: [
				self sqsNextQueryObject: col
			].
			nextObject sqsReferencedColumn: col.
			^ nextObject
		] 
	].
	super doesNotUnderstand: aMessage! !

!SqsQueryObject methodsFor: 'as yet unclassified' stamp: 'test 1/29/2009 17:43'!
oid
	"object id has to be overridden, because the objectID for the queryProxies surely
	won't be found anywhere in our caches'"
	| tableName aliasSuffix aliasedTableName classInfo |
	classInfo := SqsClassInfo for: self depictedClass.
	tableName := classInfo classTable baseTable tableName.
	aliasSuffix := self query aliasSuffixForTableOfClass: self depictedClass.
	aliasedTableName := tableName , aliasSuffix.
	self whereBuffer: self whereBuffer , aliasedTableName , '.' , classInfo configuration tableConfiguration idField! !

!SqsQueryObject methodsFor: 'as yet unclassified' stamp: 'tkow 1/16/2009 17:56'!
perform: aSymbol
	^(aSymbol = SqsSearch searchForIdField) ifTrue: [
		self oid	
	] ifFalse: [
		self doesNotUnderstand: (Message selector: aSymbol)
	]
	! !

!SqsQueryObject methodsFor: 'error handling' stamp: 'tkow 10/21/2008 18:44'!
sqsFindColumnFor: instVarName inTable: table
	| column |
	column := table columns detect: [:col |
		col linkedVariable = instVarName asString
	] ifNone: [nil].
	column ifNil: [
		table children do: [:childTable |
			column ifNil: [
				column := self sqsFindColumnFor: instVarName inTable: childTable. 	
			]	
		]	
	].
	^column
	
	! !

!SqsQueryObject methodsFor: 'error handling' stamp: 'tkow 12/12/2008 17:38'!
sqsFindColumnForMessage: aMessage 
	| table column |
	table := (SqsClassInfo for: self depictedClass) classTable baseTable.
	column := self 
		sqsFindColumnFor: aMessage selector
		inTable: table.
	^ column! !

!SqsQueryObject methodsFor: 'error handling' stamp: 'test 1/29/2009 19:04'!
sqsJoin: tableName withSuffix: aSuffix onColumn: column 
	| curTableName oidField |
	curTableName := tableName , aSuffix.
	oidField := (SqsClassInfo for: self depictedClass) configuration tableConfiguration idField.
	"if we perform operations on objects that return objects themselves, we first need to scope
	back to the table where that new value resides"
	self addToWhereBuffer: '= ' , curTableName , '.' , oidField.
	self whereBuffer: self encapsulatedWhere , ' AND '.
	"those tables simply have to added to the query tables, and need no links to other tables"
	self query queryTables add: (SqsQueryTable 
			table: (SqsClassInfo for: self depictedClass) cachedClassTable
			alias: aSuffix
			field: column columnName
			class: self depictedClass)! !

!SqsQueryObject methodsFor: 'error handling' stamp: 'test 1/29/2009 18:45'!
sqsJoinTablesForCollection: collectionDescription
	| suffix curTableName baseClass curSuffix idField |
	
	baseClass := (SqsClassInfo for: self depictedClass) baseClass.

	idField := (SqsClassInfo for: self depictedClass) configuration tableConfiguration idField.	
	self query previousQueryObject class = SqsQueryObject ifTrue: [
		suffix := (self query newAliasSuffixForTableOfClass: self depictedClass).
		self 
			sqsJoin: self sqsReferencedColumn tableName
			withSuffix: suffix
			onColumn: self sqsReferencedColumn.
		curTableName := collectionDescription ownerColumn foreignKey referencedTable.
		self whereBuffer: self whereBuffer, curTableName, suffix, '.', idField , ' '.
		
	] ifFalse: [
		curTableName := collectionDescription ownerColumn foreignKey referencedTable.
		curSuffix := self query aliasSuffixForTableOfClass: baseClass.
		self whereBuffer: self whereBuffer, curTableName, curSuffix, '.', idField, ' '.
	].! !

!SqsQueryObject methodsFor: 'error handling' stamp: 'test 1/29/2009 17:43'!
sqsNextQueryCollection: collectionDescription
	| nextQueryClass nextQuery joinTableSuffix joinTableIdField joinTableName |
	nextQueryClass := SqsQuery classForType: Collection.
	joinTableSuffix := self query aliasSuffixForTableOfClass: Collection.
	joinTableName := collectionDescription tableName, joinTableSuffix.
	joinTableIdField := collectionDescription ownerColumn columnName.
	
	self query queryTables add: (SqsQueryTable 
		table: ((SqsClassInfo for: self depictedClass) tableStructureHandler joinTableForDescription: collectionDescription)
		alias:  joinTableSuffix
		field:  collectionDescription linkedVariable asString 
		class:  (self depictedClass)
		ignoreValues: true).
		
	self query distinct: true.
	self sqsJoinTablesForCollection: collectionDescription.

	nextQuery := self query newForType: Collection.
	self whereBuffer: self whereBuffer ,' = ', joinTableName , '.' , joinTableIdField.	
	nextQuery whereBuffer: self whereBuffer.
	^ nextQuery! !

!SqsQueryObject methodsFor: 'error handling' stamp: 'test 1/30/2009 15:39'!
sqsNextQueryObject: column 
	| nextType nextQueryClass curTableName nextQuery baseClass suffix |

	nextType := Smalltalk at: column objectClass.
	nextQueryClass := SqsQuery classForType: nextType.
	baseClass := (SqsClassInfo for: depictedClass) baseClass.

	self query previousQueryObject class = SqsQueryObject ifTrue: [ 
		suffix := query newAliasSuffixForTableOfClass: baseClass.
		self 
			sqsJoin: column tableName
			withSuffix: suffix
			onColumn: column.
	] ifFalse: [
		suffix := query aliasSuffixForTableOfClass: baseClass.
	].

	curTableName := column tableName , suffix.
	self whereBuffer: whereBuffer , curTableName , '.' , column columnName.
	nextQuery := self query newForType: nextType.
	nextQuery whereBuffer: whereBuffer.
	^ nextQuery! !

SqsQueryValue subclass: #SqsQueryString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryString methodsFor: 'copying' stamp: 'wh 8/16/2006 19:24'!
, aString
	" The standard is || yet MySQL used CONCAT 
		Impliment the standard here "
	^(self newForType: String) whereBuffer: 
			self encapsulatedWhere,' || ',aString asSqlValueString.! !

!SqsQueryString methodsFor: 'comparing' stamp: 'wh 9/14/2006 14:04'!
beginsWith: aString
	
	^(query newForType: Boolean) whereBuffer: 
			(self encapsulatedWhere),' LIKE "',aString asEscapedSql,'%"'.! !

!SqsQueryString methodsFor: 'comparing' stamp: 'wh 8/16/2006 19:21'!
endsWith: aString
	^(self newForType: Boolean) whereBuffer: 
			self whereBuffer,' LIKE ''%',aString asEscapedSql,''''.! !

!SqsQueryString methodsFor: 'accessing' stamp: 'wh 8/16/2006 19:22'!
size
	"Postgres and MySQL handle this the same way "
	^(self newForType: 'integer') whereBuffer: 
			'CHAR_LENGTH(',self whereBuffer,')'.! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
< anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: '<'! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
<= anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: '<='! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
= anAttrib 
	anAttrib ifNil: 
		[ ^ self 
			booleanCompair: anAttrib
			with: 'IS' ].
	^ self 
		booleanCompair: anAttrib
		with: '='! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
> anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: '>'! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
>= anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: '>='! !

!SqsQueryValue methodsFor: 'as yet unclassified' stamp: 'wh 8/15/2006 09:59'!
addToWhereBuffer: aString
	
	self whereBuffer: (whereBuffer, ' ', aString).! !

!SqsQueryValue methodsFor: 'converting' stamp: 'wh 8/16/2006 20:52'!
asSqlValueString
	^self encapsulatedWhere.! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'wh 8/16/2006 20:50'!
asString
	^whereBuffer.! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
booleanCompair: anAttrib with: aDbOperator 
	^ self 
		operator: aDbOperator
		returnType: Boolean
		attribute: anAttrib! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'tkow 11/2/2008 21:55'!
depictedClass
	^ depictedClass! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'tkow 11/2/2008 21:55'!
depictedClass: anObject
	depictedClass := anObject! !

!SqsQueryValue methodsFor: 'as yet unclassified' stamp: 'wh 8/16/2006 20:32'!
encapsulatedWhere
	whereBuffer size > 0 ifTrue:[
		^'(',whereBuffer,')'.
	] ifFalse:[
		^''.
	].! !

!SqsQueryValue methodsFor: 'testing' stamp: 'wh 8/15/2006 10:38'!
isNil
	self addToWhereBuffer: 'IS NULL'.! !

!SqsQueryValue methodsFor: 'testing' stamp: 'wh 8/15/2006 10:38'!
notNil
	self addToWhereBuffer: 'IS NOT NULL'.! !

!SqsQueryValue methodsFor: 'as yet unclassified' stamp: 'test 2/2/2009 14:29'!
operator: aChar returnType: aType attribute: anAttrib
	| comp objScoping |

	objScoping := self sqsScopeToObjectIdField.
	
	comp := (anAttrib class includesBehavior: SqsQueryValue) ifTrue: [
		anAttrib whereBuffer	
	] ifFalse: [
		(anAttrib respondsTo: #asSqlValueString) ifTrue: [
			anAttrib asSqlValueString		
		] ifFalse: [
			anAttrib oid asSqlValueString
		]	
	].
	
	^(query newForType: aType) whereBuffer:
			whereBuffer,objScoping,' ',aChar,' ',comp.
	! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:41'!
query
	^query! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'tkow 10/14/2008 10:12'!
query: aQuery
	query := aQuery.
	query currentQueryObject: self.
	self whereBuffer: ''.! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'test 1/26/2009 16:05'!
sqsReferencedColumn
	^ referencedColumn! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'test 1/26/2009 16:05'!
sqsReferencedColumn: anObject
	referencedColumn := anObject! !

!SqsQueryValue methodsFor: 'as yet unclassified' stamp: 'test 2/2/2009 14:38'!
sqsScopeToObjectIdField
	| ci |
	^(query previousQueryObject ifNil: [
		ci := SqsClassInfo for: depictedClass.
		((depictedClass respondsTo: #sqsType) or: [whereBuffer notEmpty]) ifTrue: [
			''
		] ifFalse: [
			ci tableName, (query aliasSuffixForTableOfClass: depictedClass), '.', ci configuration tableConfiguration idField.
		]
	] ifNotNil: [''])! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:57'!
whereBuffer 
	^whereBuffer.
! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:57'!
whereBuffer: aString
	whereBuffer _ aString.! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
~= anAttrib 
	anAttrib ifNil: 
		[ ^ self 
			booleanCompair: anAttrib
			with: 'IS NOT' ].
	^ self 
		booleanCompair: anAttrib
		with: '<>'! !

!Class class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:22'!
sqsType
	^#string! !

!Class methodsFor: '*sqsave' stamp: 'wh 9/5/2006 10:58'!
asSqlValueString
	^'''',self name asString asEscapedSql,''''.! !

!LargePositiveInteger class methodsFor: '*sqsave' stamp: 'tkow 1/19/2009 17:49'!
fromSqlValue: anObject
	^ anObject asString asInteger! !

!LargePositiveInteger class methodsFor: '*sqsave' stamp: 'tkow 11/11/2008 03:14'!
sqsType
	^#largeInteger! !

!LargePositiveInteger methodsFor: '*sqsave' stamp: 'tkow 11/11/2008 13:24'!
asSqlValueString
	^'''', self asString, ''''! !

TestCase subclass: #SqsTestCase
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqsTestCase subclass: #SqsBaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsBaseTest methodsFor: 'private' stamp: 'tkow 1/19/2009 15:06'!
setUp
	super setUp.
	self setupTestConnection.
	self clearDatabase.
	self removeDescriptions.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testGetDirectlyReferencedObjects
	| testObject testObject2 directlyReferencedObjects base |
	self removeDescriptions.
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject2 := SqsTestObject new.
	testObject testInteger: 4.
	testObject testSomething: testObject2.
	base := SqsStorage for: testObject.
	base descriptionHandler createDescriptions.
	directlyReferencedObjects := base directlyReferencedObjects.
	self assert: directlyReferencedObjects size == 1.
	self assert: directlyReferencedObjects first == testObject2! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 1/18/2009 17:07'!
testGetIndirectlyReferencedObjects
	| testObject testObject2 indirectlyReferencedObjects base |
	self removeDescriptions.
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject2 := SqsTestObject new.
	testObject testInteger: 4.
	testObject testSomething: (OrderedCollection with: testObject2).
	base := SqsStorage for: testObject.
	base descriptionHandler createDescriptions.
	indirectlyReferencedObjects := base indirectlyReferencedObjects.
	self assert: indirectlyReferencedObjects size == 1.
	self assert: indirectlyReferencedObjects first collection first == testObject2.
	self assert: indirectlyReferencedObjects first collectionDescription class = SqsCollectionDescription! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 1/19/2009 17:34'!
testIsDirtyFlag

	| testObject2 testObject |
	testObject2 := SqsTestObjectChild new
		testSubString: 'test';
		testBool: true;
		yourself.

	testObject := SqsTestObject new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: testObject2;
		yourself.
		
	testObject save.
	
	self assert: (SqsStorage for: testObject) isDirty not.
	testObject2 testInteger: 42.
	self assert: (SqsStorage for: testObject2) isDirty.
	self assert: (SqsStorage for: testObject) isDirty not.
	testObject testBool: true.
	self assert: (SqsStorage for: testObject) isDirty.
	testObject save.
	self assert: (SqsStorage for: testObject) isDirty not.! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 12/15/2008 12:53'!
testNewRecordAttribute
	| obj obj2 oid |
	SqsStorage flushObjectCache.
	obj := SqsTestObject new.
	obj testInteger: 42.
	self assert: (SqsStorage oidFor: obj) isNil.
	obj save.
	self assert: (SqsStorage oidFor: obj) isNil not.
	oid := SqsStorage oidFor: obj.
	self assert: (SqsStorage 
			cachedObjectOfClass: SqsTestObject
			withOid: oid) == obj.
	obj2 := SqsTestObject findByTestInteger: 42.
	self assert: (SqsStorage oidFor: obj2) isNil not! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testObjectIdAssignment
	| testObject testObject2 |
	self clearDatabase.
	testObject := SqsTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: testObject oid == 1.
	testObject2 := SqsTestObject new.
	testObject2 testInteger: 4.
	testObject2 save.
	self assert: testObject2 oid == 2! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testPersistenceDescriptorCreationOnSave
	| testObject description targetClass |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqsTestObject new.
	testObject
		testDate: Date today;
		testInteger: 42;
		testString: 'calculon';
		testSomething: SqsTestObject new.
	testObject save.
	targetClass := (SqsClassInfo for: SqsTestObject) descriptionHandler targetClass.
	self 
		shouldnt: 
			[ description := targetClass perform: 'TestInteger' asSqSaveDescriptionSelector ]
		raise: [ Error ].
	self assert: description class = SqsColumn.
	self assert: description sqlType = #integer.
	self assert: description columnName = 'test_integer'.
	self assert: description associatedClass isNil.
	self assert: description linkedVariable = 'testInteger'! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testPersistenceDescriptorCreationOnSaveHappensOnlyInTheClassesDefiningTheVariable
	| testObject targetClass1 targetClass2 targetClass3 |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject testSubString: 'test'.
	testObject testExtremelyDeepSubString: 'test'.
	testObject save.
	targetClass1 := (SqsClassInfo for: SqsTestObject) descriptionHandler targetClass.
	targetClass2 := (SqsClassInfo for: SqsTestObjectChild) descriptionHandler targetClass.
	targetClass3 := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) descriptionHandler targetClass.
	self assert: (targetClass1 class includesSelector: 'testDate' asSqSaveDescriptionSelector).
	self assert: (targetClass1 class includesSelector: 'testInteger' asSqSaveDescriptionSelector).
	self assert: (targetClass1 class includesSelector: 'testString' asSqSaveDescriptionSelector).
	self assert: (targetClass1 class includesSelector: 'testSomething' asSqSaveDescriptionSelector) not.
	self assert: (targetClass2 class includesSelector: 'testSubString' asSqSaveDescriptionSelector).
	self assert: (targetClass3 class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector).
	self assert: (targetClass1 class includesSelector: 'testSubString' asSqSaveDescriptionSelector) not.
	self assert: (targetClass1 class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector) not! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testTableCreationOnSave
	| testObject |
	self clearDatabase.
	testObject := SqsTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	self assert: (SqsStorage for: testObject) tableForClassExists not.
	testObject save.
	self assert: (SqsStorage for: testObject) tableForClassExists! !

SqsTestCase subclass: #SqsCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqsCollectionTest subclass: #SqsCTICollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsCTICollectionTest methodsFor: 'private' stamp: 'tkow 12/12/2008 17:44'!
setUp
	super setUp.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance! !

!SqsCollectionTest class methodsFor: 'as yet unclassified' stamp: 'tkow 12/1/2008 13:01'!
shouldInheritSelectors
	^ true! !

!SqsCollectionTest methodsFor: 'private' stamp: 'tkow 1/19/2009 15:05'!
setUp
	super setUp.
	self setupTestConnection.
	self clearDatabase.
	self removeDescriptions.! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testCollectionAdding
	| testObject2 testObject1 testResult testObject3 testResult2 t2Oid t3Oid |
	testObject2 := SqsTestObject new
		testInteger: 42;
		yourself.
	"this should also lead to a removal of the testSomething column...."
	testObject1 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
	testObject1 save.
	t2Oid := testObject2 oid.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething class includesBehavior: SqsProxy).
	self assert: (testResult testSomething at: 1) oid = t2Oid.
	testObject3 := SqsTestObject new
		testInteger: 84;
		yourself.
	testResult testSomething add: testObject3.
	testResult save.
	t3Oid := testObject3 oid.
	self assert: testObject3 oid notNil.
	self assert: (testResult testSomething at: 2) = testObject3.
	testResult := nil.
	SqsStorage flushObjectCache.
	testResult2 := SqsTestObject findByTestInteger: 21.
	self assert: testResult2 isNil not.
	self assert: testResult2 testSomething isCollection.
	self assert: (testResult2 testSomething class includesBehavior: SqsProxy).
	self assert: (testResult2 testSomething at: 1) oid = t2Oid.
	self 
		shouldnt: [ testResult2 testSomething at: 2 ]
		raise: Error.
	self assert: (testResult2 testSomething at: 2) oid = t3Oid! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testCollectionAddingSimpleObjects
	| testObject1 testResult testResult2 collection |
	collection := OrderedCollection 
		with: 21
		with: 42
		with: 84.
	testObject1 := SqsTestObject new
		testInteger: 21;
		testSomething: collection;
		yourself.
	testObject1 save.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething at: 1) = 21.
	testResult testSomething add: 168.
	testResult save.
	testResult := nil.
	SqsStorage flushObjectCache.
	testResult2 := SqsTestObject findByTestInteger: 21.
	self assert: testResult2 isNil not.
	self assert: testResult2 testSomething isCollection.
	self assert: (testResult2 testSomething at: 1) = 21.
	self 
		shouldnt: [ testResult2 testSomething at: 4 ]
		raise: Error.
	self assert: (testResult2 testSomething at: 4) = 168! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testCollectionIsProxyAfterSaving
	| testObject2 testObject1 |
	testObject2 := SqsTestObject new
		testInteger: 42;
		yourself.
	testObject1 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
	testObject1 save.
	self assert: (testObject1 testSomething class includesBehavior: SqsProxy)! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testCollectionRemoving
	| testObject2 testObject1 testResult testObject3 |
	testObject2 := SqsTestObject new
		testInteger: 42;
		yourself.
	testObject1 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
	testObject3 := SqsTestObject new
		testInteger: 42;
		yourself.
	testObject1 testSomething add: testObject3.
	testObject1 save.
	testObject1 testSomething removeAt: 2.
	testObject1 save.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething at: 1) = testObject2.
	self 
		should: [ testResult testSomething at: 2 ]
		raise: Error! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testCollectionShuffling
	| testObject2 testObject1 testResult testObject3 testResult2 t2Oid t3Oid |
	testObject2 := SqsTestObject new testInteger: 42.
	testObject1 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2).
	testObject3 := SqsTestObject new testInteger: 42.
	testObject1 testSomething add: testObject3.
	testObject1 save.
	t2Oid := testObject2 oid.
	t3Oid := testObject3 oid.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult notNil.
	self assert: testResult testSomething notNil.
	testResult testSomething: testResult testSomething reversed.
	testResult save.
	testResult := nil.
	SqsStorage flushObjectCache.
	testResult2 := SqsTestObject findByTestInteger: 21.
	self assert: testResult2 testSomething isCollection.
	self assert: (testResult2 testSomething at: 1) oid = t3Oid.
	self assert: (testResult2 testSomething at: 2) oid = t2Oid! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testCollectionWithSimpleValues
	| testCollection testObject testResult |
	testCollection := Set 
		with: 42
		with: 21
		with: 84.
	testObject := SqsTestObject new
		testInteger: 42;
		testString: 'fortyTwo';
		testSomething: testCollection.
	testObject save.
	testObject := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 42.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething includes: 21).
	self assert: (testResult testSomething includes: 42).
	self assert: (testResult testSomething includes: 84)! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'test 1/26/2009 14:45'!
testDescriptionCreation
	| testObject testObject2 description referenceColumn ownerColumn base targetClass |
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject2 := SqsTestObject new.
	testObject testInteger: 4.
	testObject testSomething: (OrderedCollection with: testObject2).
	base := SqsStorage for: testObject.
	base descriptionHandler createDescriptions.
	targetClass := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) descriptionHandler targetClass.
	self 
		shouldnt: 
			[ description := targetClass perform: 'testSomething' asSqSaveDescriptionSelector ]
		raise: Error.
	self assert: description isNil not.
	self assert: description describesCollection.
	self assert: description tableName = 'sqs_test_objects_test_something'.
	referenceColumn := description referenceColumn.
	self assert: referenceColumn columnName = 'value'.
	self assert: description referenceTableName = 'sqs_test_objects'.
	ownerColumn := description ownerColumn.
	self assert: ownerColumn columnName = 'sqs_test_object_id'! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testDictionaryCreation
	| testObject1 testObject2 testResult testDictionary |
	testObject1 := SqsTestObjectEvenDeeperChild new
		testString: 'test1';
		testSomething: Dictionary new.
	testObject2 := SqsTestObjectChild new testString: 'test2'.
	testObject1 testSomething 
		at: #test
		put: testObject2.
	testObject1 save.
	testObject1 := nil.
	testResult := SqsTestObject findByTestString: 'test1'.
	self assert: testResult isNil not.
	testDictionary := testResult testSomething.
	self assert: testDictionary isDictionary.
	self assert: (testDictionary at: #test) = testObject2! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testLazyCollectionCreation
	| testObject2 testObject1 testResult |
	testObject2 := SqsTestObject new
		testInteger: 42;
		yourself.
	"this should also lead to a removal of the testSomething column...."
	testObject1 := SqsTestObject new
		testInteger: 21;
		yourself.
	testObject1 save.
	testObject1 testSomething: (OrderedCollection with: testObject2).
	testObject1 save.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult notNil.
	self assert: testResult testSomething notNil.
	self assert: (testResult testSomething at: 1) = testObject2! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testNilObjectsInCollections
	| testObject2 testObject1 testResult testObject3 |
	testObject2 := SqsTestObject new
		testInteger: 42;
		yourself.
	testObject1 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
	testObject3 := SqsTestObject new
		testInteger: 42;
		yourself.
	testObject1 testSomething add: nil.
	testObject1 testSomething add: nil.
	testObject1 testSomething add: testObject3.
	testObject1 testSomething add: nil.
	testObject1 save.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething at: 1) = testObject2.
	self 
		shouldnt: [ testResult testSomething at: 4 ]
		raise: Error.
	self assert: testResult testSomething size = 5.
	self assert: (testResult testSomething at: 2) isNil! !

SqsCollectionTest subclass: #SqsSTICollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsSTICollectionTest methodsFor: 'private' stamp: 'tkow 12/12/2008 17:44'!
setUp
	super setUp.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance! !

SqsTestCase subclass: #SqsColumnTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsColumnTest methodsFor: 'tests' stamp: 'test 1/27/2009 11:29'!
testCreationCode
	| column column2 |
	column := SqsColumn new.
	column columnName: 'testColumn'.
	column sqlType: #integer.
	column2 := Compiler evaluate: column codeForObjectCreation.
	self assert: column2 class = SqsColumn.
	self assert: column2 sqlType = #integer.
	self assert: column2 columnName = 'testColumn'! !

!SqsColumnTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:40'!
testCustomEquals
	| column1 column2 |
	column1 := SqsColumn new.
	column1 columnName: 'testColumn'.
	column1 sqlType: #integer.
	column2 := SqsColumn new.
	column2 columnName: 'testColumn'.
	column2 sqlType: #integer.
	self assert: column1 = column2! !

SqsTestCase subclass: #SqsConnectionManagerTest
	instanceVariableNames: 'connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsConnectionManagerTest methodsFor: 'running' stamp: 'tkow 10/27/2008 17:27'!
setUp
	connections := OrderedCollection new.! !

!SqsConnectionManagerTest methodsFor: 'running' stamp: 'tkow 12/12/2008 17:38'!
tearDown
	SqsConnectionManager getInstance closeAllConnections! !

!SqsConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 12/13/2008 10:24'!
testAdapterLimitiationToThreads
	| cSpec manager session1 session2 session3 |
	cSpec := self standardConnectionSpecification.
	manager := SqsConnectionManager getInstance.
	session1 := manager sessionForConSpec: cSpec.
	session2 := manager sessionForConSpec: cSpec.
	self assert: session1 == session2.
	[ session3 := manager sessionForConSpec: cSpec ] fork.

	"kind of dirty...why is there now join, or waitFor for Process?"
	(Delay forMilliseconds: 2000) wait.
	self assert: session3 notNil.
	self assert: session3 ~= session1! !

!SqsConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 12/13/2008 11:17'!
testAddConnectionSpecification
	| conManager testSession |
	conManager := SqsConnectionManager getInstance.
	conManager conSpecDictionary: Dictionary new.
	conManager 
		setConSpec: self standardConnectionSpecification
		for: self standardCategory.
	self assert: (conManager conSpecDictionary includesKey: self standardCategory).
	self assert: (conManager conSpecDictionary at: self standardCategory) class == SqsConnectionSpecification.
	testSession := conManager sessionForCategory: self standardCategory.
	self assert: testSession notNil.
	self assert: testSession sqsDbAdapter notNil.
	self assert: testSession connectionIdentityString = self standardConnectionSpecification connectionIdentityString! !

!SqsConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 12/13/2008 10:33'!
testConnectionCounting
	| conSpec conManager |
	conSpec := self standardConnectionSpecification.
	conSpec maxConnections: 10.
	conManager := SqsConnectionManager getInstance.
	conManager 
		setConSpec: conSpec
		for: 'Test-Category'.
	1 
		to: 10
		do: 
			[ :i | 
			connections add: (conManager getConnectionFor: conSpec).
			self assert: connections last class = SqsMySqlConnection ].
	self 
		should: [ conManager getConnectionFor: conSpec ]
		takeMoreThanMilliseconds: 2000.
	conManager 
		releaseConnection: connections removeFirst
		for: conSpec.
	self 
		should: [ conManager getConnectionFor: conSpec ]
		notTakeMoreThanMilliseconds: 2000.
	connections do: 
		[ :con | 
		conManager 
			releaseConnection: con
			for: conSpec ]! !

!SqsConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 12/13/2008 10:33'!
testConnectionFreeing
	| conSpec conManager adapter queue oldQueueSize |
	conSpec := self standardConnectionSpecification.
	conManager := SqsConnectionManager getInstance.
	conManager 
		setConSpec: conSpec
		for: 'Test'.
	adapter := (conManager sessionForCategory: 'Test') sqsDbAdapter.
	queue := conManager connectionPool 
		at: conSpec connectionIdentityString
		ifAbsentPut: [ SharedQueue2 new ].
	oldQueueSize := queue size.
	self assert: ((adapter checkTableExistance: 'testtable') class includesBehavior: Boolean).
	oldQueueSize = 0 
		ifTrue: [ self assert: queue size = 1 ]
		ifFalse: [ self assert: queue size = oldQueueSize ]! !

SqsTestCase subclass: #SqsConnectionSpecificationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsConnectionSpecificationTest methodsFor: 'as yet unclassified' stamp: 'tkow 12/13/2008 11:19'!
testConnectionIdentityString
	| testConSpec |
	testConSpec := SqsConnectionSpecification new
		database: 'testDb';
		username: 'testUser';
		port: '3306';
		password: 'test';
		hostname: 'localhost';
		driverClass: #SqsMysqlAdapter.
	self assert: testConSpec connectionIdentityString = 'SqsMysqlAdapter#testUser@localhost:3306/testDb'! !

SqsTestCase subclass: #SqsDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsDescriptionHandlerTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testCollectionCheck
	"a collection with simple values"
	| collection descriptionHandler |
	collection := OrderedCollection 
		with: 1
		with: 2
		with: 3.
	descriptionHandler := SqsDescriptionHandler new.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection) not.

	"a collection with simple values and nil"
	collection add: nil.
	descriptionHandler := SqsDescriptionHandler new.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection) not.

	"a collection with values from completely different classes"
	collection add: 'test'.
	self 
		should: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.

	"a collection with complex values"
	collection := OrderedCollection 
		with: SqsTestObject new
		with: SqsTestObjectChild new.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection).

	"a collection with complex values and nil values"
	collection add: nil.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection).

	"a collection with complex values and simple values"
	collection add: 42.
	self 
		should: [ descriptionHandler isComplexCollection: collection ]
		raise: Error! !

!SqsDescriptionHandlerTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:42'!
testDictionaryKeyRecognition
	| dictionary handler |
	dictionary := Dictionary new.
	dictionary 
		at: #test
		put: #test.
	dictionary 
		at: 'test2'
		put: #test2.
	handler := SqsDescriptionHandler new.
	self assert: (handler indexClassOfDictionary: dictionary) = ByteSymbol.
	dictionary := Dictionary new.
	dictionary 
		at: 432
		put: #test.
	dictionary 
		at: 41235
		put: #test2.
	handler := SqsDescriptionHandler new.
	self 
		shouldnt: [ handler indexClassOfDictionary: dictionary ]
		raise: Error.
	self assert: (handler indexClassOfDictionary: dictionary) = SmallInteger.
	dictionary := Dictionary new.
	dictionary 
		at: 432
		put: #test.
	dictionary 
		at: #test
		put: #test2.
	handler := SqsDescriptionHandler new.
	self 
		should: [ handler indexClassOfDictionary: dictionary ]
		raise: Error! !

!SqsDescriptionHandlerTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testSqlTypeRecognition
	| handler |
	handler := SqsDescriptionHandler new.
	self assert: (handler sqlTypeForObject: 42) = #integer.
	self assert: (handler sqlTypeForObject: SqsTestObject new) = #integer.
	self assert: (handler sqlTypeForObject: true) = #boolean! !

SqsTestCase subclass: #SqsDictionaryExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsDictionaryExtensionTests methodsFor: 'tests' stamp: 'tk 8/15/2008 14:49'!
testValueJoin
	| dict1 dict2 result |
	dict1 := Dictionary new.
	dict1 at: #test1 put: (OrderedCollection with: 42).
	dict1 at: #test2 put: 42.
	dict1 at: #test3 put: (OrderedCollection with: 84).
	
	dict2 := Dictionary new.
	dict2 at: #test1 put: (OrderedCollection with: 21).
	dict2 at: #test2 put: 21.
	
	result := dict1 valueJoin: dict2.
	self assert: ((result at: #test1) isCollection).
	self assert: ((result at: #test1) includes: (42)).
	self assert: ((result at: #test1) includes: (21)).

	self assert: ((result at: #test2) isCollection).
	self assert: ((result at: #test2) includes: (42)).
	self assert: ((result at: #test2) includes: (21)).

	self assert: ((result at: #test3) isCollection).
	self assert: ((result at: #test3) includes: (84)).
	! !

SqsTestCase subclass: #SqsDriverTest
	instanceVariableNames: 'adapter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsDriverTest methodsFor: 'running' stamp: 'tkow 12/12/2008 17:37'!
setUp
	adapter := SqsMysqlAdapter new! !

!SqsDriverTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:41'!
testQueryToCreateColumn
	| column sql referenceSql |
	SqsClassInfo clearInfoCache.
	column := SqsColumn new
		columnName: 'test_column';
		sqlType: #integer;
		canBeNull: false;
		foreignKey: (SqsForeignKeyDescription new
				referencedColumns: (OrderedCollection with: 'test_reference');
				referencedTable: 'test_table';
				deleteActions: #(#CASCADE )).
	sql := adapter queryToCreateColumn: column.
	referenceSql := 'test_column INTEGER NOT NULL, FOREIGN KEY (test_column) REFERENCES test_table(test_reference) ON DELETE CASCADE'.
	self assert: sql = referenceSql! !

!SqsDriverTest methodsFor: 'tests' stamp: 'tkow 12/13/2008 11:20'!
testTableCreation
	| testObject table sql referenceSql classInfo |
	self removeDescriptions.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance.
	testObject := SqsTestObjectChild new
		testInteger: 42;
		testSomething: 4.12;
		testString: 'test';
		testDate: Date today;
		testSubString: 'subString'.
	(SqsStorage for: testObject) createClassDescription.
	classInfo := SqsClassInfo for: SqsTestObject.
	table := classInfo classTable.
	sql := adapter queryToCreateTable: table.
	referenceSql := 'CREATE TABLE sqs_test_objects ('.
	referenceSql := referenceSql , ((table columns collect: [ :column | adapter queryToCreateColumn: column ]) join: ', ').
	referenceSql := referenceSql , ', PRIMARY KEY (' , classInfo configuration tableConfiguration idField , ')) ENGINE=INNODB'.
	self assert: sql = referenceSql! !

SqsTestCase subclass: #SqsInheritanceSensitiveTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqsInheritanceSensitiveTest subclass: #SqsClassTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsClassTableInheritanceTest methodsFor: 'running' stamp: 'tkow 12/12/2008 17:44'!
setUp
	super setUp.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance! !

!SqsClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/13/2008 11:44'!
testCascadingDelete
	| dbConnection testObject resultDicts oid query oidField |
	testObject := SqsTestObjectEvenDeeperChild new
		testString: 'Hello World';
		testInteger: 42;
		testSubString: 'SubString';
		testExtremelyDeepSubString: 'DeeperSubString'.
	testObject save.
	SqsStorage for: testObject.
	oid := testObject oid.
	testObject destroy.
	dbConnection := (SqsConnectionManager getInstance sessionForCategory: 'SqSave') sqsDbAdapter.
	oidField := (SqsClassInfo for: SqsTestObjectChild) configuration tableConfiguration idField.
	query := 'SELECT * FROM ' , SqsTestObjectChild name asSqSaveTableName.
	query := query , ' WHERE ' , oidField , ' = ' , oid asString.
	resultDicts := dbConnection executeQuery: query.
	self assert: resultDicts isEmpty.
	
	query := 'SELECT * FROM ' , SqsTestObjectEvenDeeperChild name asSqSaveTableName.
	query := query , ' WHERE ' , oidField , ' = ' , oid asString.
	resultDicts := dbConnection executeQuery: query.
	self assert: resultDicts isEmpty! !

!SqsClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testGetClassTableColumns
	self assert: (SqsClassInfo for: SqsTestObject) classTableColumns size = 5.
	self assert: (SqsClassInfo for: SqsTestObjectChild) classTableColumns size = 1.
	self assert: (SqsClassInfo for: SqsTestObjectEvenDeeperChild) classTableColumns size = 1! !

!SqsClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject
		testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 4.5243;
		testSubString: 'FortyTwo';
		testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.
	self assert: (SqsStorage for: SqsTestObject new) tableForClassExists.
	self assert: (SqsStorage for: SqsTestObjectChild new) tableForClassExists.
	self assert: (SqsStorage for: SqsTestObjectEvenDeeperChild new) tableForClassExists! !

!SqsClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testTableNames
	self assert: (SqsClassInfo for: SqsTestObject) tableName = SqsTestObject name asSqSaveTableName.
	self assert: (SqsClassInfo for: SqsTestObjectChild) tableName = SqsTestObjectChild name asSqSaveTableName.
	self assert: (SqsClassInfo for: SqsTestObjectEvenDeeperChild) tableName = SqsTestObjectEvenDeeperChild name asSqSaveTableName! !

!SqsClassTableInheritanceTest methodsFor: 'running' stamp: 'tkow 12/12/2008 17:55'!
testTableObjectChildren
	| testObject table1 table2 table3 |
	testObject := SqsTestObjectEvenDeeperChild new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: SqsTestObject new;
		testSubString: 'sub-string';
		testExtremelyDeepSubString: 'deep-sub-string'.
	(SqsStorage for: testObject) createClassDescription.
	table1 := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) classTable.
	table2 := (SqsClassInfo for: SqsTestObjectChild) classTable.
	table3 := (SqsClassInfo for: SqsTestObject) classTable.
	self assert: table1 allChildTables isEmpty.
	self assert: table2 allChildTables size = 1.
	self 
		assert: table2 allChildTables
		includes: table1.
	self assert: table3 allChildTables size = 2.
	self 
		assert: table3 allChildTables
		includes: table1! !

!SqsClassTableInheritanceTest methodsFor: 'running' stamp: 'tkow 12/12/2008 17:55'!
testTableObjectCreation
	| testObject table parent |
	testObject := SqsTestObjectEvenDeeperChild new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: SqsTestObject new;
		testSubString: 'sub-string';
		testExtremelyDeepSubString: 'deep-sub-string'.
	(SqsStorage for: testObject) createClassDescription.
	table := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) classTable.
	self assert: table tableName = SqsTestObjectEvenDeeperChild name asSqSaveTableName.
	self assert: table children isEmpty.
	self assert: table columns size = 2.
	self assert: table parent isNil not.
	parent := table parent.
	self assert: parent tableName = SqsTestObjectChild name asSqSaveTableName! !

!SqsInheritanceSensitiveTest class methodsFor: 'as yet unclassified' stamp: 'tk 7/1/2008 13:08'!
shouldInheritSelectors
	^true! !

!SqsInheritanceSensitiveTest methodsFor: 'running' stamp: 'test 12/13/2008 11:28'!
setUp
	self setupTestConnection.
	self clearDatabase.
	self removeDescriptions! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/13/2008 11:24'!
testCircularReferenceHandling
	| testObject1 testObject2 testResult1 testResult2 |
	
	testObject1 := SqsTestObject new testInteger: 42.
	testObject2 := SqsTestObject new
		testInteger: 21;
		testSomething: testObject1.
	testObject1 testSomething: testObject2.

	"why 3000? because when logging is on, this can take a while..."
	self 
		should: [ testObject1 save ]
		notTakeMoreThanMilliseconds: 3000.
	testObject1 := nil.
	testObject2 := nil.
	SqsStorage flushObjectCache.
	testResult1 := SqsTestObject findByTestInteger: 42.
	testResult2 := SqsTestObject findByTestInteger: 21.
	self assert: testResult1 oid isNil not.
	self assert: testResult2 oid isNil not.
	self assert: testResult2 testSomething oid = testResult1 oid.
	self assert: testResult1 testSomething oid = testResult2 oid! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testComplexCollectionStorage
	| testObject testObject2 testResult |
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject2 := SqsTestObject new.
	testObject testSomething: (OrderedCollection with: testObject2).
	testObject testInteger: 42.
	testObject save.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 42.
	self assert: testResult notNil.
	self assert: testObject = testResult.
	"we still are ahold of the object, thus no proxy will be created"
	self assert: testResult testSomething first = testObject2! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testCorrectObjectCreation
	| testObject1 testObject2 result |
	testObject1 := SqsTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	result := SqsTestObject findByTestInteger: 42.
	self assert: result class = SqsTestObject.
	testObject2 := SqsTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save.
	testObject2 := nil.
	SqsStorage flushObjectCache.
	result := SqsTestObject findByTestInteger: 21.
	self assert: result class = SqsTestObjectChild! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testDestroyObjects
	| testObject searchResult newSearchResult |
	testObject := SqsTestObjectEvenDeeperChild new
		testString: 'Hello World';
		testInteger: 42;
		testSubString: 'SubString';
		testExtremelyDeepSubString: 'DeeperSubString'.
	testObject save.
	SqsStorage flushObjectCache.
	searchResult := SqsTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: searchResult isNil not.
	searchResult destroy.
	SqsStorage flushObjectCache.
	newSearchResult := SqsTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: newSearchResult isNil! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testGetPersistedInstanceVariables
	| ivars1 ivars2 ivars3 |
	ivars1 := (SqsClassInfo for: SqsTestObject) persistedInstVars.
	ivars2 := (SqsClassInfo for: SqsTestObjectChild) persistedInstVars.
	ivars3 := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) persistedInstVars.
	self assert: ivars1 size = 5.
	self assert: ivars2 size = 6.
	self assert: ivars3 size = 7.
	self assert: (ivars3 includes: 'testUnstoredVariable') not! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testNamingBasedSearch
	| testObject searchResult1 searchResult2 searchResult3 searchResult0 |
	testObject := SqsTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	SqsStorage flushObjectCache.
	searchResult0 := SqsTestObject 
		findByTestInteger: 5
		andTestDate: Date today.
	SqsStorage flushObjectCache.
	searchResult1 := SqsTestObject findByTestInteger: 5.
	searchResult2 := SqsTestObject 
		findByTestDate: Date today
		andTestString: 'test'.
	SqsStorage flushObjectCache.
	searchResult3 := SqsTestObject findByTestString: 'test'.
	self assert: searchResult0 isNil not.
	self assert: searchResult0 testInteger = 5.
	self assert: searchResult0 testDate = Date today.
	self assert: searchResult0 testString = 'test'.
	self assert: testObject = searchResult1.
	self assert: testObject = searchResult2.
	self assert: testObject = searchResult3! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 1/19/2009 17:57'!
testObjectCompleteness
	| testObject testResult |
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject
		testInteger: 42;
		testString: 'fortyTwo';
		testDate: Date today;
		testSomething: 3;
		testSubString: 'twentyOne';
		testExtremelyDeepSubString: #elevenAndAHalf;
		testBool: true.
	testObject save.
	testObject := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: testResult isNil not.
	self assert: testResult testInteger = 42.
	self assert: testResult testString = 'fortyTwo'.
	self assert: testResult testDate = Date today.
	self assert: testResult testSomething = 3.
	self assert: testResult testSubString = 'twentyOne'.
	self assert: testResult testExtremelyDeepSubString = #elevenAndAHalf.
	self assert: testResult testBool = true! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testSaveRelatedObjectAlongWithObject
	| testObject testObject2 result base |
	testObject := SqsTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject2 := SqsTestObject new.
	testObject2 testInteger: 6.
	testObject2 testString: 'test2'.
	testObject testSomething: testObject2.
	base := SqsStorage for: testObject2.
	self assert: base newRecord.
	testObject save.
	self assert: base newRecord not.
	self assert: base oid isNil not.
	result := SqsTestObject findByTestInteger: 6.
	self assert: result == testObject2! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'test 1/22/2009 19:43'!
testSearchForCollections
	| results testObject1 |

	testObject1 := SqsTestObject new
		testInteger: 21;
		yourself.
	testObject1 save.

	10 timesRepeat: [
		SqsTestObject new
			testInteger: 42;
			testString: #helloWorld;
			testDate: Date today;
			testBool: true;
			testSomething: testObject1;
			save	
	].

	results := SqsTestObject findAllByTestInteger: 42.
	self assert: (results size = 10).
	results := SqsTestObject findAllByTestString: #helloWorld.
	self assert: (results size = 10).	
	results := SqsTestObject findAllByTestDate: Date today.
	self assert: (results size = 10).
	results := SqsTestObject findAllByTestBool: true.
	self assert: (results size = 10).		
	results := SqsTestObject findAllByTestSomething: testObject1.
	self assert: (results size = 10).

! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'test 1/22/2009 17:47'!
testSearchForMultipleArguments
	| results testObject1 testObject2 |

	testObject1 := SqsTestObject new
		testInteger: 42;
		testString: #hello;
		testDate: Date today;
		yourself.
		
	testObject1 save.
	
	testObject2 := SqsTestObject new
		testInteger: 42;
		testString: #world;
		testDate: Date today;
		testSomething: testObject1;
		yourself.
		
	testObject2 save.

	results := SqsTestObject findAllByTestInteger: 42 andTestString: #hello.
	self assert: (results size = 1).
	self assert: (results first = testObject1).
	
	results := SqsTestObject findAllByTestString: #world andTestInteger: 42.
	self assert: (results size = 1).	
	self assert: (results first = testObject2).
		
	results := SqsTestObject findAllByTestSomething: testObject1 andTestInteger: 42.
	self assert: (results size = 1).
	self assert: (results first = testObject2).
		
	results := SqsTestObject findAllByTestDate: Date today andTestInteger: 42.
	self assert: (results size = 2).	
! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testSearchRestrictionToClasses
	| testObject testResult oldOid testResult2 |
	testObject := SqsTestObject new.
	testObject
		testInteger: 42;
		testString: 'fortyTwo';
		testDate: Date today;
		testSomething: 3;
		testBool: true.
	testObject save.
	oldOid := testObject oid.
	testObject := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: testResult isNil.
	testResult2 := SqsTestObject findByTestInteger: 42.
	self assert: testResult2 notNil.
	self assert: testResult2 oid = oldOid! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testUpdate
	| testObject testResult |
	testObject := SqsTestObjectEvenDeeperChild new
		testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 3.14;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'deepSubString'.
	testObject save.
	testObject testString: 'newTest'.
	testObject save.
	testObject := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 42.
	self assert: testResult isNil not.
	self assert: testResult testString = 'newTest'! !

SqsInheritanceSensitiveTest subclass: #SqsSingleTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsSingleTableInheritanceTest methodsFor: 'running' stamp: 'tkow 12/12/2008 17:44'!
setUp
	super setUp.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance! !

!SqsSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testGetClassTableColumns
	self assert: (SqsClassInfo for: SqsTestObject) classTableColumns size = 5.
	self assert: (SqsClassInfo for: SqsTestObjectChild) classTableColumns size = 1.
	self assert: (SqsClassInfo for: SqsTestObjectEvenDeeperChild) classTableColumns size = 1! !

!SqsSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testSaveSubclassWithSingleTableInheritance
	| testObject base |
	base := SqsClassInfo for: SqsTestObjectChild.
	self assert: base tableName = SqsTestObject name asSqSaveTableName.
	self assert: base tableForClassExists not.
	testObject := SqsTestObjectChild new.
	testObject testSubString: 'Subtest'.
	testObject save.
	self assert: base tableForClassExists! !

!SqsSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: #singleTableInheritance.
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject
		testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 4.524;
		testSubString: 'FortyTwo';
		testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.
	self assert: (SqsStorage for: testObject) tableForClassExists! !

!SqsSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testTableObjectChildren
	| testObject table1 table2 table3 |
	testObject := SqsTestObjectEvenDeeperChild new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: SqsTestObject new;
		testSubString: 'sub-string';
		testExtremelyDeepSubString: 'deep-sub-string'.
	(SqsStorage for: testObject) createClassDescription.
	table1 := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) classTable.
	table2 := (SqsClassInfo for: SqsTestObjectChild) classTable.
	table3 := (SqsClassInfo for: SqsTestObject) classTable.
	self assert: table1 allChildTables isEmpty.
	self assert: table2 allChildTables isEmpty.
	self assert: table3 allChildTables isEmpty! !

!SqsSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testTableObjectCreation
	| testObject table |
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance.
	testObject := SqsTestObjectEvenDeeperChild new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: SqsTestObject new;
		testSubString: 'sub-string';
		testExtremelyDeepSubString: 'deep-sub-string'.
	(SqsStorage for: testObject) createClassDescription.
	table := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) classTable.
	self assert: table children isEmpty.
	self assert: table tableName = SqsTestObject name asSqSaveTableName.
	self assert: table columns size = 9.
	self assert: table parent isNil! !

!SqsSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/13/2008 11:44'!
testTypeParameter
	| testObject1 testObject2 dbConnection resultDicts typeField |
	testObject1 := SqsTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	dbConnection := (SqsConnectionManager getInstance sessionForCategory: self standardCategory) sqsDbAdapter.
	resultDicts := dbConnection 
		executeQuery: 'SELECT * FROM ' , SqsTestObject name asSqSaveTableName , ' WHERE test_integer = 42'.

	typeField := (SqsClassInfo for: SqsTestObject) configuration tableConfiguration typeField.
	resultDicts do: [ :resultDict | self assert: (resultDict at: typeField) = SqsTestObject name asString ].
	testObject2 := SqsTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save! !

SqsTestCase subclass: #SqsProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsProxyTest methodsFor: 'as yet unclassified' stamp: 'tkow 12/2/2008 18:46'!
setUp
	self setupTestConnection.! !

!SqsProxyTest methodsFor: 'as yet unclassified' stamp: 'tkow 12/12/2008 17:55'!
testProxiedObjectNotLoadedBeforeAccess
	| testObject testObject1 testResult |
	self clearDatabase.
	testObject := SqsTestObject new
		testInteger: 42;
		testString: 'foo';
		yourself.
	testObject1 := SqsTestObjectEvenDeeperChild new
		testSubString: 'foo-bar';
		testInteger: 42;
		testSomething: (OrderedCollection with: testObject);
		yourself.
	testObject1 save.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObjectChild findByTestSubString: 'foo-bar'.
	self assert: testResult notNil.
	self assert: (testResult testSomething class includesBehavior: SqsProxy).
	self assert: testResult testSomething sqsProxiedObject isNil.
	testResult testSomething at: 1.
	self assert: testResult testSomething sqsProxiedObject notNil! !

SqsTestCase subclass: #SqsSearchQueryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsSearchQueryTest methodsFor: 'running' stamp: 'test 1/27/2009 13:14'!
setUp
	self setupTestConnection.
	self removeDescriptions.
	self clearDatabase.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 1/27/2009 13:14'!
testComplexQueries
	| testObject query testObject2 compSql oidField |

	testObject2 := SqsTestObject new testInteger: 21.
	testObject := SqsTestObject new
		testString: 'test';
		testInteger: 42;
		testBool: true;
		testSomething: testObject2;
		testDate: Date today.
	testObject save.
	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj testSomething testInteger = 21 ].
	oidField := (SqsClassInfo for: SqsTestObject) configuration tableConfiguration idField.
	self assert: query whereBuffer = ('(sqs_test_objects.test_something_id = sqs_test_objects_1.' , oidField , ') AND sqs_test_objects_1.test_integer = 21').
	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj testSomething = testObject2 ].
	self assert: query whereBuffer = ('sqs_test_objects.test_something_id = ' , testObject2 oid asString).
	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj testSomething testSomething testSomething = testObject2 ].
	compSql := '((sqs_test_objects.test_something_id = sqs_test_objects_1.' , oidField , ') AND '.
	compSql := compSql , 'sqs_test_objects_1.test_something_id = sqs_test_objects_2.' , oidField , ') AND '.
	compSql := compSql , 'sqs_test_objects_2.test_something_id = ' , testObject2 oid asString.
	self assert: query whereBuffer = compSql! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 1/29/2009 15:44'!
testConcatenatedCollectionAnySatisfyQuery
	| testObject1 testObject2 results testObject3 |
	testObject3 := SqsTestObject new
		testInteger: 21;
		yourself.
	
	testObject1 := SqsTestObject new
		testInteger: 42;
		testSomething: (OrderedCollection with: testObject3);
		yourself.
	
	"sorry for the testBool abuse, but you'll get the point, I guess'"	
	testObject2 := SqsTestObject new
		testInteger: 42;
		testBool: testObject1;
		yourself.
		
	testObject2 save.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testBool testSomething anySatisfy: [:aTestObject | aTestObject testInteger = 21]].
	self assert: results size = 1.
	self assert: (results includes: testObject2).
	
	testObject1 testSomething: (OrderedCollection with: 12).
	testObject1 save.
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testBool testSomething anySatisfy: [:aValue | aValue = 12]].
	self assert: results size = 1.
	self assert: (results includes: testObject2).! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 1/27/2009 14:09'!
testConcatenatedCollectionIncludesQuery
	| testObject1 testObject2 results testObject3 |
	testObject3 := SqsTestObject new
		testInteger: 21;
		yourself.
	
	testObject1 := SqsTestObject new
		testInteger: 42;
		testSomething: (OrderedCollection with: testObject3);
		yourself.
	
	"sorry for the testBool abuse, but you'll get the point, I guess'"	
	testObject2 := SqsTestObject new
		testInteger: 42;
		testBool: testObject1;
		yourself.
		
	testObject2 save.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testBool testSomething includes: testObject3].
	self assert: results size = 1.
	self assert: (results includes: testObject2).
	
	testObject1 testSomething: (OrderedCollection with: 12).
	testObject1 save.
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testBool testSomething includes: 12].
	self assert: results size = 1.
	self assert: (results includes: testObject2).! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 1/27/2009 13:28'!
testConcatenatedCollectionSizeQuery
	| testObject1 testObject2 results |
	testObject1 := SqsTestObject new
		testInteger: 42;
		testSomething: (OrderedCollection with: 5 with: 6 with: 7 with: 8)
		yourself.
	
	"sorry for the testBool abuse, but you'll get the point, I guess'"	
	testObject2 := SqsTestObject new
		testInteger: 42;
		testBool: testObject1;
		yourself.
		
	testObject1 save.
	testObject2 save.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testBool testSomething size = 4].
	self assert: results size = 1.! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 1/23/2009 18:07'!
testFindCorrectColumn
	| queryObject classTable |
	queryObject := SqsQueryObject new.
	classTable := (SqsClassInfo for: SqsTestObject) classTable.
	self assert: (queryObject 
			sqsFindColumnFor: #testInteger
			inTable: classTable) isNil not.
	self assert: (queryObject 
			sqsFindColumnFor: #testSubString
			inTable: classTable) isNil not.
	self assert: (queryObject 
			sqsFindColumnFor: #testExtremelyDeepSubString
			inTable: classTable) isNil not.
	self assert: (queryObject 
			sqsFindColumnFor: #testNonExistentColumn
			inTable: classTable) isNil.
			! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 2/2/2009 13:19'!
testSimpleCollectionAnySatisfiesQuery
	| testObject1 testObject2 results |
	testObject1 := SqsTestObject new
		testInteger: 42;
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject1);
		yourself.
		
	testObject2 save.

	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testSomething anySatisfy: [:anObj | anObj = testObject1]].
	self assert: results size = 1.
	self assert: (results includes: testObject2).
	
	testObject2 testSomething: (OrderedCollection with: 1).
	testObject2 save.
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testSomething anySatisfy: [:anObj | anObj > 0]].
	self assert: results size = 1.
	self assert: (results includes: testObject2).
	! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 1/27/2009 14:04'!
testSimpleCollectionIncludesQuery
	| testObject1 testObject2 results |
	testObject1 := SqsTestObject new
		testInteger: 42;
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject1);
		yourself.
		
	testObject2 save.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testSomething includes: testObject1].
	self assert: results size = 1.
	self assert: (results includes: testObject2).
	
	testObject2 testSomething: (OrderedCollection with: 1).
	testObject2 save.
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testSomething includes: 1].
	self assert: results size = 1.
	self assert: (results includes: testObject2).
	! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 1/27/2009 13:20'!
testSimpleCollectionSizeQuery
	| testObject1 testObject2 results |
	testObject1 := SqsTestObject new
		testInteger: 42;
		testSomething: (OrderedCollection with: 1 with: 2 with: 3 with: 4);
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 42;
		testSomething: (OrderedCollection with: 5 with: 6 with: 7 with: 8);
		yourself.
		
	testObject1 save.
	testObject2 save.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testSomething size = 4].
	self assert: results size = 2.
	
	testObject2 testSomething add: 11.
	testObject2 save.
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testSomething size = 4].
	self assert: results size = 1.
	self assert: results includes: testObject1.! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 2/2/2009 14:38'!
testSimpleQueries
	| testObject query compSql oidField |

	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.
	testObject := SqsTestObjectEvenDeeperChild new
		testString: 'test';
		testInteger: 42;
		testBool: true;
		testSomething: 4.123;
		testDate: Date today;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'subberString'.
	(SqsStorage for: testObject) createClassDescription.
	oidField := (SqsClassInfo for: SqsTestObject) configuration tableConfiguration idField.
	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj testInteger = 5 ].
	self assert: query whereBuffer = 'sqs_test_objects.test_integer = 5'.

	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj oid = 5 ].
	self assert: query whereBuffer = ('sqs_test_objects.' , oidField , ' = 5').
	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj testDate = Date today ].
	self assert: query whereBuffer = ('sqs_test_objects.test_date = ' , Date today asSqlValueString).
	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj testBool = true ].
	self assert: query whereBuffer = 'sqs_test_objects.test_bool = TRUE'.
	query := (SqsQuery new on: SqsTestObjectEvenDeeperChild) analyze: [ :obj | obj testExtremelyDeepSubString = 'test' ].
	self assert: query whereBuffer = 'sqs_test_object_even_deeper_childs.test_extremely_deep_sub_string = ''test'''.
	testObject testExtremelyDeepSubString: SqsTestObject new.
	(SqsStorage for: testObject) createClassDescription.

	"this should be the probably most complicated query to process - associated element in a sub-table"
	query := (SqsQuery new on: SqsTestObjectEvenDeeperChild) analyze: [ :obj | obj testExtremelyDeepSubString testSubString = 'test' ].
	compSql := '(sqs_test_object_even_deeper_childs.test_extremely_deep_sub_string_id = sqs_test_object_childs_1.' , oidField , ') AND '.
	compSql := compSql , 'sqs_test_object_childs_1.test_sub_string = ''test'''.
	self assert: query whereBuffer = compSql! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 2/2/2009 13:21'!
testSimplestQuery
	| testObject results |

	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.
	testObject := SqsTestObjectEvenDeeperChild new
		testString: 'test';
		testInteger: 42;
		testBool: true;
		testSomething: 4.123;
		testDate: Date today;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'subberString'.

	testObject save.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj = testObject].
	self assert: (results size = 1).
	self assert: ((results at: 1) = testObject).! !

SqsTestCase subclass: #SqsStringExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsStringExtensionTests methodsFor: 'tests' stamp: 'tkow 11/10/2008 16:42'!
testAsSqSaveDescriptionSelector
	| testString |
	testString := 'instanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #sqsDescrInstanceVariable).
	testString := 'InstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #sqsDescrInstanceVariable).
	testString := 'aInstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #sqsDescrAInstanceVariable).
	! !

!SqsStringExtensionTests methodsFor: 'tests' stamp: 'tkow 12/12/2008 18:00'!
testAsSqSaveDescriptorClassName
	'SqSaveTestObject' asSqSaveDescriptorClassName = #SqsTestObjectPersistenceDescriptor.
	'sqSaveTestObjectEvenDeeperChild' asSqSaveDescriptorClassName = #SqsTestObjectEvenDeeperChildPersistenceDescriptor! !

!SqsStringExtensionTests methodsFor: 'tests' stamp: 'tk 6/24/2008 15:33'!
testAsSqSaveTableName
	| testString |
	testString := 'TKSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'tk_save_test_objects').
	testString := 'SqSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'sq_save_test_objects').
	testString := 'SqSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'sqsave_test_objects').
	testString := 'TKSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'tksave_test_objects').
	! !

!SqsStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/14/2008 17:45'!
testCollectionJoin
	self assert: ((#('hallo' 'welt') join: '-') = 'hallo-welt').
	self assert: ((#('hallo' 'welt') join: '') = 'hallowelt').
	self assert: ((#('hallo' 'welt') join: nil) = 'hallowelt')! !

!SqsStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/7/2008 16:48'!
testDecamelized
	self assert: 'sq_save_type_field' decamelized = 'sq_save_type_field'.
	self assert: 'SqSaveTypeField' decamelized = 'sq_save_type_field'.! !

SqsTestCase subclass: #SqsTableCacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTableCacheTest methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
testCorrectCacheCreationCTI
	| testObject tableCache testObject2 |
	self setupTestConnection.
	self clearDatabase.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.
	testObject := SqsTestObject new
		testInteger: 42;
		yourself.
	testObject save.
	tableCache := (SqsClassInfo for: SqsTestObject) tableStructureHandler tableCache tableCache.
	self assert: (tableCache includesKey: SqsTestObject name).
	self assert: ((tableCache at: SqsTestObject name) includesKey: SqsTableCache existenceKey).
	
	testObject2 := SqsTestObjectChild new
		testInteger: 12;
		yourself.
	testObject2 save.
	
	self assert: (tableCache includesKey: SqsTestObjectChild name).
	self assert: ((tableCache at: SqsTestObjectChild name) includesKey: SqsTableCache existenceKey).! !

!SqsTableCacheTest methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
testCorrectCacheCreationSTI
	| testObject tableCache testObject2 |
	self setupTestConnection.
	self clearDatabase.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance.
	testObject := SqsTestObject new
		testInteger: 42;
		yourself.
	testObject save.
	tableCache := (SqsClassInfo for: SqsTestObject) tableStructureHandler tableCache tableCache.
	self assert: (tableCache includesKey: SqsTestObject name).
	self assert: ((tableCache at: SqsTestObject name) includesKey: SqsTableCache existenceKey).
	testObject2 := SqsTestObjectChild new
		testInteger: 12;
		yourself.
	testObject2 save.
	self assert: (tableCache includesKey: SqsTestObjectChild name) not! !

SqsTestCase subclass: #SqsTableChangesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTableChangesTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testCorrectClassChoosing
	| sampleObject |
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance.
	sampleObject := SqsStorage for: SqsTestObject new.
	self assert: (SqsTableStructureHandler forObject: sampleObject) class = SqsSingleTableInheritanceHandler.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.
	sampleObject := SqsStorage for: SqsTestObject new.
	self assert: (SqsTableStructureHandler forObject: sampleObject) class = SqsClassTableInheritanceHandler! !

!SqsTableChangesTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:41'!
testFindAlteredColumns
	| oldColumn newColumn oldTable newTable tableChanges |
	oldColumn := SqsColumn new
		linkedVariable: 'test_var';
		sqlType: #integer;
		columnName: 'test_column_1'.
	newColumn := SqsColumn new
		linkedVariable: 'test_var';
		sqlType: #string;
		columnName: 'test_column_1'.
	oldTable := SqsTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: oldColumn).
	newTable := SqsTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: newColumn).
	tableChanges := (SqsTableChanges 
		oldTable: oldTable
		newTable: newTable) calculateChanges.
	self assert: tableChanges alteredColumns isEmpty not.
	self assert: tableChanges alteredColumns anyOne = newColumn! !

!SqsTableChangesTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:41'!
testFindChangedTableName
	| oldTable newTable changes |
	oldTable := SqsTable new tableName: 'testTable1'.
	newTable := SqsTable new tableName: 'testTable2'.
	changes := SqsTableChanges 
		oldTable: oldTable
		newTable: newTable.
	self assert: changes newTableName isNil not.
	self assert: changes newTableName = 'testTable2'! !

!SqsTableChangesTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:41'!
testFindRemovedAndAddedColumns
	| oldColumn newColumn oldTable newTable tableChanges |
	oldColumn := SqsColumn new
		linkedVariable: 'test_var_1';
		sqlType: #integer;
		columnName: 'test_column_1'.
	newColumn := SqsColumn new
		linkedVariable: 'test_var_2';
		sqlType: #integer;
		columnName: 'test_column_1'.
	oldTable := SqsTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: oldColumn).
	newTable := SqsTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: newColumn).
	tableChanges := (SqsTableChanges 
		oldTable: oldTable
		newTable: newTable) calculateChanges.
	self assert: tableChanges removedColumns isEmpty not.
	self assert: tableChanges removedColumns anyOne = oldColumn.
	self assert: tableChanges addedColumns isEmpty not.
	self assert: tableChanges addedColumns anyOne = newColumn! !

!SqsTableChangesTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:41'!
testFindRenamedColumns
	| oldColumn newColumn changed oldTable newTable tableChanges |
	oldColumn := SqsColumn new
		linkedVariable: 'test_var';
		sqlType: #integer;
		columnName: 'test_column_1'.
	newColumn := SqsColumn new
		linkedVariable: 'test_var';
		sqlType: #integer;
		columnName: 'test_column_2'.
	oldTable := SqsTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: oldColumn).
	newTable := SqsTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: newColumn).
	tableChanges := (SqsTableChanges 
		oldTable: oldTable
		newTable: newTable) calculateChanges.
	self assert: tableChanges renamedColumns isEmpty not.
	changed := tableChanges renamedColumns anyOne.
	self assert: changed first = oldColumn.
	self assert: changed last = newColumn! !

SqsTestCase subclass: #SqsTableStructureHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTableStructureHandlerTest methodsFor: 'as yet unclassified' stamp: 'tkow 12/6/2008 15:20'!
setUp
	self setupTestConnection.
	self clearDatabase.! !

!SqsTableStructureHandlerTest methodsFor: 'tests' stamp: 'test 1/25/2009 16:14'!
testCacheFillingWithLazyCollections
	| testObject tableCache toCache tocCache toedcCache classIndex joinIndex joinTables testStorage testObject2 changes joinTable |
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.
	SqsTableStructureHandler clearTableCache.
	self clearDatabase.
	self removeDescriptions.
	
	classIndex := SqsTableCache classTableKey.
	joinIndex := SqsTableCache joinTableKey.
	testObject := SqsTestObjectEvenDeeperChild new
		testSubString: 'test';
		testExtremelyDeepSubString: 'test2';
		testInteger: 42;
		yourself.
	testObject2 := SqsTestObject new
		testInteger: 21;
		yourself.
	testStorage := SqsStorage for: testObject.
	testStorage save.
	tableCache := testStorage tableStructureHandler tableCache.
	toCache := tableCache tableCache 
		at: SqsTestObject name
		ifAbsent: [ nil ].
	tocCache := tableCache tableCache 
		at: SqsTestObjectChild name
		ifAbsent: [ nil ].
	toedcCache := tableCache tableCache 
		at: SqsTestObjectEvenDeeperChild name
		ifAbsent: [ nil ].
	self assert: ((toCache notNil and: [ tocCache notNil ]) and: [ toedcCache notNil ]).
	self 
		shouldnt: [ toCache at: classIndex ]
		raise: Error.
	self 
		shouldnt: [ tocCache at: classIndex ]
		raise: Error.
	self 
		shouldnt: [ toedcCache at: classIndex ]
		raise: Error.
	self 
		should: [ joinTables := toCache at: joinIndex ]
		raise: Error.
	testObject testSomething: (OrderedCollection with: testObject2).
	testStorage createClassDescription.
	changes := testStorage tableStructureHandler getTableChanges.
	"one empty changes object for all subclasses"
	self assert: changes size = 3.

	"more interesting now are the join tables. one should be inserted in the cache right now"
	joinTables := toCache 
		at: joinIndex
		ifAbsent: [ nil ].
	self assert: joinTables notNil.
	self assert: joinTables size = 1.
	joinTable := joinTables anyOne value.
	self assert: joinTable tableName = 'sqs_test_objects_test_something'! !

!SqsTableStructureHandlerTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testColumnValueDictionaryCreation
	| testObject storage columnValueDict |
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance.
	self removeDescriptions.
	testObject := SqsTestObjectEvenDeeperChild new
		testBool: true;
		testInteger: 42;
		testSomething: 4.12;
		testDate: Date today;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'subberString';
		testString: 'string'.
	storage := SqsStorage for: testObject.
	storage createClassDescription.
	columnValueDict := storage tableStructureHandler columnValueDictionaryFor: storage classInfo classTable.
	self assert: (columnValueDict includesKey: storage classInfo configuration tableConfiguration idField) not.
	self assert: (columnValueDict includesKey: 'test_bool').
	self assert: (columnValueDict at: 'test_bool') = true asSqlValueString.
	self assert: (columnValueDict includesKey: 'test_integer').
	self assert: (columnValueDict at: 'test_integer') = 42 asSqlValueString.
	self assert: (columnValueDict includesKey: 'test_something').
	self assert: (columnValueDict at: 'test_something') = 4.12 asSqlValueString.
	self assert: (columnValueDict includesKey: 'test_date').
	self assert: (columnValueDict at: 'test_date') = Date today asSqlValueString.
	self assert: (columnValueDict includesKey: 'test_sub_string').
	self assert: (columnValueDict at: 'test_sub_string') = 'subString' asSqlValueString.
	self assert: (columnValueDict includesKey: 'test_extremely_deep_sub_string').
	self assert: (columnValueDict at: 'test_extremely_deep_sub_string') = 'subberString' asSqlValueString! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 1/18/2009 17:15'!
clearDatabase
	connection resetDatabase.
	SqsTableStructureHandler clearTableCache.
! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 10/6/2008 17:56'!
descriptorMethodCategory
	^'persistence-description'! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 12/12/2008 17:37'!
mysqlConnectionSpecification
	^ SqsConnectionSpecification 
		user: self standardUser
		password: self standardPassword
		database: self standardDatabase! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 12/12/2008 17:37'!
postgresConnectionSpecification
	^ SqsConnectionSpecification 
		user: 'enterprisedb'
		password: self standardPassword
		port: 5444
		database: self standardDatabase
		driver: #SqsPostgresAdapter! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 12/12/2008 17:54'!
removeDescriptions
	| classes targetClass |
	targetClass := (SqsClassInfo for: SqsTestObject) descriptionHandler targetClass.
	classes := Set with: targetClass.
	classes addAll: targetClass allSubclasses.
	classes do: 
		[ :curClass | 
		(curClass class selectors select: [ :selector | selector prefixMatchesRegex: '' asSqSaveDescriptionSelector ]) do: [ :selector | curClass class removeSelector: selector ] ]! !

!SqsTestCase methodsFor: 'running' stamp: 'test 1/27/2009 11:28'!
setTestObjectInheritanceModeTo: inheritanceMode 
	| code targetClass config |
	config := SqsConfiguration new.
	config tableConfiguration inheritanceMode: inheritanceMode.
	code := SqsClassInfo configurationFunction asString , String crlf , String tab , '^ '.
	code := code , config codeForObjectCreation.
	targetClass := SqsTestObject.
	(targetClass organization categories includes: self descriptorMethodCategory) ifTrue: [ targetClass organization addCategory: self descriptorMethodCategory ].
	targetClass class 
		compile: code
		classified: self descriptorMethodCategory! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 12/13/2008 10:33'!
setupTestConnection
	SqsConnectionManager getInstance 
		setConSpec: self standardConnectionSpecification
		for: self standardCategory.
	connection := (SqsConnectionManager getInstance sessionForCategory: self standardCategory) sqsDbAdapter! !

!SqsTestCase methodsFor: 'test-assertions' stamp: 'tkow 10/29/2008 13:40'!
should: aBlock takeMoreThanMilliseconds: delayTime
    | evaluated evaluationProcess result delay testProcess aDuration |

	evaluated := false.
	aDuration := (Duration milliSeconds: delayTime).
	delay := Delay forDuration: aDuration.
	testProcess := Processor activeProcess.
	evaluationProcess := [
		result := aBlock value.
		evaluated := true.
		delay unschedule.
		testProcess resume ] forkNamed: 'Process to evaluate should: notTakeMoreThanMilliseconds:'.

	delay wait.
	evaluated ifTrue: [
		self assert: false description: ('Block evaluation took less than the expected <1p>' expandMacrosWith: aDuration)
	] ifFalse: [
	 	evaluationProcess terminate
	].
    ^result! !

!SqsTestCase methodsFor: 'standard values' stamp: 'tkow 11/3/2008 14:15'!
standardCategory
	^'SqSave'! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 12/13/2008 10:40'!
standardConnectionSpecification
	^ self mysqlConnectionSpecification! !

!SqsTestCase methodsFor: 'standard values' stamp: 'tkow 11/3/2008 14:15'!
standardDatabase
	^'squeak_test'! !

!SqsTestCase methodsFor: 'standard values' stamp: 'tkow 11/3/2008 14:14'!
standardPassword
	^'test'! !

!SqsTestCase methodsFor: 'standard values' stamp: 'test 1/22/2009 14:34'!
standardUser
	^'test'! !

!Symbol class methodsFor: '*sqsave' stamp: 'tkow 1/19/2009 17:47'!
fromSqlValue: anObject
	^ anObject asSymbol! !

!Symbol class methodsFor: '*sqsave' stamp: 'tkow 11/11/2008 01:53'!
sqsType
	^#string! !

!Symbol methodsFor: '*sqsave' stamp: 'tkow 11/11/2008 01:53'!
asSqlValueString
	^'''', self asString ,''''! !

!DateAndTime class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:25'!
sqsType
	^#dateAndTime! !

!DateAndTime methodsFor: '*sqsave' stamp: 'wh 3/2/2006 15:27'!
asSqlValueString
	^'''', self asString,''''. ! !

Object subclass: #AuthorPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps'!

!AuthorPersistenceDescriptor class methodsFor: 'persistence-description' stamp: 'tkow 1/9/2009 13:35'!
sqsDescrBirthdate
^(SqsColumn new
	
	 manuallyMaintained: false;
	 columnName: 'birthdate';
	 sqlType: #date;
	 objectClass: #Date;
	 canBeNull: true;
	 isPrimaryKey: false;
	 autoIncrement: false;
	 linkedVariable: 'birthdate';
	 yourself)! !

!AuthorPersistenceDescriptor class methodsFor: 'persistence-description' stamp: 'test 1/26/2009 14:46'!
sqsDescrBlogEntries
	^ SqsCollectionDescription new
		manuallyMaintained: false;
		collectionClass: OrderedCollection;
		tableName: 'authors_blog_entries';
		ownerColumn: (SqsColumn new
				manuallyMaintained: false;
				columnName: 'author_id';
				sqlType: #integer;
				foreignKey: (SqsForeignKeyDescription new
						manuallyMaintained: false;
						referencedColumns: (OrderedCollection new
								add: 'id';
								yourself);
						referencedTable: 'authors';
						updateActions: #();
						deleteActions: #(#CASCADE );
						yourself);
				canBeNull: false;
				isPrimaryKey: false;
				autoIncrement: false;
				linkedVariable: #SQSOWNER;
				yourself);
		referenceColumn: (SqsColumn new
				manuallyMaintained: false;
				columnName: 'value';
				sqlType: #integer;
				canBeNull: false;
				isPrimaryKey: false;
				autoIncrement: false;
				linkedVariable: #SQSREF;
				yourself);
		referenceTableName: 'blog_entrys';
		configuration: (SqsCollectionConfiguration new
				valueField: 'value';
				orderedCollections: true;
				orderField: 'sqs_order_number';
				nilValue: 0;
				yourself);
		simpleValues: false;
		indexType: #integer;
		referencedClass: #BlogEntry;
		linkedVariable: 'blogEntries';
		yourself! !

!AuthorPersistenceDescriptor class methodsFor: 'persistence-description' stamp: 'tkow 1/9/2009 13:35'!
sqsDescrName
^(SqsColumn new
	
	 manuallyMaintained: false;
	 columnName: 'name';
	 sqlType: #string;
	 objectClass: #ByteString;
	 canBeNull: true;
	 isPrimaryKey: false;
	 autoIncrement: false;
	 linkedVariable: 'name';
	 yourself)! !

!AuthorPersistenceDescriptor class methodsFor: 'persistence-description' stamp: 'tkow 1/9/2009 19:09'!
sqsDescrSsn
^(SqsColumn new
	
	 manuallyMaintained: false;
	 columnName: 'ssn';
	 sqlType: #integer;
	 objectClass: #SmallInteger;
	 canBeNull: true;
	 isPrimaryKey: false;
	 autoIncrement: false;
	 linkedVariable: 'ssn';
	 yourself)! !

Object subclass: #BlogEntryPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps'!

!BlogEntryPersistenceDescriptor class methodsFor: 'persistence-description' stamp: 'tkow 1/9/2009 13:35'!
sqsDescrCreatedAt
^(SqsColumn new
	
	 manuallyMaintained: false;
	 columnName: 'created_at';
	 sqlType: #date;
	 objectClass: #Date;
	 canBeNull: true;
	 isPrimaryKey: false;
	 autoIncrement: false;
	 linkedVariable: 'createdAt';
	 yourself)! !

!BlogEntryPersistenceDescriptor class methodsFor: 'persistence-description' stamp: 'tkow 1/9/2009 13:35'!
sqsDescrText
^(SqsColumn new
	
	 manuallyMaintained: false;
	 columnName: 'text';
	 sqlType: #string;
	 objectClass: #ByteString;
	 canBeNull: true;
	 isPrimaryKey: false;
	 autoIncrement: false;
	 linkedVariable: 'text';
	 yourself)! !

!Object class methodsFor: '*sqsave' stamp: 'tkow 1/19/2009 17:47'!
fromSqlValue: anObject
	^ anObject! !

!Object methodsFor: '*sqsave' stamp: 'tkow 12/12/2008 17:45'!
destroy
	(SqsStorage for: self) destroy! !

!Object methodsFor: '*sqsave' stamp: 'tkow 1/6/2009 17:02'!
instVarDict
	"returns a dictionary where each inst var name points to the current value"
	| ivnDict |
	ivnDict := Dictionary new.
	self class allInstVarNames do: [:ivn |
		| ivarValue |
		ivarValue := self instVarNamed: ivn.
		ivnDict at: ivn put: ivarValue.
	].
	^ ivnDict! !

!Object methodsFor: '*sqsave' stamp: 'tkow 12/12/2008 17:45'!
oid
	^ SqsStorage oidFor: self! !

!Object methodsFor: '*sqsave' stamp: 'tkow 12/12/2008 17:45'!
save
	(SqsStorage for: self) save! !

!Object methodsFor: '*sqsave' stamp: 'tkow 12/12/2008 23:09'!
save: anSqsDbAdapter 
	| storage |
	storage := SqsStorage for: self.
	storage sqsSession: anSqsDbAdapter.
	storage save! !

!Object methodsFor: '*sqsave' stamp: 'tk 8/26/2008 16:43'!
sqSaveClass
	^self class! !

Object subclass: #SqsClassInfo
	instanceVariableNames: 'currentClass tableStructureHandler descriptionHandler tableName classTable configuration'
	classVariableNames: 'InfoCache'
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsClassInfo class methodsFor: 'standard-values' stamp: 'tkow 10/6/2008 18:30'!
clearInfoCache
	InfoCache := nil.! !

!SqsClassInfo class methodsFor: 'standard-values' stamp: 'tkow 11/7/2008 13:45'!
configurationFunction
	^#sqsConfiguration! !

!SqsClassInfo class methodsFor: 'standard-values' stamp: 'tkow 11/7/2008 13:46'!
descriptionHandlerFunction
	^ #sqsDescriptionHandler! !

!SqsClassInfo class methodsFor: 'access to cache' stamp: 'tkow 11/7/2008 16:03'!
for: aClass
	| newInstance |
	InfoCache ifNil: [InfoCache := Dictionary new].
	newInstance := InfoCache at: aClass name ifAbsentPut: [
		(self new) currentClass: aClass; yourself
	].
	self prepareNewInstance: newInstance.	
	^ newInstance
! !

!SqsClassInfo class methodsFor: 'access to cache' stamp: 'tkow 1/6/2009 14:46'!
prepareNewInstance: newInstance 
	newInstance configuration environment = SqsConfiguration developmentMode ifTrue: 
		[ newInstance tableName: nil.
		newInstance tableStructureHandler: nil.
		newInstance descriptionHandler: nil.
		newInstance configuration: nil.
		newInstance cachedClassTable ifNotNil: 
			[ newInstance cachedClassTable structure ~= newInstance inheritanceMode ifTrue: [ newInstance cachedClassTable: nil ] ] ].
	^ newInstance! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 12/12/2008 17:45'!
baseClass
	| klass |
	klass := self currentClass.
	[ klass superclass = Object or: [ klass superclass = SqsSearch ] ] whileFalse: [ klass := klass superclass ].
	^ klass! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 11/3/2008 14:57'!
cachedClassTable
	^ classTable
! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 11/3/2008 14:57'!
cachedClassTable: anSqSTable
	classTable := anSqSTable
! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 11/3/2008 14:27'!
classTable
	^ self tableStructureHandler classTable
! !

!SqsClassInfo methodsFor: 'table-information' stamp: 'tkow 10/6/2008 18:09'!
classTableColumns
	^self descriptionHandler classTableColumns! !

!SqsClassInfo methodsFor: 'variable-information' stamp: 'tkow 11/7/2008 16:16'!
columnNameForInstVar: ivn
	^ ivn decamelized! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 12/12/2008 17:39'!
configuration
	configuration ifNil: 
		[ (self currentClass respondsTo: self class configurationFunction) 
			ifTrue: 
				[ configuration := self currentClass perform: self class configurationFunction ]
			ifFalse: 
				[ "'No configuration specified for the current class'"
				configuration := SqsConfiguration new ] ].
	^ configuration! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:41'!
configuration: anObject
	configuration := anObject! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 9/29/2008 15:19'!
currentClass
	^ currentClass! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 9/29/2008 15:19'!
currentClass: anObject
	currentClass := anObject! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:48'!
descriptionHandler
	descriptionHandler ifNil: [
		descriptionHandler := self descriptionHandlerClass forClassInfo: self.	
	].
	^descriptionHandler! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 9/30/2008 11:51'!
descriptionHandler: anObject
	descriptionHandler := anObject! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:49'!
descriptionHandlerClass
	^ self configuration descriptionHandlerClass! !

!SqsClassInfo methodsFor: 'iterating' stamp: 'tkow 9/30/2008 15:13'!
doForAllSuperclasses: aBlock
	| curClass baseClass |
	"this is a convenience method to perform some block
	for all of the current class' superclasses up until the base class"
	curClass := self currentClass.
	baseClass := self baseClass.
	[curClass = baseClass superclass] whileFalse: [
		aBlock value: curClass.
		curClass := curClass superclass.
	].! !

!SqsClassInfo methodsFor: 'persistence-information' stamp: 'tkow 11/7/2008 16:27'!
inheritanceMode
	^self configuration tableConfiguration inheritanceMode! !

!SqsClassInfo methodsFor: 'variable-information' stamp: 'tkow 9/30/2008 14:17'!
persistedInstVars
	| |
	^self descriptionHandler persistedInstanceVariables
	! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 12/13/2008 10:32'!
sqsSession
	^ self configuration connectionSpec 
		ifNil: [ SqsConnectionManager getInstance sessionForClass: self currentClass ]
		ifNotNil: 
			[ SqsConnectionManager getInstance sessionForConSpec: self configuration connectionSpec ]! !

!SqsClassInfo methodsFor: 'object-persistence' stamp: 'tkow 1/18/2009 16:06'!
tableForClassExists
	| |
	^ self tableStructureHandler tableForClassExists! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:08'!
tableName
	| |
	tableName ifNil: [
		tableName := self configuration tableConfiguration tableName ifNil: [
			self tableStructureHandler tableName
		].
	].
	^ tableName! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 9/30/2008 15:05'!
tableName: aString
	| |
	tableName := aString! !

!SqsClassInfo methodsFor: 'table-information' stamp: 'tkow 9/29/2008 15:14'!
tableNameForClass: aClass
	"only use me for classes you are sure of using the same description handler 
	 than the one the current sqsObject is using"
	^self descriptionHandler tableNameForClass: aClass
	! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 12/12/2008 17:44'!
tableStructureHandler
	tableStructureHandler ifNil: [ tableStructureHandler := SqsTableStructureHandler forClassInfo: self ].
	^ tableStructureHandler! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:15'!
tableStructureHandler: anObject
	tableStructureHandler := anObject! !

!SqsClassInfo methodsFor: 'variable-information' stamp: 'tkow 9/29/2008 15:15'!
unpersistedInstVars
	| |
	^self descriptionHandler unpersistedInstVars
	! !

Object subclass: #SqsCollectionChanges
	instanceVariableNames: 'addedObjects deletedObjects movedObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
addedObjects
	^ addedObjects! !

!SqsCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
addedObjects: anObject
	addedObjects := anObject! !

!SqsCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
deletedObjects
	^ deletedObjects! !

!SqsCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
deletedObjects: anObject
	deletedObjects := anObject! !

!SqsCollectionChanges methodsFor: 'initialization' stamp: 'tkow 11/7/2008 15:23'!
initialize
	super initialize.
	addedObjects := OrderedCollection new.
	deletedObjects := OrderedCollection new.
	movedObjects := OrderedCollection new.! !

!SqsCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
movedObjects
	^ movedObjects! !

!SqsCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
movedObjects: anObject
	movedObjects := anObject! !

Object subclass: #SqsCollectionConfiguration
	uses: TSqsSelfPrinting
	instanceVariableNames: 'valueField orderedCollections orderField nilValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

SqsCollectionConfiguration class
	uses: TSqsSelfPrinting classTrait
	instanceVariableNames: ''!

!SqsCollectionConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:22'!
standardForOrderedCollections
	^ true! !

!SqsCollectionConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/10/2008 09:40'!
standardNilValue
	^ 0! !

!SqsCollectionConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:22'!
standardOrderField
	^'sqs_order_number'! !

!SqsCollectionConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:21'!
standardValueField
	^'value'! !

!SqsCollectionConfiguration methodsFor: 'printing' stamp: 'test 1/27/2009 11:29'!
codeForObjectCreation
	| aStream |
	aStream := TextStream on: String new.
	aStream nextPut: $(.
	aStream nextPutAll: self class name , ' new'.
	aStream nextPutAll: String crlf , String tab.
	1 
		to: self class instSize
		do: 
			[ :i | 
			(self instVarAt: i) ifNotNil: 
				[ aStream
					nextPutAll: String cr , String tab;
					nextPutAll: ' ' , (self class allInstVarNames at: i) , ': ';
					store: (self instVarAt: i);
					nextPut: $; ] ].
	aStream nextPutAll: String cr , String tab , ' yourself)'.
	^ aStream contents! !

!SqsCollectionConfiguration methodsFor: 'initialize-release' stamp: 'tkow 11/10/2008 09:41'!
initialize
	super initialize.
	self orderField: self class standardOrderField.
	self orderedCollections: self class standardForOrderedCollections.
	self valueField: self class standardValueField.
	self nilValue: self class standardNilValue.! !

!SqsCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/10/2008 09:41'!
nilValue
	^ nilValue! !

!SqsCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/10/2008 09:41'!
nilValue: anObject
	nilValue := anObject! !

!SqsCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
orderField
	^ orderField! !

!SqsCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
orderField: anObject
	orderField := anObject! !

!SqsCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
orderedCollections
	^ orderedCollections! !

!SqsCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
orderedCollections: anObject
	orderedCollections := anObject! !

!SqsCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
valueField
	^ valueField! !

!SqsCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
valueField: anObject
	valueField := anObject! !

Object subclass: #SqsCollectionInformation
	instanceVariableNames: 'collection collectionDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsCollectionInformation methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:11'!
collection
	^ collection! !

!SqsCollectionInformation methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:11'!
collection: anObject
	collection := anObject! !

!SqsCollectionInformation methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:11'!
collectionDescription
	^ collectionDescription! !

!SqsCollectionInformation methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:11'!
collectionDescription: anObject
	collectionDescription := anObject! !

Object subclass: #SqsCon
	instanceVariableNames: 'length type to from'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsCon class methodsFor: 'as yet unclassified' stamp: 'test 2/2/2009 16:57'!
from: aPart to: anotherPart
	^self new
		from: aPart;
		to: anotherPart;
		length: ((Random seed: Time now asNanoSeconds) nextValue asInteger);
		type: ('Type',((Random seed: Time now asNanoSeconds) nextValue asInteger) asString);
		yourself! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
from
	^ from! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
from: anObject
	from := anObject! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
length
	^ length! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
length: anObject
	length := anObject! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
to
	^ to! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
to: anObject
	to := anObject! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
type
	^ type! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
type: anObject
	type := anObject! !

Object subclass: #SqsConfiguration
	uses: TSqsSelfPrinting
	instanceVariableNames: 'connectionSpec descriptionHandlerClass collectionConfiguration tableConfiguration environment useInstVarAccessors warnOnAlteration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsConfiguration commentStamp: 'tkow 12/4/2008 16:02' prior: 0!
A SqSConfiguration is the main class for the configuration of SqueakSave. It defines some fundamental options by itself and links to the other configuration classes for detailed configuration of merely all aspects of the mapper. Instances of this class should be created on the class side of the class they are valid for, and will be used for all subclasses, also.

Instance Variables
	collectionConfiguration:		SqSCollectionconfiguration
	connectionSpec:		SqSConnectionSpecification
	descriptionHandlerClass:		Symbol
	mode:		Symbol
	objectCaching:		Symbol
	tableConfiguration:		SqSTableConfiguration
	useInstVarAccessors:		Boolean

collectionConfiguration
	- xxxxx

connectionSpec
	- xxxxx

descriptionHandlerClass
	- xxxxx

mode
	- xxxxx

objectCaching
	- xxxxx

tableConfiguration
	- xxxxx

useInstVarAccessors
	- xxxxx
!

SqsConfiguration class
	uses: TSqsSelfPrinting classTrait
	instanceVariableNames: ''!

!SqsConfiguration class methodsFor: 'modes' stamp: 'tkow 11/7/2008 16:04'!
developmentMode
	^#development! !

!SqsConfiguration class methodsFor: 'modes' stamp: 'tkow 11/7/2008 15:31'!
productionMode
	^#production! !

!SqsConfiguration class methodsFor: 'standard values' stamp: 'tkow 12/12/2008 17:39'!
standardCollectionConfiguration
	^ SqsCollectionConfiguration new! !

!SqsConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 16:20'!
standardForInstVarAccess
	^ true! !

!SqsConfiguration class methodsFor: 'standard values' stamp: 'tkow 12/12/2008 17:44'!
standardHandlerClass
	^ SqsStandardExternDescriptionHandler! !

!SqsConfiguration class methodsFor: 'standard values' stamp: 'tkow 12/12/2008 17:40'!
standardTableConfiguration
	^ SqsTableConfiguration activeRecordStyle	"SqSTableConfiguration new"! !

!SqsConfiguration class methodsFor: 'standard values' stamp: 'test 1/27/2009 17:38'!
standardWarning
	^ false! !

!SqsConfiguration methodsFor: 'printing' stamp: 'test 1/27/2009 11:29'!
codeForObjectCreation
	| aStream |
	aStream := TextStream on: String new.
	aStream nextPut: $(.
	aStream nextPutAll: self class name , ' new'.
	aStream nextPutAll: String crlf , String tab.
	1 
		to: self class instSize
		do: 
			[ :i | 
			(self instVarAt: i) ifNotNil: 
				[ aStream
					nextPutAll: String cr , String tab;
					nextPutAll: ' ' , (self class allInstVarNames at: i) , ': ';
					store: (self instVarAt: i);
					nextPut: $; ] ].
	aStream nextPutAll: String cr , String tab , ' yourself)'.
	^ aStream contents! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
collectionConfiguration
	^ collectionConfiguration! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
collectionConfiguration: anObject
	collectionConfiguration := anObject! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
connectionSpec
	^ connectionSpec! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
connectionSpec: anObject
	connectionSpec := anObject! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
descriptionHandlerClass
	^ descriptionHandlerClass! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
descriptionHandlerClass: anObject
	descriptionHandlerClass := anObject! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 12/15/2008 19:54'!
environment
	^ environment! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 12/15/2008 19:54'!
environment: anObject
	environment := anObject! !

!SqsConfiguration methodsFor: 'initialization' stamp: 'test 1/27/2009 17:36'!
initialize
	super initialize.
	descriptionHandlerClass := self class standardHandlerClass.
	collectionConfiguration := self class standardCollectionConfiguration.
	environment := self class developmentMode.
	tableConfiguration := self class standardTableConfiguration.
	useInstVarAccessors := self class standardForInstVarAccess.
	warnOnAlteration := self class standardWarning.
	
	! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 14:10'!
tableConfiguration
	^ tableConfiguration! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 14:10'!
tableConfiguration: anObject
	tableConfiguration := anObject! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:19'!
useInstVarAccessors
	^ useInstVarAccessors! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:19'!
useInstVarAccessors: anObject
	useInstVarAccessors := anObject! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'test 1/27/2009 17:34'!
warnOnAlteration
	^ warnOnAlteration! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'test 1/27/2009 17:34'!
warnOnAlteration: anObject
	warnOnAlteration := anObject! !

Object subclass: #SqsConnection
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsConnection commentStamp: 'tkow 10/27/2008 14:41' prior: 0!
A SqSConnection is merely an interface for all the different connection classes used by
the different database server clients. In contrast to the database adapters they are only ment to control
the connections via a common interface even from without the controllers, so that mixed up postgresql,
mysql or other connections can be handled by the same connection manager 

Instance Variables
	connection:		anObject, instance of i.e. JdmConnection

connection
	- xxxxx
!

!SqsConnection class methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 15:28'!
withConnection: aConnection
	^self new
		connection: aConnection;
		yourself
	! !

!SqsConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 14:36'!
close
	self subclassResponsibility! !

!SqsConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 14:41'!
connection
	^ connection! !

!SqsConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 14:41'!
connection: anObject
	connection := anObject! !

!SqsConnection methodsFor: 'connection-control' stamp: 'tkow 10/29/2008 13:25'!
executeQuery: anSqlQuery
	self subclassResponsibility! !

!SqsConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 17:04'!
init
	self subclassResponsibility! !

!SqsConnection methodsFor: 'connection-control' stamp: 'tkow 10/27/2008 14:37'!
isAlive
	self subclassResponsibility.! !

!SqsConnection methodsFor: 'connection-control' stamp: 'tkow 10/29/2008 13:49'!
nextRowFromResult: result
	self subclassResponsibility! !

!SqsConnection methodsFor: 'connection-control' stamp: 'tkow 10/27/2008 17:05'!
reconnect
	self isAlive ifTrue: [
		self close.	
	].
	self init.! !

!SqsConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 15:29'!
rowDictionariesForResultSet: result
	^self subclassResponsibility! !

SqsConnection subclass: #SqsMySqlConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 14:42'!
close
	connection close! !

!SqsMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 10/29/2008 13:32'!
executeQuery: anSqlQuery
	^ (connection createStatement) executeQuery: (anSqlQuery)! !

!SqsMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 17:05'!
init
	connection initialize2! !

!SqsMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 17:14'!
isAlive
	^(connection socket notNil) and: [connection socket isConnected]! !

!SqsMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 10/29/2008 14:04'!
nextRowFromResult: result
	^ result next ifTrue: [
		result currentRowAsDictionary 
	] ifFalse: [
		nil
	]! !

!SqsMySqlConnection methodsFor: 'converting' stamp: 'tkow 12/13/2008 12:21'!
rowDictionariesForResultSet: result 
	| resultDicts |
	resultDicts := OrderedCollection new.
	"damn...I really need a proper mysql driver, this one returns JdmResult or JdmResultSets"
	(result class includesBehavior: JdmResult) ifTrue: [
		^ resultDicts	
	].
	
	"store all data rows in our own structure - this way we can issue new commands upon object creation"
	[ result next ] whileTrue: [ 
		resultDicts add: result currentRowAsDictionary 
	].
	^resultDicts! !

SqsConnection subclass: #SqsPostgresConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsPostgresConnection methodsFor: 'as yet unclassified' stamp: 'tkow 12/9/2008 14:56'!
close
	connection terminate! !

!SqsPostgresConnection methodsFor: 'as yet unclassified' stamp: 'tkow 12/11/2008 13:57'!
executeQuery: anSqlQuery
	| result |
	result := connection execute: anSqlQuery.
	result errorResponse ifNil: [
		^ result		
	] ifNotNil: [
		self error: result errorResponse value
	].! !

!SqsPostgresConnection methodsFor: 'as yet unclassified' stamp: 'tkow 12/9/2008 15:01'!
init
	connection startup! !

!SqsPostgresConnection methodsFor: 'as yet unclassified' stamp: 'tkow 12/9/2008 15:02'!
isAlive
	^ connection isConnected! !

!SqsPostgresConnection methodsFor: 'as yet unclassified' stamp: 'tkow 12/9/2008 15:15'!
rowDictionariesForResultSet: resultSet
	| resultSets |
	
	resultSets := resultSet resultSets at: 1 ifAbsent: [nil].
	^ resultSets ifNil: [
		OrderedCollection new.
	] ifNotNil: [
		resultSets rows collect: [:row |
			row dataKeyedByFieldName
		]
	]
	
	! !

Object subclass: #SqsConnectionManager
	instanceVariableNames: 'connectionPool monitor connectionCount sessionPool conSpecDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

SqsConnectionManager class
	instanceVariableNames: 'ConnectionManager ManagerPool'!

SqsConnectionManager class
	instanceVariableNames: 'ConnectionManager ManagerPool'!

!SqsConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 17:39'!
getInstance
	ConnectionManager ifNil: [
		ConnectionManager := self new.	
	].
	^ConnectionManager! !

!SqsConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 11:50'!
getInstanceFor: aSymbol
	^(ManagerPool ifNil: [
		Dictionary new	
	]) at: aSymbol ifAbsentPut: [self new]! !

!SqsConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 11:50'!
reset
	ManagerPool := Dictionary new.
	ConnectionManager := nil.! !

!SqsConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:43'!
testCategory
	^'SqSave'! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 12/13/2008 10:22'!
adapterForConSpec: cSpec
	| adapterClass |
	"returns a new adapter for the given connection specification"
	adapterClass := Smalltalk 
		at: cSpec driverClass 
		ifAbsent: [self unknownClassError: cSpec driverClass].
	^ adapterClass withConnectionSpecification: cSpec.
! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 12/13/2008 10:37'!
closeAllConnections
	"this will close all connections lying around somewhere in the pool
	and additionally clear the pool and the connection count"
	| con |
	self connectionPool valuesDo: [:conQueue |
		con := conQueue	nextOrNil.
		[con notNil] whileTrue: [
			con close.
			con := conQueue nextOrNil.
		]
	].
	connectionCount := Dictionary new.
	connectionPool := Dictionary new.! !

!SqsConnectionManager methodsFor: 'accessing' stamp: 'tkow 12/13/2008 10:40'!
conSpecDictionary
	^ conSpecDictionary! !

!SqsConnectionManager methodsFor: 'accessing' stamp: 'tkow 12/13/2008 10:40'!
conSpecDictionary: anObject 
	conSpecDictionary := anObject! !

!SqsConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool
	^ connectionPool! !

!SqsConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool: anObject
	connectionPool := anObject! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 10/29/2008 13:39'!
getConnectionFor: anSqsConSpec	
	| queue conCount connection cidStr |
	cidStr := anSqsConSpec connectionIdentityString.
	monitor critical: [
		conCount := connectionCount at: cidStr ifAbsentPut: 0.
		queue := connectionPool at: cidStr ifAbsentPut: [SharedQueue2 new].	
	].
	connection := queue nextOrNil.
	monitor critical: [
		(connection isNil and: [conCount < anSqsConSpec maxConnections]) ifTrue: [
			queue nextPut: ((Smalltalk at: anSqsConSpec driverClass) newConnectionFor: anSqsConSpec).
			connectionCount at: cidStr put: (conCount + 1).
			connection := queue next
		].
	].
	connection ifNil: [
		connection := queue next	
	].
	^connection
	
	! !

!SqsConnectionManager methodsFor: 'initialization' stamp: 'tkow 12/13/2008 10:40'!
initialize
	conSpecDictionary := Dictionary new.
	connectionPool := Dictionary new.
	monitor := Monitor new.
	connectionCount := Dictionary new.
	sessionPool := WeakIdentityKeyDictionary new! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 12/13/2008 10:38'!
noConSpecFoundErrorFor: aString 
	self error: 'No connection Specification found for ' , aString! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 10/29/2008 13:10'!
releaseConnection: aConnection for: anSqsConSpec	
	| queue |
	queue := connectionPool
				at: anSqsConSpec connectionIdentityString 
				ifAbsent: [self error: 'How did you get that connection anyway?'].	
	queue nextPut: aConnection
	! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 12/12/2008 17:35'!
resetConnections
	SqsConnection allInstances do: [ :sqsCon | sqsCon reconnect ]! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 12/13/2008 10:38'!
sessionForCategory: aCategoryName 
	| cSpec |
	cSpec := self conSpecDictionary 
		at: aCategoryName
		ifAbsent: [ self noConSpecFoundErrorFor: aCategoryName ].
	^ self sessionForConSpec: cSpec! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 12/13/2008 10:38'!
sessionForClass: aClass 
	| stringsToTry cSpec currentString |
	stringsToTry := OrderedCollection with: aClass name.
	stringsToTry addAll: (aClass category asString subStrings: '-').
	cSpec := nil.
	[ stringsToTry notEmpty and: [ cSpec isNil ] ] whileTrue: 
		[ currentString := stringsToTry removeFirst.
		cSpec := self conSpecDictionary 
			at: currentString
			ifAbsent: [ nil ] ].
	cSpec 
		ifNil: [ self noConSpecFoundErrorFor: aClass name ]
		ifNotNil: [ ^ self sessionForConSpec: cSpec ]! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 12/13/2008 11:11'!
sessionForConSpec: cSpec 
	"simply return the session of the current thread and set the new adapter
	 accordingly. Since the adapter doesn't really have state, that shouldn't be a problem"
	| session |
	session := self sessionPool 
		at: Processor activeProcess
		ifAbsentPut: [ SqsSession new ].
	"we should only set the adapter if the current one is for another connection"
	(session connectionIdentityString = cSpec connectionIdentityString) ifFalse: [
		session sqsDbAdapter: (self adapterForConSpec: cSpec).		
	].
	^ session! !

!SqsConnectionManager methodsFor: 'accessing' stamp: 'tkow 12/13/2008 10:38'!
sessionPool
	^ sessionPool! !

!SqsConnectionManager methodsFor: 'accessing' stamp: 'tkow 12/13/2008 10:38'!
sessionPool: anObject 
	sessionPool := anObject! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 12/13/2008 10:37'!
setConSpec: aConnectionSpecification for: aString 
	"setUp the connection specification for a class or category. so basically without setting up a 
	connection specification for a class or category, the nice and easy #save will not work"
	self conSpecDictionary 
		at: aString asString
		put: aConnectionSpecification! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 12/9/2008 16:41'!
unknownClassError: className
	self error: 'The driver class: ', className asString, ' is unknown in this image'.! !

Object subclass: #SqsConnectionSpecification
	instanceVariableNames: 'username password database port hostname driverClass maxConnections connectionIdentityString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 09:54'!
standardQueueSize
	^20! !

!SqsConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 12/12/2008 17:37'!
user: aUsername password: aPassword database: aDatabaseName 
	"just for the lazy people like me - creates a mysql connection..."
	^ self new
		username: aUsername;
		password: aPassword;
		port: 3306;
		database: aDatabaseName;
		driverClass: #SqsMysqlAdapter;
		hostname: 'localhost'! !

!SqsConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: 'localhost'.! !

!SqsConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName hostname: aHostname driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: aHostname.! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:45'!
connectionIdentityString
	connectionIdentityString ifNil: [
		connectionIdentityString := (self driverClass asString),'#',(self username),'@',(self hostname),':',(self port asString),'/',(self database)
	].
	^connectionIdentityString
	! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database
	^ database! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database: anObject
	database := anObject! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass
	^ driverClass! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass: anObject
	driverClass := anObject! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname
	^ hostname! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname: anObject
	hostname := anObject! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tkow 10/27/2008 09:55'!
maxConnections
	^maxConnections ifNil: [self class standardQueueSize]! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tkow 10/27/2008 09:53'!
maxConnections: anObject
	maxConnections := anObject! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password
	^ password! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password: anObject
	password := anObject! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port
	^ port! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port: anObject
	port := anObject! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username
	^ username! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username: anObject
	username := anObject! !

Object subclass: #SqsDatabaseAdapter
	instanceVariableNames: 'connection connectionSpecification isInTransaction usesConnectionPool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsDatabaseAdapter class methodsFor: 'special-operations' stamp: 'test 1/25/2009 15:09'!
cascadeAction
	^ #CASCADE! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 12/11/2008 17:40'!
columnTableSeperator
	^ '.'! !

!SqsDatabaseAdapter class methodsFor: 'special-operations' stamp: 'test 1/27/2009 10:42'!
completeCount
	^ 'COUNT(*)'! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:55'!
defaultColumn
	^'Default'! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:55'!
extraColumn
	^'Extra'! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:53'!
fieldNameColumn
	^'Field'! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:54'!
keyColumn
	^'Key'! !

!SqsDatabaseAdapter class methodsFor: 'instance creation' stamp: 'tkow 10/27/2008 15:08'!
newConnectionFor: anSqsConSpec
	"this method is meant to create new instances of the designated connection class
	for the database client of the corresponding flavour - so for a Mysql adapter this should return
	an SqSMySqlConnection holding a JdmConnection. For PostgreSql an SqSPostgreSqlConnection holding
	the postgreSql connection delivered with the postgre client"
	self subclassResponsibility! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:53'!
nullColumn
	^'Null'! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:53'!
typeColumn
	^'Type'! !

!SqsDatabaseAdapter class methodsFor: 'instance creation' stamp: 'tkow 10/27/2008 10:34'!
withConnectionSpecification: anSqsConSpec
	^self new
		connectionSpecification: anSqsConSpec;
		yourself! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:42'!
addColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToAddColumn: column).	
		]
	"]"
	! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 9/16/2008 22:38'!
addEntries: addedIds inJoinTable: aDescription forOwnerId: oid
	addedIds do: [:ids |
		| sql |
		sql	:= self queryToAddEntry: ids toJoinTable: aDescription forOwnerId: oid.
		self executeQuery: sql.
	]	! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/13/2008 11:48'!
allTableNames
	| resultDicts tableNames |
	resultDicts := self executeQuery: self queryForAllUserTables.

	tableNames := OrderedCollection new.
	resultDicts do: [:dict | 
		dict valuesDo: [:tableName | 
			tableNames add: tableName
		]
	].
	^ tableNames! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:47'!
alterColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToAlterColumn: column).	
		]
	"]"
	! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/15/2008 10:23'!
beginTransaction
	isInTransaction := true.
	self startTransaction.! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:32'!
boolean
	^'BOOLEAN'.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/11/2008 14:22'!
checkTableExistance: aTableName 
	| |
	^ self allTableNames anySatisfy: [:name | name = aTableName].
! !

!SqsDatabaseAdapter methodsFor: 'data-preparation' stamp: 'tkow 12/11/2008 18:24'!
columnName: columnName aliasedWith: aliasName
	^ aliasName, self class columnTableSeperator, columnName! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/15/2008 10:26'!
commitTransaction
	isInTransaction := false.
	self executeQuery: self queryToCommit! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 12/5/2008 13:38'!
completeWhereStatementFor: anSqsQuery
	| sql aliasedTable |
	sql := ' WHERE (', anSqsQuery whereBuffer, ')'.
	aliasedTable := anSqsQuery valueTables first.
	
	anSqsQuery ignoreTypeField ifFalse: [
		sql := sql, ' AND ('.
		sql := sql, ((aliasedTable queryClass withAllSubclasses collect: [:aClass |
			(aliasedTable aliasedName), '.', (aliasedTable originalTable typeColumn columnName),	' = ', aClass name asSqlValueString
		]) join: ' OR ').	
		sql := sql, ')'.
	].
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'connection-control' stamp: 'tkow 10/30/2008 15:05'!
connection
	^connection! !

!SqsDatabaseAdapter methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:37'!
connection: anObject
	connection := anObject! !

!SqsDatabaseAdapter methodsFor: 'connection-control' stamp: 'tkow 10/27/2008 10:37'!
connectionIdentityString
	^self connectionSpecification connectionIdentityString! !

!SqsDatabaseAdapter methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:37'!
connectionSpecification
	^ connectionSpecification! !

!SqsDatabaseAdapter methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:37'!
connectionSpecification: anObject
	connectionSpecification := anObject! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 1/18/2009 17:17'!
createTable: anSqSTable 
	| query |
	query := self queryToCreateTable: anSqSTable.
	self executeQuery: query.! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
date
	^'DATE'.! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
dateAndTime
	^'DATETIME'.
	! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'tkow 1/20/2009 14:29'!
decimal
	^ 'DECIMAL'! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
decimalIntegerSize: m scale: d
	^'DECIMAL('m asString,',',d asString,')'.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 9/16/2008 21:32'!
deleteEntriesFromJoinTable: collectionDescription forObjectId: oid 
	| sql |
	sql := self 
		queryToRemoveEntriesFromJoinTable: collectionDescription
		forObjectId: oid.
	self executeQuery: sql! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
double
	^'DOUBLE'.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'test 12/13/2008 12:04'!
executeQuery: anSqlQuery
	| result rowDicts |
	self log: anSqlQuery.
	self getConnectionIfNecessary.
	result := [connection executeQuery: (anSqlQuery)] ifError: [ :err |
		self freeConnection.
		self error: err
	].
	rowDicts := connection rowDictionariesForResultSet: result.
	self freeConnection.
	^ rowDicts
	! !

!SqsDatabaseAdapter methodsFor: 'data-preparation' stamp: 'tkow 12/12/2008 17:52'!
explicitColumnsOfTable: anSqSQueryTable 
	| sql classTable aliasName childQueryTable aliasedColumns columnAlias |
	classTable := anSqSQueryTable originalTable.
	aliasName := anSqSQueryTable aliasedName.
	aliasedColumns := OrderedCollection new.
	classTable columns do: 
		[ :column | 
		(column = classTable oidColumn and: [ classTable parent notNil ]) ifFalse: 
			[ columnAlias := self 
				columnName: column columnName
				aliasedWith: aliasName.
			aliasedColumns add: classTable tableName , '.' , column columnName , ' AS ' , columnAlias ] ].
	sql := aliasedColumns join: ', '.
	classTable children do: 
		[ :childTable | 
		childQueryTable := SqsQueryTable 
			table: childTable
			alias: anSqSQueryTable aliasSuffix
			field: nil.
		sql := sql , ', ' , (self explicitColumnsOfTable: childQueryTable) ].
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
float
	^'FLOAT'.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/12/2008 17:38'!
freeConnection
	(isInTransaction not and: [ usesConnectionPool ]) ifTrue: 
		[ connection ifNotNil: 
			[ SqsConnectionManager getInstance 
				releaseConnection: connection
				for: connectionSpecification.
			connection := nil ] ]! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/12/2008 17:38'!
getConnectionIfNecessary
	(connection isNil and: [ usesConnectionPool ]) ifTrue: 
		[ connection := SqsConnectionManager getInstance getConnectionFor: connectionSpecification.
		connection isAlive ifFalse: [ connection reconnect ] ]! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/15/2008 10:25'!
getSimpleCollectionDescribedBy: descr forObject: anObject 
	| sql resultDicts results value |
	sql := self 
		queryForSimpleValuesOfCollection: descr
		ofObjectId: anObject oid.
	resultDicts := self executeQuery: sql.
	results := OrderedCollection new.
	resultDicts do: 
		[ :resultRow | 
		value := resultRow 
			at: descr referenceColumn columnName
			ifAbsent: [ nil ].
		results add: value ].
	^ results! !

!SqsDatabaseAdapter methodsFor: 'initialization' stamp: 'tkow 12/12/2008 17:42'!
initialize
	super initialize.
	isInTransaction := false.
	usesConnectionPool := true.
	objectCache := SqsObjectCache new! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
integer
	^'INTEGER'.! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'tkow 9/24/2008 16:18'!
largeInteger
	^'TEXT'.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/9/2008 16:45'!
lastOidFromTable: aTable
	self subclassResponsibility! !

!SqsDatabaseAdapter methodsFor: 'logging' stamp: 'tk 7/29/2008 11:57'!
log: aString
	"TODO: viable solution for logging - Transcript is just weigh to slow"
	Transcript show: '+++++++++++++++++++';
		show: String cr;
		show: aString;
		show: String cr.! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
mediumInteger
	^'MEDIUMINT'.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 9/16/2008 22:37'!
moveEntries: movedIds inJoinTable: aDescription forOwnerId: oid
	| sql |
	movedIds do: [:ids |
		sql := self queryToUpdateEntries: ids inJoinTable: aDescription forOwnerId: oid.
		self executeQuery: (sql).
	]
	! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/13/2008 11:46'!
performSearch: anSqsQuery withLimit: limit
	| sql |
	sql := self queryForSearch: anSqsQuery withLimit: limit.
	^ self executeQuery: sql.
	! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 11/27/2008 13:51'!
queryAliasedTableInFromClause: aliasedTable

	| sql joinTables joinConditions |
	sql := aliasedTable originalTable tableName, ' AS ', aliasedTable aliasedName.
	
	joinTables := OrderedCollection new.
	joinConditions := OrderedCollection new.
	
	"join them consequitvely - when performance issues arise, change the join order"
	aliasedTable tableLinks do: [:tableLink |
		
		sql := sql, ' ', tableLink joinDirection, ' JOIN '.
		sql := sql, '(',(self queryAliasedTableInFromClause: tableLink toTable), ') ON ('.
		
		sql := sql, ((tableLink fromFields collectWithIndex: [:field :index |
			aliasedTable aliasedName,'.', field ,' = ', tableLink toTable aliasedName, '.', (tableLink toFields at: index).
		]) join: ' AND ').
		sql := sql, ')'
	].
	^ sql ! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/11/2008 14:15'!
queryForAllUserTables
	^ self subclassResponsibility! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tk 7/10/2008 17:15'!
queryForForeignKeyConstraint: aForeignKeyDescription ofColumn: aColumnName
	| sql |
	sql := 'FOREIGN KEY (',aColumnName,') REFERENCES '.
	sql := sql, aForeignKeyDescription referencedTable,'(', aForeignKeyDescription referencedColumns first,') '.
	aForeignKeyDescription deleteActions ifNotEmpty: [sql := sql, 'ON DELETE'].
	aForeignKeyDescription deleteActions do: [:action | sql := sql, ' ',action].
	aForeignKeyDescription updateActions ifNotEmpty: [sql := sql, 'ON UPDATE'].
	aForeignKeyDescription updateActions do: [:action | sql := sql, ' ',action].
	^sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'wh 8/11/2006 09:23'!
queryForRollback
	^'ROLLBACK'.! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'test 1/26/2009 17:08'!
queryForSearch: anSqsQuery withLimit: limit
	| sql |
	sql := 'SELECT '.
	anSqsQuery distinct ifTrue: [sql := sql, ' DISTINCT '].
	
	anSqsQuery valueTables do: [:aliasedTable |
		sql := sql, (self explicitColumnsOfTable: aliasedTable)
	].
	sql := sql,' FROM '.

	sql := sql, ((anSqsQuery queryTables collect: [:aliasedTable |
		(self queryAliasedTableInFromClause: aliasedTable)
	]) join: ', ').

	sql := sql, (self completeWhereStatementFor: anSqsQuery).
	
	anSqsQuery orderBy ifNotNil: [
		sql := sql, ' ORDER BY ', anSqsQuery orderBy
	].
	
	limit ifNotNil: [
		sql := sql, ' LIMIT ', limit asString
	].
	^sql
	! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'test 1/26/2009 14:45'!
queryForSimpleValuesOfCollection: descr ofObjectId: oid 
	| sql |
	sql := 'SELECT * FROM ' , descr tableName.
	sql := sql , ' WHERE ' , descr ownerColumn columnName , ' = ' , oid asSqlValueString.
	descr maintainOrder ifTrue: [ sql := sql , ' ORDER BY ' , descr configuration orderField ].
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 9/18/2008 16:54'!
queryToAddColumn: aColumn
	| sql |
	sql := 'ALTER TABLE ', aColumn tableName, ' ADD COLUMN '.
	sql := sql, aColumn columnName, ' ', (self perform: aColumn sqlType).
	aColumn canBeNull ifFalse: [
		sql := sql, ' NOT NULL'	
	].
	^sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'test 1/26/2009 14:45'!
queryToAddEntry: ids toJoinTable: aDescription forOwnerId: oid 
	"orderNumber := movedIds at: 2.
	newObjectId := movedIds at: 1."
	| sql |
	sql := 'INSERT INTO ' , aDescription tableName , '('.
	sql := sql , aDescription ownerColumn columnName , ', ' , aDescription referenceColumn columnName.
	aDescription maintainOrder ifTrue: [ sql := sql , ', ' , aDescription configuration orderField ].
	sql := sql , ') VALUES (' , oid asString , ','.
	sql := sql , ((ids at: 1) 
			ifNil: [ aDescription configuration nilValue ]
			ifNotNil: [ ids at: 1 ]) asSqlValueString , ', '.
	sql := sql , (ids at: 2) asSqlValueString , ')'.
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 9/18/2008 16:54'!
queryToAlterColumn: aColumn
	| sql |
	sql := 'ALTER TABLE ', aColumn tableName, ' MODIFY '.
	sql := sql, aColumn columnName, ' ', (self perform: aColumn sqlType).
	aColumn canBeNull ifFalse: [
		sql := sql, ' NOT NULL'	
	].
	^sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 12/15/2008 10:25'!
queryToCommit
	^ 'COMMIT'! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 11/3/2008 18:42'!
queryToCreateColumn: column
	| sql |
	sql := column columnName, ' ',(self perform: column sqlType).
	column canBeNull ifFalse: [
		sql := sql, ' NOT NULL'.
	].
	column autoIncrement ifTrue: [
		sql := sql, ' AUTO_INCREMENT '
	].
	column foreignKey ifNotNil: [
		sql := sql, ', ', (self queryForForeignKeyConstraint: column foreignKey ofColumn: column columnName)
	].
	^sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 12/11/2008 15:07'!
queryToCreateOidColumn: anSqsColumn
	^ self queryToCreateColumn: anSqsColumn! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 12/11/2008 15:06'!
queryToCreateTable: anSqSTable
	| sql primaryKeyColumns |
	sql := 'CREATE TABLE ' , anSqSTable tableName , ' ('.

	sql := sql, ((anSqSTable columns collect: [:column |
		column = anSqSTable oidColumn ifTrue: [
			self queryToCreateOidColumn: column
		] ifFalse: [
			self queryToCreateColumn: column
		]	
	]) join: ', ').

	primaryKeyColumns := (anSqSTable columns select: [ :column | column isPrimaryKey ]) collect: [ :column | column columnName ].
	sql := sql , ', PRIMARY KEY (' , (primaryKeyColumns join: ', ') , ')'.
	sql := sql , ')'.
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 9/29/2008 14:46'!
queryToInsertColumns: columnDict inTable: aTableName
	| sql keys values |
	sql := 'INSERT INTO ', aTableName,' ('.
	keys := ''.
	values := ''.
	columnDict associationsDo: [:assoc |
		keys := keys, assoc key, ', '.
		values := values, assoc value asString, ', '.	
	].
	sql := sql, (keys allButLast: 2), ') VALUES (', (values allButLast: 2), ')'.
	^sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:46'!
queryToRemoveColumn: aColumn
	^'ALTER TABLE ',aColumn tableName,' DROP COLUMN ', aColumn columnName.! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'test 1/26/2009 14:45'!
queryToRemoveEntriesFromJoinTable: collectionDescr forObjectId: oid 
	| sql |
	sql := 'DELETE FROM ' , collectionDescr tableName , ' WHERE '.
	sql := sql , collectionDescr ownerColumn columnName , ' = ' , oid asSqlValueString.
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'test 1/26/2009 14:45'!
queryToRemoveIds: ids ofColumn: columnName fromTable: aDescription forOwnerId: oid 
	| sql |
	sql := 'DELETE FROM ' , aDescription tableName , ' WHERE '.
	sql := sql , columnName , ' IN (' , (ids join: ',') , ') AND '.
	sql := sql , aDescription ownerColumn columnName , ' = ' , oid asString.
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 11/10/2008 15:28'!
queryToRemoveObjectWithId: oid fromTable: aTable
	
	^'DELETE FROM ', aTable tableName,' WHERE ',aTable oidColumn columnName,' = ',oid asString.! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 9/18/2008 16:55'!
queryToRenameColumns: columnsCollection
	| oldColumn sql newColumn |
	oldColumn := columnsCollection first.
	newColumn := columnsCollection at: 2.
	sql := 'ALTER TABLE ', oldColumn tableName, ' CHANGE '.
	sql := sql, oldColumn columnName, ' ', newColumn columnName, ' ', (self perform: newColumn sqlType).
	^sql 
	! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/5/2008 14:05'!
queryToRenameTable: oldName to: newName
	^ 'ALTER TABLE ',oldName, ' RENAME TO ', newName
! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 12/15/2008 10:24'!
queryToStartTransaction
	^ 'START TRANSACTION'! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'test 1/26/2009 14:45'!
queryToUpdateEntries: movedIds inJoinTable: aDescription forOwnerId: oid 
	"orderNumber := movedIds at: 2.
	newObjectId := movedIds at: 1."
	| sql |
	sql := 'UPDATE ' , aDescription tableName , '	SET '.
	sql := sql , aDescription referenceColumn columnName , ' = ' , ((movedIds at: 1) 
			ifNil: [ aDescription configuration nilValue ]
			ifNotNil: [ movedIds at: 1 ]) asSqlValueString.
	sql := sql , ' WHERE ' , aDescription ownerColumn columnName , ' = ' , oid asString.
	sql := sql , ' AND ' , aDescription configuration orderField , ' = ' , (movedIds at: 2) asString.
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 11/10/2008 14:34'!
queryToUpdateFields: columnDict ofObjectWithId: oid inTable: aTable
	| sql |
	sql := 'UPDATE ' , aTable tableName , ' SET '.
	columnDict associationsDo: [:assoc | sql := sql , assoc key , ' = ' , assoc value asString , ', '].
	sql := (sql allButLast: 2) 	, ' WHERE ', aTable oidColumn columnName ,' = ' , oid asString.
	^sql! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:45'!
removeColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToRemoveColumn: column).	
		]
	"]"
	! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 11/10/2008 14:45'!
removeEntries: deletedIds fromJoinTable: aDescription forOwnerId: oid
	| sql ids columnName |
	aDescription maintainOrder ifTrue: [
		ids := deletedIds collect: [: dids | dids last].
		columnName := aDescription configuration orderField.
	] ifFalse: [
		ids := deletedIds collect: [: dids | dids first].
		columnName := aDescription referenceColumn columnName
	].
	sql := self queryToRemoveIds: ids ofColumn: columnName fromTable: aDescription forOwnerId: oid.
	self executeQuery: sql.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 11/10/2008 13:58'!
removeObjectWithId: oid fromTable: aSqSTable
	| sql |
	" this method has to be overwritten if the database can not guarantee that the entries
	in all available class table are removed when one object is being removed"
	sql := self queryToRemoveObjectWithId: oid fromTable: aSqSTable baseTable.
	self executeQuery: (sql).! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:41'!
renameColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:columnPair |
			self executeQuery: (self queryToRenameColumns: columnPair).	
		]
	"]"
	! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/5/2008 14:04'!
renameTable: oldName to: newName
	| sql |
	sql := self queryToRenameTable: oldName to: newName.
	self executeQuery: sql.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 1/18/2009 17:16'!
resetDatabase
	| tables retries curErrors |
	tables := self allTableNames.
	retries := tables copy.
	[ retries isEmpty ] whileFalse: 
		[ curErrors := OrderedCollection new.
		retries do: 
			[ :table | 
			[self executeQuery: 'DROP TABLE IF EXISTS ' , table]
				on: Error
				do: [ curErrors add: table ] ].
		retries := curErrors reversed ].! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tk 7/18/2008 16:22'!
rollback
	"self localCache do:[:object | object rollback ].
	self rollbackDbTransaction."
	"self executeQuery: 'ROLLBACK'"! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'wh 8/11/2006 09:24'!
rollbackDbTransaction
	self executeQuery:(self queryForRollback) .! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'test 1/26/2009 14:45'!
searchForCollectionDescribedBy: descr ofObject: anObject 
	| collectionConf referenceClassInfo referenceConf query classTable queryTable joinTable joinQueryTable refIdField childQueryTable childLink |
	collectionConf := anObject configuration collectionConfiguration.
	referenceClassInfo := SqsClassInfo for: (Smalltalk at: descr referencedClass).
	referenceConf := referenceClassInfo configuration tableConfiguration.
	query := SqsQuery on: referenceClassInfo currentClass.
	query whereBuffer: descr tableName , '.' , descr ownerColumn columnName , ' = ' , anObject oid asSqlValueString.
	query orderBy: collectionConf orderField.
	classTable := anObject classInfo classTable baseTable.
	queryTable := SqsQueryTable 
		table: classTable
		alias: ''
		field: ''
		class: anObject classInfo baseClass.
	joinTable := SqsTable new.
	joinTable tableName: descr tableName.
	joinQueryTable := SqsQueryTable 
		table: joinTable
		alias: ''
		field: ''
		class: nil.
	refIdField := referenceConf idField.
	joinQueryTable tableLinks add: (SqsTableLink 
			table: queryTable
			fromField: collectionConf valueField
			toField: refIdField
			direction: 'LEFT OUTER').
	classTable allChildTables do: 
		[ :childTable | 
		childQueryTable := SqsQueryTable 
			table: childTable
			alias: ''
			field: nil.
		childLink := SqsTableLink 
			table: childQueryTable
			fromField: refIdField
			toField: refIdField
			direction: 'LEFT OUTER'.
		queryTable tableLinks add: childLink ].
	query valueTables add: queryTable.
	query queryTables add: joinQueryTable.
	query ignoreTypeField: true.
	^ query! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/13/2008 11:46'!
showFieldsOfTable: aTableName
	| |
	^ self executeQuery: ('SHOW FIELDS FROM ', aTableName).
! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
smallInteger
	^'SMALLINT'! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/15/2008 10:24'!
startTransaction
	self executeQuery: self queryToStartTransaction! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/9/2008 16:45'!
storeColumns: columnDict inTable: aTable
	self storeColumns: columnDict inTable: aTable andReturnOId: false.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/9/2008 16:45'!
storeColumns: columnDict inTable: aTable andReturnOId: aBool
	"columnDict is a Dictionary where a SqSaveColumnDescription points to the stored value"
	| sql |
	sql := self queryToInsertColumns: columnDict inTable: aTable tableName.
	self executeQuery: (sql).
	aBool ifTrue: [
		^self lastOidFromTable: aTable
	].! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
string
	^self stringWithLength: 254.
	! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 23:21'!
stringWithLength: m
	^'VARCHAR(',m asString,')'.! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
text
	^'TEXT'.! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
time
	^'TIME'.! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/16/2006 22:18'!
unsignedInteger
	"The SQL standard does not support unsigned Integer 
		imagine my suprise "
	^'INTEGER '.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 11/10/2008 13:57'!
updateFields: columnDict ofObjectWithId: oid inTable: aTable
	| sql |
	sql := self queryToUpdateFields: columnDict ofObjectWithId: oid inTable: aTable. 
	self executeQuery: sql! !

!SqsDatabaseAdapter methodsFor: 'accessing' stamp: 'tkow 10/30/2008 15:10'!
usesConnectionPool
	^ usesConnectionPool! !

!SqsDatabaseAdapter methodsFor: 'accessing' stamp: 'tkow 10/30/2008 15:10'!
usesConnectionPool: anObject
	usesConnectionPool := anObject! !

SqsDatabaseAdapter subclass: #SqsMysqlAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsMysqlAdapter class methodsFor: 'instance creation' stamp: 'tkow 12/12/2008 17:36'!
newConnectionFor: anSqsConSpec 
	| spec connection |
	Socket initializeNetwork.
	spec := JdmConnectionSpec new initialize
		user: anSqsConSpec username;
		password: anSqsConSpec password;
		host: (NetNameResolver addressForName: anSqsConSpec hostname);
		database: anSqsConSpec database;
		port: anSqsConSpec port.
	connection := JdmConnection on: spec.
	^ SqsMySqlConnection withConnection: connection! !

!SqsMysqlAdapter methodsFor: 'as yet unclassified' stamp: 'tkow 12/11/2008 17:42'!
columnName: columnName aliasedWith: aliasName
	^ (super columnName: columnName aliasedWith: aliasName) asSqlValueString! !

!SqsMysqlAdapter methodsFor: 'database operations' stamp: 'tk 7/21/2008 14:55'!
lastOidFromTable: aTable
	 | oid |
	"MySQL will only retrun the last ID. Postgres needs the table part"  
	(self executeQuery: 'SELECT LAST_INSERT_ID() AS OID')
		collect: [:table |
			oid := (table at: 'OID') asString asInteger. 	
		].
	^oid.
	! !

!SqsMysqlAdapter methodsFor: 'as yet unclassified' stamp: 'tkow 12/11/2008 14:16'!
queryForAllUserTables
	^ 'SHOW TABLES'! !

!SqsMysqlAdapter methodsFor: 'sql statements' stamp: 'tkow 9/19/2008 13:47'!
queryToCreateJoinTable: tableDescription
	^ (super queryToCreateJoinTable: tableDescription) , ' ENGINE=INNODB'.! !

!SqsMysqlAdapter methodsFor: 'sql statements' stamp: 'tkow 10/7/2008 16:25'!
queryToCreateTable: anSqSTable
	^ (super queryToCreateTable: anSqSTable) , ' ENGINE=INNODB'.! !

SqsDatabaseAdapter subclass: #SqsPostgresAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsPostgresAdapter class methodsFor: 'as yet unclassified' stamp: 'tkow 12/11/2008 17:41'!
columnTableSeperator
	^ '__'! !

!SqsPostgresAdapter class methodsFor: 'as yet unclassified' stamp: 'tkow 12/12/2008 17:36'!
newConnectionFor: anSqsConSpec 
	| spec connection |
	spec := PGConnectionArgs 
		hostname: anSqsConSpec hostname
		portno: anSqsConSpec port
		databaseName: anSqsConSpec database
		userName: anSqsConSpec username
		password: anSqsConSpec password.
	connection := PGConnection new.
	connection connectionArgs: spec.
	connection startup.
	^ SqsPostgresConnection withConnection: connection! !

!SqsPostgresAdapter class methodsFor: 'as yet unclassified' stamp: 'tkow 12/11/2008 14:19'!
systemSchemaNames
	^ #('dbo' 'information_schema' 'pg_catalog' 'sys')! !

!SqsPostgresAdapter methodsFor: 'as yet unclassified' stamp: 'tkow 12/12/2008 16:37'!
date
	^'DATE'! !

!SqsPostgresAdapter methodsFor: 'as yet unclassified' stamp: 'tkow 12/12/2008 16:06'!
dateAndTime
	^'TIMESTAMPZ'! !

!SqsPostgresAdapter methodsFor: 'as yet unclassified' stamp: 'tkow 12/13/2008 11:45'!
lastOidFromTable: aTable 
	| rowDicts oidField oidSequence |
	oidField := (SqsClassInfo for: (Smalltalk at: aTable associatedClass)) configuration tableConfiguration idField.
	oidSequence := '"' , aTable tableName asLowercase , '_' , aTable oidColumn columnName , '_seq"'.
	rowDicts := self executeQuery: 'SELECT currval(''' , oidSequence , ''') AS ' , oidField.
	^ rowDicts 
		ifEmpty: [ nil ]
		ifNotEmpty: 
			[ (rowDicts at: 1) 
				at: oidField
				ifAbsent: [ nil ] ]! !

!SqsPostgresAdapter methodsFor: 'as yet unclassified' stamp: 'tkow 12/11/2008 14:20'!
queryForAllUserTables
	| sql |
	sql := 'SELECT table_name FROM information_schema.tables WHERE table_schema NOT IN'.
	sql := sql, ' (' ,((self class systemSchemaNames collect: [:name | name asSqlValueString]) join: ', ') ,')'.
	^ sql! !

!SqsPostgresAdapter methodsFor: 'as yet unclassified' stamp: 'tkow 12/11/2008 15:11'!
queryToCreateOidColumn: anSqsColumn
	^ anSqsColumn columnName, ' SERIAL'! !

!SqsPostgresAdapter methodsFor: 'as yet unclassified' stamp: 'tkow 12/12/2008 16:37'!
time
	^'TIME'! !

Object subclass: #SqsDescriptionHandler
	instanceVariableNames: 'currentObject classInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsDescriptionHandler commentStamp: 'tk 5/22/2008 10:47' prior: 0!
A TKSaveDescriptionHandler is an abstract base class for the description handlers of the TKSave framework.
It defines methods that subclasses have to implement in order to be able to create, update, delete and read the descriptions of TKSaveBase subclasses.
It is therefore ment to provide a clean abstraction for the problem of describing the way objects are being stored within the database.

Instance Variables
	sampleObject:		anObject that determines how the descriptors will loke like
			
sampleObject
	- xxxxx!

!SqsDescriptionHandler class methodsFor: 'cached-creation' stamp: 'test 10/6/2008 18:30'!
forClassInfo: aClassInfo
	^ (self new)
		classInfo: aClassInfo;
		yourself! !

!SqsDescriptionHandler class methodsFor: 'cached-creation' stamp: 'tkow 9/30/2008 11:33'!
forObject: aSampleObject 
	^ (self new) 
		currentObject: aSampleObject;
		classInfo: (aSampleObject classInfo);
		yourself! !

!SqsDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 11/11/2008 01:57'!
sqlTypeFunction
	^#sqsType! !

!SqsDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/15/2008 14:40'!
sqlValueStringFunction
	^#asSqlValueString! !

!SqsDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/18/2008 16:12'!
standardSqlType
	^#integer! !

!SqsDescriptionHandler methodsFor: 'object-transformation' stamp: 'test 1/24/2009 15:35'!
adaptObject: anObject toSpecificationOfInstVar: ivarName 
	| description |
	description := self sqsDescriptionForInstVar: ivarName.
	^ description 
		ifNil: [ nil ]
		ifNotNil: 
			[ description associatedClass 
				ifNil: 
					[ description describesCollection 
						ifTrue: 
							[ SqsStorage 
								createCollectionProxyFor: ivarName
								with: anObject
								in: self currentObject storedObject
								description: description ]
						ifFalse: 
							[ self 
								transformObject: anObject
								toMatchDescription: description ] ]
				ifNotNil: 
					[ SqsStorage 
						createProxyFor: ivarName
						with: anObject
						in: self currentObject storedObject ] ]! !

!SqsDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/29/2008 18:01'!
classInfo
	^ classInfo! !

!SqsDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/29/2008 18:01'!
classInfo: anObject
	classInfo := anObject! !

!SqsDescriptionHandler methodsFor: 'table-information' stamp: 'test 1/24/2009 15:35'!
classTableColumns
	| variables columnDescription columns |
	variables := self classInfo currentClass instVarNames difference: (self unpersistedInstVarsOf: self classInfo currentClass).
	columns := OrderedCollection new.
	variables do: 
		[ :var | 
		columnDescription := self sqsDescriptionForInstVar: var.
		columnDescription 
			ifNil: 
				[ columns add: (SqsColumn new
						columnName: var decamelized;
						tableName: self classInfo tableName;
						sqlType: self class standardSqlType;
						linkedVariable: var;
						yourself) ]
			ifNotNil: 
				[ columnDescription describesCollection ifFalse: [ columns add: columnDescription ] ] ].
	^ columns! !

!SqsDescriptionHandler methodsFor: 'code-compilation' stamp: 'tkow 9/12/2008 10:53'!
compileMethodCode: code intoClass: aClass
	(aClass organization categories includes: self descriptorMethodCategory)
		ifTrue: [aClass organization addCategory: self descriptorMethodCategory].
	aClass class compile: code classified: self descriptorMethodCategory! !

!SqsDescriptionHandler methodsFor: 'code-compilation' stamp: 'tkow 10/10/2008 11:07'!
createDescriptions
	"overwrite me to enable automatic creation of descriptions"
	! !

!SqsDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:06'!
currentObject
	^ currentObject! !

!SqsDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:06'!
currentObject: anObject 
	currentObject := anObject! !

!SqsDescriptionHandler methodsFor: 'private' stamp: 'tk 5/22/2008 10:52'!
descriptorMethodCategory
	^'auto-generated-description'! !

!SqsDescriptionHandler methodsFor: 'object-information' stamp: 'test 1/24/2009 15:35'!
directlyReferencedObjects
	| referencedObjects descr ivarValue |
	referencedObjects := OrderedCollection new.
	self persistedInstanceVariables do: 
		[ :ivn | 
		descr := self sqsDescriptionForInstVar: ivn.
		descr ifNotNil: 
			[ descr associatedClass ifNotNil: 
				[ ivarValue := self getIvarValue: ivn.
				ivarValue ifNotNil: [ referencedObjects add: ivarValue ] ] ] ].
	^ referencedObjects! !

!SqsDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 9/30/2008 14:11'!
getIvarValue: ivn 
	| |
	^ self useInstVarAccessors 
		ifTrue: [ self currentObject storedObject perform: ivn asSymbol ]
		ifFalse: [ self currentObject storedObject instVarNamed: ivn asSymbol ] 
! !

!SqsDescriptionHandler methodsFor: 'printing' stamp: 'tk 6/19/2008 14:17'!
indent: noOfTabs
	| indent |
	indent := String cr.
	0 to: noOfTabs do: [ :i |
		indent := indent, String tab.
	].
	^indent! !

!SqsDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 10/9/2008 18:10'!
indexClassOfDictionary: aDictionary 
	| indexBaseType |
	indexBaseType := nil.
	aDictionary
		keysDo: [:key | 
			(key class respondsTo: self class sqlTypeFunction)
				ifFalse: [self error: 'only simple types allowed as dictionary keys (use id or something...)'].
			indexBaseType
				ifNil: [indexBaseType := key class perform: self class sqlTypeFunction]
				ifNotNil: [(key class perform: self class sqlTypeFunction)
							= indexBaseType
						ifFalse: [self error: 'mixed keys? not so good for storing this in a database']]].
	^ aDictionary keys anyOne class! !

!SqsDescriptionHandler methodsFor: 'object-information' stamp: 'test 1/24/2009 15:35'!
indirectlyReferencedObjects
	| referencedObjects descr ivarValue |
	referencedObjects := OrderedCollection new.
	self persistedInstanceVariables do: 
		[ :ivn | 
		descr := self sqsDescriptionForInstVar: ivn.
		descr ifNotNil: 
			[ descr describesCollection ifTrue: 
				[ ivarValue := self getIvarValue: ivn.
				referencedObjects add: (SqsCollectionInformation new
						collection: ivarValue;
						collectionDescription: descr;
						yourself) ] ] ].
	^ referencedObjects! !

!SqsDescriptionHandler methodsFor: 'testing' stamp: 'tkow 12/4/2008 16:21'!
isComplexCollection: aCollection 
	"this check tries to find out whether a collection includes 'simple' objects. This is necessary, because collections with simple value don't point to another table but 	instead contain the values themselves. Addtionally there is a check to find out whether all values of a collection are somehow related to one-another,
	because only such values can be stored in a reasonable manner. Return value is true or false and tells us whether this collection holds complex objects or not"
	| sampleValue complexCollection isDict |
	sampleValue := nil.
	complexCollection := true.
	isDict := aCollection isDictionary.
	aCollection
		do: [:element | 
			| currentValue | 
			currentValue := isDict
						ifTrue: [element value]
						ifFalse: [element].
			currentValue
				ifNotNil: [sampleValue
						ifNil: [sampleValue := currentValue].
					complexCollection := (currentValue respondsTo: self class sqlValueStringFunction) not.
					((currentValue class includesBehavior: sampleValue class)
							or: [sampleValue class inheritsFrom: currentValue class])
						ifFalse: [self error: 'SqueakSave currently only supports collections with values that belong to the same base class (other than object...)']]].
	^ complexCollection! !

!SqsDescriptionHandler methodsFor: 'testing' stamp: 'tkow 9/23/2008 17:31'!
isComplexObject: anObject
	"determines whether an object is of a primitive type that can be stored
	directly in a database column, or if an additional table is required"
	| |
	^(anObject class respondsTo: self class sqlTypeFunction) not.! !

!SqsDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 9/30/2008 14:20'!
persistedInstanceVariables
	| persistedVars |
	persistedVars := Set new.
	self classInfo doForAllSuperclasses: [ :aClass |
		persistedVars addAll: aClass instVarNames.
		persistedVars := persistedVars difference: (self unpersistedInstVarsOf: aClass).
	].
	^ persistedVars! !

!SqsDescriptionHandler methodsFor: 'testing' stamp: 'tkow 9/18/2008 17:00'!
sqlTypeForObject: anObject 
	| |
	"determines the sql type for an object - this will always return at least 
	INTEGER since every object should be storeable somehow"
	^(anObject class respondsTo: self class sqlTypeFunction) ifTrue: [
		anObject class perform: (self class sqlTypeFunction)		
	] ifFalse: [
		self class standardSqlType
	]
			
! !

!SqsDescriptionHandler methodsFor: 'accessing' stamp: 'test 1/24/2009 15:35'!
sqsDescriptionForInstVar: ivarName 
	^ self subclassResponsibility! !

!SqsDescriptionHandler methodsFor: 'table-information' stamp: 'test 1/25/2009 15:37'!
tableNameForClass: aClass 
	^ (SqsClassInfo for: aClass) tableName! !

!SqsDescriptionHandler methodsFor: 'table-information' stamp: 'test 1/25/2009 15:39'!
tableNameForInstVar: ivn
	self currentObject doForAllSuperclasses: [ :aClass |
		(aClass instVarNames includes: ivn) ifTrue: [
			^ self tableNameForClass: aClass
		]
	].
	^ self tableNameForClass: self currentObject class! !

!SqsDescriptionHandler methodsFor: 'object-transformation' stamp: 'tkow 1/19/2009 17:59'!
transformObject: anObject toMatchDescription: description 
	"this is merely a hack to avoid some driver problems. Since some drivers deliver wrong 
	 classes (i.e. strings 0 or 1 insteda of true and false) we call the fromSqlValue function on
	 the classes where everything breaks. This also helps to create symbols instead of strings."
	| desiredClass |
	desiredClass := Smalltalk at: description objectClass.
	^ desiredClass fromSqlValue: anObject! !

!SqsDescriptionHandler methodsFor: 'variable-information' stamp: 'tkow 9/30/2008 14:25'!
unpersistedInstVars
	| unpersistedVars |
	"gather the unpersisted instance variables of all classes within the inheritance chain"
	unpersistedVars := Set new.
	self classInfo doForAllSuperclasses: [ :currentClass |
		unpersistedVars addAll: (self unpersistedInstVarsOf: currentClass).
	].
	^unpersistedVars
	! !

!SqsDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 9/3/2008 18:23'!
unpersistedInstVarsOf: klass
	self subclassResponsibility! !

!SqsDescriptionHandler methodsFor: 'configuration' stamp: 'tkow 11/7/2008 16:27'!
useAdvancedCollections
	^ self classInfo configuration collectionConfiguration orderedCollections! !

!SqsDescriptionHandler methodsFor: 'configuration' stamp: 'tkow 11/7/2008 16:22'!
useInstVarAccessors
	^ self classInfo configuration useInstVarAccessors! !

SqsDescriptionHandler subclass: #SqsStandardDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsStandardDescriptionHandler commentStamp: 'tk 6/19/2008 15:22' prior: 0!
A TKSaveMagritteDescriptionHandler is  .

Instance Variables
!

!SqsStandardDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 15:54'!
inheritanceModeFunction
	^#tableInheritance! !

!SqsStandardDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 16:12'!
tableNameFunction
	^#sqSaveTableName! !

!SqsStandardDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 16:13'!
unpersistedInstVarsFunction
	^#sqSaveUnpersistedInstVars! !

!SqsStandardDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 16:14'!
useInstVarAccessorsFunction
	^#useInstVarAccessors! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 10/9/2008 10:27'!
collectionDescriptionFor: ivn inClass: aClass basedOn: aCollection 
	"only create descriptors for non-empty collections"
	^ aCollection isEmpty 
		ifTrue: [ nil ]
		ifFalse: 
			[ self 
				persistenceDescriptionForCollection: aCollection
				withLabel: ivn
				complexValues: (self isComplexCollection: aCollection) ]! !

!SqsStandardDescriptionHandler methodsFor: 'accessing' stamp: 'test 1/27/2009 17:34'!
columnDescriptionForObject: anObject ofInstVar: instVarName linkedTo: aClass 
	| column sqlType objectClass |
	column := SqsColumn new.
	sqlType := self sqlTypeForObject: anObject.
		
	objectClass := (self isComplexObject: anObject) ifTrue: [
		(SqsClassInfo for: anObject class) baseClass name
	] ifFalse: [
		anObject class name
	].
	
	column
		columnName: instVarName decamelized;
		objectClass: objectClass;
		linkedVariable: instVarName;
		tableName: (self tableNameForInstVar: instVarName);
		sqlType: sqlType.
		
	aClass ifNotNil: 
		[ column associatedClass: aClass.
		column columnName: instVarName decamelized , '_id' ].
	^ column! !

!SqsStandardDescriptionHandler methodsFor: 'code-compilation' stamp: 'tkow 10/10/2008 11:07'!
createDescriptions
	| anObject targetClass |
	self persistedInstanceVariables do: 
		[ :ivn | 
		anObject := self getIvarValue: ivn.
		targetClass := self targetClassForDescriptorOfInstVar: ivn.
		anObject ifNotNil: 
			[ (targetClass respondsTo: ivn asSqSaveDescriptionSelector) 
				ifTrue: 
					[ self 
						updatePersistenceDescriptorFor: ivn
						basedOn: anObject
						inClass: targetClass ]
				ifFalse: 
					[ self 
						writePersistenceDescriptorFor: ivn
						basedOn: anObject
						inClass: targetClass ] ] ]! !

!SqsStandardDescriptionHandler methodsFor: 'private' stamp: 'tk 8/31/2008 15:17'!
descriptorMethodCategory
	^'persistence-description'! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'test 1/25/2009 16:12'!
ownerColumnForCurrentObject
	^ SqsColumn new
		sqlType: (Integer perform: self class sqlTypeFunction);
		columnName: self classInfo baseClass name decamelized , '_id';
		foreignKey: (SqsForeignKeyDescription new
				referencedColumns: (OrderedCollection with: self classInfo configuration tableConfiguration idField);
				referencedTable: self classInfo tableName;
				deleteActions: (OrderedCollection with: self classInfo sqsSession sqsDbAdapter class cascadeAction));
		linkedVariable: #SQSOWNER;
		canBeNull: false! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'test 2/2/2009 14:18'!
persistenceDescriptionForCollection: aCollection withLabel: ivn complexValues: aBool 
	| ownerColumn collectionSample referenceColumn referenceTableName indexType refClass |
	ownerColumn := self ownerColumnForCurrentObject.
	
	collectionSample := nil.
	aCollection do: [ :element | collectionSample ifNil: [ collectionSample := element ] ].
	collectionSample := SqsStorage for: collectionSample.
	
	refClass := aBool ifTrue: [
		collectionSample baseClass name	
	] ifFalse: [
		collectionSample storedObject class name
	].
	
	referenceColumn := self 
		referenceColumnDescriptionNamed: ivn
		for: collectionSample
		simpleValues: aBool not.
	referenceTableName := aBool 
		ifTrue: [ self tableNameForClass: collectionSample baseClass ]
		ifFalse: [ nil ].
	indexType := (aCollection isDictionary 
		ifTrue: [ self indexClassOfDictionary: aCollection ]
		ifFalse: [ Integer ]) perform: self class sqlTypeFunction.
		
	^ SqsCollectionDescription new
		referenceTableName: referenceTableName;
		referenceColumn: referenceColumn;
		collectionClass: aCollection sqSaveClass;
		indexType: indexType;
		referencedClass: refClass;
		simpleValues: aBool not;
		configuration: self classInfo configuration collectionConfiguration;
		ownerColumn: ownerColumn;
		linkedVariable: ivn;
		tableName: self currentObject baseClass name asSqSaveTableName , '_' , ivn decamelized! !

!SqsStandardDescriptionHandler methodsFor: 'accessing' stamp: 'test 1/25/2009 15:18'!
persistenceDescriptionForObject: anObject withLabel: aLabel
	| linkedClass |
	linkedClass := (self isComplexObject: anObject) 
		ifTrue: [ (SqsClassInfo for: anObject class) baseClass name asSymbol ]
		ifFalse: [ nil ].
	^ self 
		columnDescriptionForObject: anObject
		ofInstVar: aLabel
		linkedTo: linkedClass! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'test 1/25/2009 15:19'!
persistenceDescriptorFor: ivn inClass: aClass basedOn: anObject 
	"ensure that for all collections (except for strings) we create different descriptors"
	^ (anObject isCollection and: [ anObject isString not ]) 
		ifTrue: 
			[ self 
				collectionDescriptionFor: ivn
				inClass: aClass
				basedOn: anObject ]
		ifFalse: 
			[ self 
				persistenceDescriptionForObject: anObject
				withLabel: ivn 
			]! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'test 1/27/2009 17:40'!
questionToChangeAssoc: ivn classFrom: previousClass to: newClass 
	| dialogText |
	^ self classInfo configuration warnOnAlteration ifTrue: [
		dialogText := 'Change class of ' , ivn , ' from ' , previousClass name , ' to ' , newClass name , '?'.
		self confirm: dialogText.
	] ifFalse: [
		true
	]
	! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 12/12/2008 17:41'!
referenceColumnDescriptionNamed: ivn for: collectionSample simpleValues: aBool 
	| referenceColumn sqlType |
	sqlType := self sqlTypeForObject: collectionSample storedObject.
	referenceColumn := SqsColumn new
		sqlType: sqlType;
		columnName: self classInfo configuration collectionConfiguration valueField;
		canBeNull: false;
		linkedVariable: #SQSREF.
	"create the foreign key relationship only if complex collections should be
	used or if our collection elements are no simple values but complex ones"
	(self useAdvancedCollections or: [ aBool ]) ifFalse: 
		[ referenceColumn foreignKey: (SqsForeignKeyDescription new
				referencedColumns: (OrderedCollection with: collectionSample configuration tableConfiguration idField);
				referencedTable: (self tableNameForClass: collectionSample baseClass);
				deleteActions: #(#CASCADE )) ].
	^ referenceColumn! !

!SqsStandardDescriptionHandler methodsFor: 'accessing' stamp: 'test 1/25/2009 16:08'!
sqsDescriptionForInstVar: ivarName 
	| curClass |
	curClass := self targetClass.
	(curClass respondsTo: ivarName asSqSaveDescriptionSelector) ifTrue: [ 
		^ curClass perform: ivarName asSqSaveDescriptionSelector 
	] ifFalse: [
		curClass allSubclassesDo: [:aClass |
			(aClass respondsTo: ivarName asSqSaveDescriptionSelector) ifTrue: [ 
				^ aClass perform: ivarName asSqSaveDescriptionSelector 
			]			
		]
	].
	^ nil
! !

!SqsStandardDescriptionHandler methodsFor: 'printing' stamp: 'tkow 10/10/2008 13:06'!
targetClass
	^self subclassResponsibility
	! !

!SqsStandardDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 10/10/2008 13:40'!
targetClassForDescriptorOfInstVar: ivn
	| targetClass baseClass |
	targetClass := self classInfo currentClass.
	baseClass := self currentObject baseClass.
	[ targetClass ~= baseClass superclass ] whileTrue: 
		[ (targetClass instVarNames includes: ivn) ifTrue: [ ^ targetClass ].
		targetClass := targetClass superclass ].
	self error: 'instance variable named ' , ivn , ' could not be found in the class hierarchy of ' , self currentObject class name

! !

!SqsStandardDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 9/10/2008 16:13'!
unpersistedInstVarsOf: aClass
	^(aClass respondsTo: self class unpersistedInstVarsFunction) ifTrue: [
		(aClass perform: self class unpersistedInstVarsFunction)
	] ifFalse: [
		#()
	].! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'test 1/27/2009 15:05'!
updatePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass
	| previousClass oldDescription |
	oldDescription := aClass perform: ivn asSqSaveDescriptionSelector.
	"for the brave ones, we leave everything as is"
	oldDescription manuallyMaintained ifFalse: [
		oldDescription describesCollection ifFalse: [
			previousClass := Smalltalk at: oldDescription objectClass asSymbol.
			"if we have a subclass of our previous class, we're fine - otherwhise, we have to alter the table and the description"
			((anObject class inheritsFrom: previousClass) or: [anObject sqSaveClass = previousClass]) ifFalse: [
				(self questionToChangeAssoc: ivn classFrom: previousClass to: anObject class) ifTrue: [
					self writePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass.	
				]
			]
		] ifTrue: [
			self writePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass.
		]
	].	
	! !

!SqsStandardDescriptionHandler methodsFor: 'configuration' stamp: 'tkow 9/12/2008 18:37'!
useInstVarAccessors
	^(self targetClass respondsTo: (self class useInstVarAccessorsFunction)) ifTrue: [
		self targetClass perform: (self class useInstVarAccessorsFunction)
	] ifFalse: [
		false
	]! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'test 1/27/2009 11:29'!
writePersistenceDescriptorFor: ivn basedOn: anObject inClass: targetClass 
	| description code |
	description := self 
		persistenceDescriptorFor: ivn
		inClass: targetClass
		basedOn: anObject.
	description ifNotNil: 
		[ code := ivn asSqSaveDescriptionSelector , String cr.
		code := code , '^' , description codeForObjectCreation.
		self 
			compileMethodCode: code
			intoClass: targetClass ]! !

SqsStandardDescriptionHandler subclass: #SqsStandardExternDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsStandardExternDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 10/10/2008 14:15'!
createExternalDescriptorClassNamed: targetName
	"this function creates all required descriptor classes up to the base class"
	| classes targetCategory currentSuperclass |
	
	classes := OrderedCollection new.
	self classInfo doForAllSuperclasses: [:aClass |
		classes add: aClass.	
	].
	targetCategory := self classInfo currentClass category asString.
	currentSuperclass := Object.
	classes reverseDo: [:aClass |
		| descrClassName |
		descrClassName := aClass name asSqSaveDescriptorClassName.
		currentSuperclass := Smalltalk at: (descrClassName) ifAbsent: [
			currentSuperclass subclass: descrClassName
				instanceVariableNames: ''
				classVariableNames: ''
				poolDictionaries: ''
				category: targetCategory
		]
	].
	^Smalltalk at: targetName! !

!SqsStandardExternDescriptionHandler methodsFor: 'printing' stamp: 'tkow 10/10/2008 14:02'!
targetClass
	| targetName |
	targetName := self classInfo currentClass name asSqSaveDescriptorClassName.
	^self createExternalDescriptorClassNamed: targetName.
	! !

!SqsStandardExternDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 10/10/2008 14:03'!
targetClassForDescriptorOfInstVar: ivn
	| targetName |
	targetName := (super targetClassForDescriptorOfInstVar: ivn) name asSqSaveDescriptorClassName.
	^self createExternalDescriptorClassNamed: targetName.! !

SqsStandardDescriptionHandler subclass: #SqsStandardInternDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsStandardInternDescriptionHandler methodsFor: 'printing' stamp: 'tkow 10/10/2008 13:07'!
targetClass
	^self classInfo currentClass! !

Object subclass: #SqsDesignObject
	instanceVariableNames: 'type buildDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

SqsDesignObject subclass: #SqsAssembly
	instanceVariableNames: 'superAssembly module'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:49'!
module
	^ module! !

!SqsAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:49'!
module: anObject
	module := anObject! !

!SqsAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:49'!
superAssembly
	^ superAssembly! !

!SqsAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:49'!
superAssembly: anObject
	superAssembly := anObject! !

SqsAssembly subclass: #SqsBaseAssembly
	instanceVariableNames: 'sharedParts unsharedParts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsBaseAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 17:01'!
addUnsharedPart: aPart
	unsharedParts ifNil: [
		unsharedParts := Set new.	
	].
	aPart addBaseAssembly: self.
	unsharedParts add: aPart.! !

!SqsBaseAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:59'!
sharedParts
	^ sharedParts! !

!SqsBaseAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:59'!
sharedParts: anObject
	sharedParts := anObject! !

!SqsBaseAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:59'!
unsharedParts
	^ unsharedParts! !

!SqsBaseAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:59'!
unsharedParts: anObject
	unsharedParts := anObject! !

SqsAssembly subclass: #SqsComplexAssembly
	instanceVariableNames: 'subAssemblies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsComplexAssembly methodsFor: 'as yet unclassified' stamp: 'test 2/2/2009 17:02'!
addSubAssembly: anAssembly
	subAssemblies ifNil: [
		subAssemblies := Set new.	
	].
	anAssembly superAssembly: self.
	subAssemblies add: anAssembly.! !

SqsDesignObject subclass: #SqsAtomicPart
	instanceVariableNames: 'x y docId connections compositePart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsAtomicPart class methodsFor: 'as yet unclassified' stamp: 'test 2/2/2009 16:53'!
buildDate: aDate
	| inst |
	inst := super buildDate: aDate.
	inst x: (Random seed: Time now asNanoSeconds) nextValue asInteger. 
	inst y: (Random seed: Time now asNanoSeconds) nextValue asInteger.
	inst docId: (Random seed: Time now asNanoSeconds) nextValue asInteger.
	^ inst! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:58'!
addConnection: aPart
	| connection |
	connections ifNil: [
		connections := Set new.	
	].
	connection := SqsCon from: self to: aPart.
	connections add: connection.
! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
compositePart
	^ compositePart! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
compositePart: anObject
	compositePart := anObject! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
connections
	^ connections! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
connections: anObject
	connections := anObject! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
docId
	^ docId! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
docId: anObject
	docId := anObject! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
x
	^ x! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
x: anObject
	x := anObject! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
y
	^ y! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
y: anObject
	y := anObject! !

SqsDesignObject subclass: #SqsCompositePart
	instanceVariableNames: 'document atomicParts rootPart baseAssemblies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsCompositePart class methodsFor: 'as yet unclassified' stamp: 'test 2/2/2009 17:04'!
documentLength: anInteger
	^ self new
		changeDocument: (SqsDocument documentLength: anInteger);
		yourself! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:06'!
addAtomicPart: aPart
	atomicParts ifNil: [
		atomicParts := Set new.	
	].
	aPart compositePart: self.
	atomicParts add: aPart.! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
addBaseAssembly: anAssembly
	baseAssemblies ifNil: [
		baseAssemblies := Set new.	
	].
	baseAssemblies add: anAssembly.
	! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
atomicParts
	^ atomicParts! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
atomicParts: anObject
	atomicParts := anObject! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
baseAssemblies
	^ baseAssemblies! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
baseAssemblies: anObject
	baseAssemblies := anObject! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:07'!
changeDocument: aDocument
	self document: aDocument! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
document
	^ document! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
document: anObject
	document := anObject! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
rootPart
	^ rootPart! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
rootPart: anObject
	rootPart := anObject! !

!SqsDesignObject class methodsFor: 'as yet unclassified' stamp: 'test 2/2/2009 16:30'!
buildDate: aDate
	^self new
		buildDate: aDate;
		type: ('Type', ((Random seed: Time now seconds) nextValue asInteger) asString);
		yourself
		! !

!SqsDesignObject methodsFor: 'accessing' stamp: 'test 2/2/2009 16:23'!
buildDate
	^ buildDate! !

!SqsDesignObject methodsFor: 'accessing' stamp: 'test 2/2/2009 16:23'!
buildDate: anObject
	buildDate := anObject! !

!SqsDesignObject methodsFor: 'accessing' stamp: 'test 2/2/2009 16:23'!
type
	^ type! !

!SqsDesignObject methodsFor: 'accessing' stamp: 'test 2/2/2009 16:23'!
type: anObject
	type := anObject! !

SqsDesignObject subclass: #SqsModule
	instanceVariableNames: 'manual assemblies designRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:48'!
addAssembly: anAssembly
	assemblies ifNil: [
		assemblies := Set new.	
	].
	anAssembly module: self.
	assemblies add: anAssembly.! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:46'!
assemblies
	^ assemblies! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:46'!
assemblies: anObject
	assemblies := anObject! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:48'!
changeDesignRoot: aDesignRoot
	aDesignRoot module: self.
	self designRoot: aDesignRoot.! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:46'!
designRoot
	^ designRoot! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:46'!
designRoot: anObject
	designRoot := anObject! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:46'!
manual
	^ manual! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:46'!
manual: anObject
	manual := anObject! !

Object subclass: #SqsDocument
	instanceVariableNames: 'title text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsDocument class methodsFor: 'as yet unclassified' stamp: 'test 2/2/2009 16:43'!
documentLength: anInteger
	| tStream |
	tStream := TextStream on: (String new: anInteger).
	1 to: anInteger do: [:index |
		tStream nextPutAll: 'd'
	].
	^ self new
		title: 'Title';
		text: tStream contents;
		yourself! !

!SqsDocument methodsFor: 'accessing' stamp: 'test 2/2/2009 16:32'!
text
	^ text! !

!SqsDocument methodsFor: 'accessing' stamp: 'test 2/2/2009 16:32'!
text: anObject
	text := anObject! !

!SqsDocument methodsFor: 'accessing' stamp: 'test 2/2/2009 16:32'!
title
	^ title! !

!SqsDocument methodsFor: 'accessing' stamp: 'test 2/2/2009 16:32'!
title: anObject
	title := anObject! !

Object subclass: #SqsLoadStrategy
	instanceVariableNames: 'eagerLoaded loadDepth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Analysis'!

!SqsLoadStrategy class methodsFor: 'as yet unclassified' stamp: 'tkow 11/5/2008 17:02'!
depth: anInteger
	^self new
		loadDepth: anInteger! !

!SqsLoadStrategy class methodsFor: 'as yet unclassified' stamp: 'tkow 11/5/2008 17:02'!
eager
	^self new
		loadDepth: 1! !

!SqsLoadStrategy class methodsFor: 'as yet unclassified' stamp: 'tkow 11/5/2008 17:02'!
eagerVariables: aDictionary
	^self new
		eagerLoaded: aDictionary! !

!SqsLoadStrategy methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:01'!
eagerLoaded
	^ eagerLoaded! !

!SqsLoadStrategy methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:01'!
eagerLoaded: anObject
	eagerLoaded := anObject! !

!SqsLoadStrategy methodsFor: 'initialization' stamp: 'tkow 11/5/2008 17:01'!
initialize
	eagerLoaded := Dictionary new.
! !

!SqsLoadStrategy methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:01'!
loadDepth
	^ loadDepth! !

!SqsLoadStrategy methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:01'!
loadDepth: anObject
	loadDepth := anObject! !

Object subclass: #SqsManual
	instanceVariableNames: 'title text textLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsManual class methodsFor: 'as yet unclassified' stamp: 'test 2/2/2009 16:45'!
documentLength: anInteger
	| tStream |
	tStream := TextStream on: (String new: anInteger).
	1 to: anInteger do: [:index |
		tStream nextPutAll: 'm'
	].
	^ self new
		title: 'Title';
		text: tStream contents;
		textLength: anInteger;
		yourself! !

!SqsManual methodsFor: 'accessing' stamp: 'test 2/2/2009 16:44'!
text
	^ text! !

!SqsManual methodsFor: 'accessing' stamp: 'test 2/2/2009 16:44'!
text: anObject
	text := anObject! !

!SqsManual methodsFor: 'accessing' stamp: 'test 2/2/2009 16:44'!
textLength
	^ textLength! !

!SqsManual methodsFor: 'accessing' stamp: 'test 2/2/2009 16:44'!
textLength: anObject
	textLength := anObject! !

!SqsManual methodsFor: 'accessing' stamp: 'test 2/2/2009 16:44'!
title
	^ title! !

!SqsManual methodsFor: 'accessing' stamp: 'test 2/2/2009 16:44'!
title: anObject
	title := anObject! !

Object subclass: #SqsMigration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsMigration commentStamp: 'tkow 1/19/2009 18:04' prior: 0!
A SqsMigration is the base class for custom migrations. It allows for easy data synchronization between multiple developers. 
Simply create a new method...

Instance Variables
!

Object subclass: #SqsObjectCache
	instanceVariableNames: 'objectCache objectIdCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsObjectCache methodsFor: 'object-caching' stamp: 'tkow 12/4/2008 17:06'!
cacheObject: anObject withOid: oid
	(self objectCacheFor: anObject class) at: oid put: anObject.
	(self objectIdCacheFor: anObject class) at: anObject put: oid.
	! !

!SqsObjectCache methodsFor: 'object-caching' stamp: 'tkow 12/4/2008 17:02'!
cachedObjectOfClass: aClass withOid: oid 
	| object |
	object := (self objectCacheFor: aClass)
		at: oid
		ifAbsent: [nil].
	"this re-caching becomes necessary sometimes, to keep both caches in sync 
	even when only one of the caches has been cleared"
	object ifNotNil: [
		(self objectIdCacheFor: object class) at: object ifAbsentPut: [oid]
	].
	^ object! !

!SqsObjectCache methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:07'!
clear
	objectCache := Dictionary new.
	objectIdCache := Dictionary new.! !

!SqsObjectCache methodsFor: 'initialization' stamp: 'tkow 12/4/2008 17:05'!
initialize
	super initialize.
	objectCache := Dictionary new.
	objectIdCache := Dictionary new.! !

!SqsObjectCache methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:04'!
objectCacheFor: aClass
	^ objectCache 
		at: aClass name 
		ifAbsentPut: [WeakValueDictionary new]! !

!SqsObjectCache methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:04'!
objectIdCacheFor: aClass
	^ objectIdCache
		at: aClass name 
		ifAbsentPut: [WeakIdentityKeyDictionary new]! !

!SqsObjectCache methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:26'!
oidFor: anObject
	| classCache |
	classCache := objectIdCache at: anObject class name ifAbsent: [^nil].
	^ classCache at: anObject ifAbsent: [nil]! !

Object subclass: #SqsPersistenceDescription
	uses: TSqsSelfPrinting
	instanceVariableNames: 'associatedClass manuallyMaintained'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

SqsPersistenceDescription class
	uses: TSqsSelfPrinting classTrait
	instanceVariableNames: ''!

SqsPersistenceDescription subclass: #SqsCollectionDescription
	instanceVariableNames: 'collectionClass tableName ownerColumn referenceColumn referenceTableName configuration simpleValues indexType referencedClass linkedVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 14:45'!
collectionClass
	^ collectionClass! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 14:45'!
collectionClass: anObject
	collectionClass := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 11/10/2008 10:20'!
configuration
	^ configuration! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 11/10/2008 10:20'!
configuration: anObject
	configuration := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 7/23/2008 15:13'!
describesCollection
	^true! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/18/2008 16:10'!
indexType
	^ indexType! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/18/2008 16:10'!
indexType: anObject
	indexType := anObject! !

!SqsCollectionDescription methodsFor: 'initialization' stamp: 'tkow 11/10/2008 10:21'!
initialize
	super initialize.
	self simpleValues: false.! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 11/21/2008 21:54'!
linkedVariable
	^ linkedVariable! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 11/21/2008 21:54'!
linkedVariable: anObject
	linkedVariable := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 11/10/2008 11:14'!
maintainOrder
	^self configuration orderedCollections! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:14'!
maintainOrder: anObject 
	maintainOrder := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
ownerColumn
	^ ownerColumn! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
ownerColumn: anObject
	ownerColumn := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceColumn
	^ referenceColumn! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceColumn: anObject
	referenceColumn := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceTableName
	^ referenceTableName! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceTableName: anObject
	referenceTableName := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/24/2008 15:48'!
referencedClass
	^ referencedClass! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/24/2008 15:48'!
referencedClass: anObject
	referencedClass := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/15/2008 14:05'!
simpleValues
	^ simpleValues! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/15/2008 14:05'!
simpleValues: anObject
	simpleValues := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'test 1/26/2009 14:45'!
tableName
	^ joinTableName! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'test 1/26/2009 14:46'!
tableName: anObject 
	joinTableName := anObject! !

SqsPersistenceDescription subclass: #SqsColumn
	instanceVariableNames: 'columnName sqlType objectClass tableName foreignKey canBeNull isPrimaryKey autoIncrement linkedVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsColumn methodsFor: 'accessing' stamp: 'tkow 12/12/2008 12:56'!
= anotherColumn
	^(self class = anotherColumn class) ifTrue: [
		(self columnName = anotherColumn columnName) and: [self tableName = anotherColumn tableName]
	] ifFalse: [
		false
	]
	! !

!SqsColumn methodsFor: 'accessing' stamp: 'tkow 10/7/2008 14:41'!
autoIncrement
	^ autoIncrement! !

!SqsColumn methodsFor: 'accessing' stamp: 'tkow 10/7/2008 14:41'!
autoIncrement: anObject
	autoIncrement := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull
	^ canBeNull! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull: anObject
	canBeNull := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName
	^ columnName! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName: anObject
	columnName := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:58'!
foreignKey
	^ foreignKey! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:16'!
foreignKey: anObject
	foreignKey := anObject.
	"being a foreign key, the column can not be null"
	self canBeNull: false.! !

!SqsColumn methodsFor: 'accessing' stamp: 'tkow 11/3/2008 15:07'!
hash
	^(self columnName hash + self sqlType hash + self tableName hash)! !

!SqsColumn methodsFor: 'initialization' stamp: 'tkow 11/3/2008 18:43'!
initialize
	super initialize.
	self canBeNull: true.
	self isPrimaryKey: false.
	self autoIncrement: false.! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 8/14/2008 11:56'!
isPrimaryKey
	^ isPrimaryKey! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 8/14/2008 11:56'!
isPrimaryKey: anObject
	isPrimaryKey := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tkow 10/9/2008 10:33'!
linkedVariable
	^ linkedVariable! !

!SqsColumn methodsFor: 'accessing' stamp: 'tkow 10/9/2008 10:33'!
linkedVariable: anObject
	linkedVariable := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass
	^ objectClass! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass: anObject
	objectClass := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType
	^ sqlType! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType: anObject
	sqlType := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName
	^ tableName! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName: anObject
	tableName := anObject! !

SqsPersistenceDescription subclass: #SqsForeignKeyDescription
	instanceVariableNames: 'referencedColumns referencedTable updateActions deleteActions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions
	^ deleteActions! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions: anObject
	deleteActions := anObject! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:31'!
initialize
	super initialize.
	self updateActions: #().
	self deleteActions: #().! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns
	^ referencedColumns! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns: anObject
	referencedColumns := anObject! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable
	^ referencedTable! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable: anObject
	referencedTable := anObject! !

!SqsForeignKeyDescription methodsFor: 'printing' stamp: 'tk 7/22/2008 13:54'!
storeOn: aStream

	aStream nextPut: $(.
	aStream nextPutAll: self class name, ' new'.
	aStream nextPutAll: (String cr, String tab, String tab).
	1 to: self class instSize do:
		[:i |
		(self instVarAt: i) ifNotNil: [
			aStream nextPutAll: (' ',(self class allInstVarNames at: i),': ');
				store: (self instVarAt: i);
				nextPut: $;;
				nextPutAll: (String cr, String tab, String tab)
			]
		].
	1 to: self basicSize do:
		[:i |
		aStream nextPutAll: ' basicAt: ';
			store: i;
			nextPutAll: ' put: ';
			store: (self basicAt: i);
			nextPut: $;].
	aStream nextPutAll: ' yourself)'.! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions
	^ updateActions! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions: anObject
	updateActions := anObject! !

!SqsPersistenceDescription methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass
	^ associatedClass! !

!SqsPersistenceDescription methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass: anObject
	associatedClass := anObject! !

!SqsPersistenceDescription methodsFor: 'printing' stamp: 'test 1/27/2009 11:29'!
codeForObjectCreation
	| aStream |
	aStream := TextStream on: String new.
	aStream nextPut: $(.
	aStream nextPutAll: self class name , ' new'.
	aStream nextPutAll: String crlf , String tab.
	1 
		to: self class instSize
		do: 
			[ :i | 
			(self instVarAt: i) ifNotNil: 
				[ aStream
					nextPutAll: String cr , String tab;
					nextPutAll: ' ' , (self class allInstVarNames at: i) , ': ';
					store: (self instVarAt: i);
					nextPut: $; ] ].
	aStream nextPutAll: String cr , String tab , ' yourself)'.
	^ aStream contents! !

!SqsPersistenceDescription methodsFor: 'accessing' stamp: 'tk 7/23/2008 15:12'!
describesCollection
	^false! !

!SqsPersistenceDescription methodsFor: 'initialization' stamp: 'tk 8/15/2008 16:37'!
initialize
	super initialize.
	self manuallyMaintained: false.! !

!SqsPersistenceDescription methodsFor: 'accessing' stamp: 'tk 8/15/2008 16:38'!
manuallyMaintained
	^ manuallyMaintained! !

!SqsPersistenceDescription methodsFor: 'accessing' stamp: 'tk 8/15/2008 16:38'!
manuallyMaintained: anObject
	manuallyMaintained := anObject! !

SqsPersistenceDescription subclass: #SqsTable
	instanceVariableNames: 'tableName parent children columns structure oidColumn typeColumn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsTable class methodsFor: 'as yet unclassified' stamp: 'tkow 11/10/2008 14:32'!
objectIdLink
	^ #SQSOID! !

!SqsTable class methodsFor: 'as yet unclassified' stamp: 'tkow 11/10/2008 14:32'!
typeLink
	^ #SQSTYPE! !

!SqsTable methodsFor: 'special columns' stamp: 'tkow 12/12/2008 17:41'!
addLightOidColumnNamed: aString linkedTo: refTableName 
	| aColumn |
	aColumn := SqsColumn new
		columnName: aString;
		sqlType: #unsignedInteger;
		canBeNull: false;
		isPrimaryKey: true;
		linkedVariable: self class objectIdLink;
		foreignKey: (SqsForeignKeyDescription new
				referencedColumns: (OrderedCollection with: aString);
				deleteActions: #(#CASCADE );
				referencedTable: refTableName).
	self columns add: aColumn.
	self oidColumn: aColumn! !

!SqsTable methodsFor: 'special columns' stamp: 'tkow 12/12/2008 17:40'!
addOidColumnNamed: aString 
	| newColumn |
	newColumn := SqsColumn new
		columnName: aString;
		sqlType: #unsignedInteger;
		canBeNull: false;
		isPrimaryKey: true;
		autoIncrement: true;
		tableName: self tableName;
		linkedVariable: self class objectIdLink.
	self columns add: newColumn.
	self oidColumn: newColumn! !

!SqsTable methodsFor: 'special columns' stamp: 'tkow 12/12/2008 17:40'!
addTypeColumnNamed: aString 
	| aColumn |
	aColumn := SqsColumn new
		columnName: aString;
		sqlType: #string;
		canBeNull: false;
		isPrimaryKey: false;
		objectClass: #Symbol;
		tableName: self tableName;
		linkedVariable: self class typeLink.
	self columns add: aColumn.
	self typeColumn: aColumn! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 13:45'!
allChildTables
	| allChildren |
	allChildren := OrderedCollection withAll: self children.
	self children do: [:childTable |
		allChildren addAll: childTable allChildTables
	].
	^allChildren! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 12/4/2008 17:45'!
allColumns
	| allColumns |
	allColumns := self columns.
	self children do: [:childTable |
		allColumns addAll: childTable allColumns
	].
	^ allColumns! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/9/2008 16:22'!
baseTable
	^self parent ifNil: [
		self
	] ifNotNil: [
		self parent baseTable
	]! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
children
	^ children! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
children: anObject
	children := anObject! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
columns
	^ columns! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
columns: anObject
	columns := anObject! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 18:39'!
initialize
	super initialize.
	self children: Set new.
	self columns: OrderedCollection new.! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/10/2008 14:49'!
oidColumn
	^ oidColumn! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/10/2008 14:49'!
oidColumn: anObject
	oidColumn := anObject! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
parent
	^ parent! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 14:48'!
parent: anObject
	parent := anObject.
	parent children add: self.
	! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
structure
	^ structure! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
structure: anObject
	structure := anObject! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
tableName
	^ tableName! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
tableName: anObject
	tableName := anObject! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/10/2008 14:49'!
typeColumn
	^ typeColumn! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/10/2008 14:49'!
typeColumn: anObject
	typeColumn := anObject! !

Object subclass: #SqsQuery
	instanceVariableNames: 'queryClass whereBuffer valueTables queryTables queryLevel previousQueryObject currentQueryObject loadStrategy orderBy ignoreTypeField distinct'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQuery class methodsFor: 'as yet unclassified' stamp: 'test 1/23/2009 17:55'!
classForType: aType 
	| |
	^ self classesForTypes
		keysAndValuesDetect: [ :classKey :subClass | aType includesBehavior: classKey]
		ifNone: [ SqsQueryObject ].
! !

!SqsQuery class methodsFor: 'as yet unclassified' stamp: 'test 1/26/2009 15:30'!
classesForTypes
	^ Dictionary new
		at: Boolean
			put: SqsQueryBoolean;
		at: Date
			put: SqsQueryDate;
		at: DateAndTime
			put: SqsQueryDateTime;
		at: Number
			put: SqsQueryNumber;
		at: String
			put: SqsQueryString;
		at: Collection
			put: SqsQueryCollection;
		yourself! !

!SqsQuery class methodsFor: 'initialize-release' stamp: 'tkow 10/14/2008 11:05'!
on: aClass
	^(self new
		on: aClass;
		yourself)! !

!SqsQuery class methodsFor: 'initialize-release' stamp: 'tkow 11/5/2008 17:04'!
on: aClass withStrategy: anSqsLoadStrategy
	^(self new
		on: aClass;
		loadStrategy: anSqsLoadStrategy;
		yourself)! !

!SqsQuery methodsFor: 'initialize-release' stamp: 'test 1/29/2009 17:40'!
aliasSuffixForTableOfClass: aClass 
	| timesTaken |
	timesTaken := self queryLevel 
		at: aClass name
		ifAbsent: [ 0 ].
	^ timesTaken = 0 
		ifTrue: [ '' ]
		ifFalse: [ '_' , timesTaken asString ]! !

!SqsQuery methodsFor: 'enumerating' stamp: 'test 1/26/2009 16:01'!
analyze: aBlock
	| qo result |
	qo := (self class classForType: Object) new 
		query: self;
		depictedClass: self queryClass.
	result := aBlock value: qo.
	self whereBuffer: result whereBuffer.
	self findValueTables.
! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 10/14/2008 11:00'!
currentQueryObject
	^ currentQueryObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 10/14/2008 11:00'!
currentQueryObject: anObject
	currentQueryObject := anObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'test 1/26/2009 17:08'!
distinct
	^ distinct! !

!SqsQuery methodsFor: 'accessing' stamp: 'test 1/26/2009 17:08'!
distinct: anObject
	distinct := anObject! !

!SqsQuery methodsFor: 'initialize-release' stamp: 'tkow 12/12/2008 17:53'!
findValueTables
	| baseTable queryBaseTable childQueryTable classInfo idField childLink |
	classInfo := SqsClassInfo for: self queryClass.
	baseTable := classInfo classTable baseTable.
	queryBaseTable := SqsQueryTable 
		table: baseTable
		alias: ''
		field: nil
		class: self queryClass.

	"we need the base table in the values (i.e. the SELECT ...) as well as in the query part (FROM ...)"
	"for eager loading, those tables would be added to the values as seperate tables and to the queries
	by linking them to the queryBaseTable via an SqSTableLink"
	self valueTables add: queryBaseTable.
	idField := classInfo configuration tableConfiguration idField.

	"the links to the child tables are merly a shortcut that simplifies the adapter handling of this stuff
	This way we can simply take all links a table has, and throw it into one giant join statement"
	baseTable allChildTables do: 
		[ :childTable | 
		childQueryTable := SqsQueryTable 
			table: childTable
			alias: ''
			field: nil.
		childLink := SqsTableLink 
			table: childQueryTable
			fromField: idField
			toField: idField
			direction: 'LEFT OUTER'.
		queryBaseTable tableLinks add: childLink ].
	self queryTables add: queryBaseTable! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 12/5/2008 13:35'!
ignoreTypeField
	^ ignoreTypeField! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 12/5/2008 13:35'!
ignoreTypeField: anObject
	ignoreTypeField := anObject! !

!SqsQuery methodsFor: 'initialization' stamp: 'test 1/26/2009 17:08'!
initialize
	super initialize.
	self whereBuffer: ''.
	self valueTables: OrderedCollection new.
	self queryTables: OrderedCollection new.
	self queryLevel: Dictionary new.
	self ignoreTypeField: false.
	self distinct: false.! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:04'!
loadStrategy
	^ loadStrategy! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:04'!
loadStrategy: anObject
	loadStrategy := anObject! !

!SqsQuery methodsFor: 'initialize-release' stamp: 'test 1/30/2009 15:27'!
newAliasSuffixForTableOfClass: aClass 
	| timesTaken aliasedName |
	timesTaken := self queryLevel 
		at: aClass name
		ifAbsentPut: [ 0 ].

	timesTaken := timesTaken + 1.
	self queryLevel 
		at: aClass name
		put: timesTaken.
	aliasedName := self aliasSuffixForTableOfClass: aClass.
	^ aliasedName! !

!SqsQuery methodsFor: 'as yet unclassified' stamp: 'tkow 11/2/2008 21:59'!
newForType: aType
	self previousQueryObject: self currentQueryObject.
	^(self class classForType: aType) new 
		query: self;
		depictedClass: aType.! !

!SqsQuery methodsFor: 'initialize-release' stamp: 'tkow 11/5/2008 17:46'!
on: aClass 
	| |
	self queryClass: aClass.
! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/24/2008 11:15'!
orderBy
	^ orderBy! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/24/2008 11:15'!
orderBy: anObject
	orderBy := anObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 10/14/2008 10:09'!
previousQueryObject
	^ previousQueryObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 10/14/2008 10:09'!
previousQueryObject: anObject
	previousQueryObject := anObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:36'!
queryClass
	^queryClass! !

!SqsQuery methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:34'!
queryClass: aClass
	queryClass _ aClass.! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/3/2008 10:09'!
queryLevel
	^ queryLevel! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/3/2008 10:09'!
queryLevel: anObject
	queryLevel := anObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/25/2008 14:06'!
queryTables
	^ queryTables! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/25/2008 14:06'!
queryTables: anObject
	queryTables := anObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 10/20/2008 16:01'!
valueTables
	^ valueTables! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 10/20/2008 16:01'!
valueTables: anObject
	valueTables := anObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:41'!
whereBuffer
	^whereBuffer.! !

!SqsQuery methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:42'!
whereBuffer: aString
	whereBuffer _ aString.! !

Object subclass: #SqsQueryTable
	instanceVariableNames: 'aliasSuffix field originalTable queryClass tableLinks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryTable class methodsFor: 'instance creation' stamp: 'tkow 11/3/2008 16:12'!
table: anSqsTable alias: anAliasName field: aFieldName 
	^ self new
		originalTable: anSqsTable;
		aliasSuffix: anAliasName;
		field: aFieldName;
		yourself! !

!SqsQueryTable class methodsFor: 'instance creation' stamp: 'tkow 11/5/2008 16:03'!
table: anSqsTable alias: anAliasName field: aFieldName class: aClass
	^ self new
		originalTable: anSqsTable;
		aliasSuffix: anAliasName;
		field: aFieldName;
		queryClass: aClass;
		yourself! !

!SqsQueryTable class methodsFor: 'instance creation' stamp: 'tkow 11/24/2008 14:44'!
table: anSqsTable alias: anAliasName field: aFieldName class: aClass ignoreValues: aBool
	^ self new
		originalTable: anSqsTable;
		aliasSuffix: anAliasName;
		field: aFieldName;
		queryClass: aClass;
		ignoreValues: aBool;
		yourself! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 16:12'!
aliasSuffix
	^ aliasSuffix! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 16:12'!
aliasSuffix: anObject 
	aliasSuffix := anObject! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 16:25'!
aliasedName
	^self originalTable tableName, self aliasSuffix! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/4/2008 13:59'!
allAliasedNames
	| aliasedNames |
	aliasedNames := OrderedCollection new.
	aliasedNames add: self aliasedName.
	self originalTable allChildTables do: [:table |
		aliasedNames add: (table tableName, self aliasSuffix)
	].
	^aliasedNames! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'wh 8/15/2006 11:45'!
field
	^field.! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 10/13/2008 16:44'!
field: anObject
	field := anObject! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:35'!
ignoreValues
	^ ignoreValues! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:35'!
ignoreValues: anObject
	ignoreValues := anObject! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/25/2008 16:11'!
initialize
	super initialize.
	self tableLinks: OrderedCollection new.! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 15:35'!
originalTable
	^ originalTable! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 15:35'!
originalTable: anObject
	originalTable := anObject! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/5/2008 16:03'!
queryClass
	^ queryClass! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/5/2008 16:03'!
queryClass: anObject
	queryClass := anObject! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/25/2008 15:53'!
tableLinks
	^ tableLinks! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/25/2008 15:53'!
tableLinks: anObject 
	tableLinks := anObject! !

Object subclass: #SqsSchemaImporter
	instanceVariableNames: 'conSpec classPrefix adapter mode tableNames tableColumns classCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqsSchemaImporter subclass: #SqsActiveRecordSchemaImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:25'!
automaticMode
	^#auto! !

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:04'!
loggingMethods
	^OrderedCollection with: (
		'acceptsLoggingOfCompilation',String cr, String tab, '^ false'
	) with: (
		'wantsChangeSetLogging', String cr, String tab,'^ false'
	)! !

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:26'!
onConSpec: sqsConSpec withPrefix: aString
	^self new
		conSpec: sqsConSpec;
		classPrefix: aString;
		mode: self safeMode;
		yourself! !

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:26'!
onConSpec: sqsConSpec withPrefix: aString inMode: aMode
	^self new
		conSpec: sqsConSpec;
		classPrefix: aString;
		mode: aMode;
		yourself! !

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 13:41'!
onConSpec: sqsConSpec withPrefix: aString inMode: aMode withCategoryName: aString2
	^self new
		conSpec: sqsConSpec;
		classPrefix: aString;
		mode: aMode;
		classCategory: aString2;
		yourself! !

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:24'!
safeMode
	^#safe! !

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:23'!
testMode
	^#test! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 12/13/2008 10:25'!
adapter
	adapter ifNil: 
		[ adapter := (SqsConnectionManager getInstance sessionForConSpec: self conSpec) sqsDbAdapter ].
	^ adapter! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
adapter: anObject
	adapter := anObject! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/21/2008 09:50'!
classCategory
	^ classCategory ifNil: [
		self classPrefix, '-Models'
	]! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/21/2008 09:49'!
classCategory: anObject
	classCategory := anObject! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:01'!
classNameForTable: tableName
	^(self classPrefix), ((tableName camelized allButLast: 1) capitalized)! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
classPrefix
	^ classPrefix! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
classPrefix: anObject
	classPrefix := anObject! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
conSpec
	^ conSpec! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
conSpec: anObject
	conSpec := anObject! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:15'!
createClass: className withInstVars: instVars
	"That's basically it - just create the class if it does not exist"
	
	Transcript show: ((instVars join: ' '), String cr).
	
	Smalltalk at: className asSymbol ifAbsent: [
		Object subclass: className asSymbol
			instanceVariableNames: (instVars join: ' ')
			classVariableNames: ''
			poolDictionaries: ''
			category: self classCategory	
	].
	self specialClassMethods: self class loggingMethods for: className asSymbol.
	! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:19'!
createClassForTable: tableName
	| instVars className curColumns |
	curColumns := self adapter showFieldsOfTable: tableName.
	instVars := self instVarsFromColumns: curColumns.
	className := self classNameForTable: tableName.
	self createClass: className withInstVars: instVars.! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 13:37'!
disableClassLogging
	^self mode = self class testMode
	
	
	! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:15'!
import
	| |
	self tableNames: self adapter allTableNames.
	Transcript show: ('Found ',tableNames size asString, 'tables', String cr).
	self tableNames doWithIndex: [:tableName :index | 
		self createClassForTable: tableName.
		Transcript show: 'Created class no. ', index asString, 'for table ', tableName, String cr.
	].
	"self createDescriptions."! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:42'!
instVarsFromColumns: curColumns
	| colName type isPrimary defaultValue instVars |
	
	instVars := Set new.
	
	curColumns do: [:row | 
		colName := row at: self adapter class fieldNameColumn.
		type := (row at: self adapter class typeColumn) asString.
		isPrimary := row at: self adapter class keyColumn.
		defaultValue := row at: self adapter class defaultColumn.
		(self isIdField: colName) ifTrue: [
			
		].
		instVars add: colName camelized.
	].

	^ instVars! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:25'!
mode
	^ mode! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:25'!
mode: anObject
	mode := anObject! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 13:18'!
specialClassMethods: anArrayOfMethodBodies for: className
	| klass |
	self disableClassLogging ifTrue: [
		klass := Smalltalk at: className.
		(anArrayOfMethodBodies ifNil: [self class loggingMethods]) do: [:methodBody |
			klass compile: methodBody classified: 'auto-generated'
		]		
	].
	
	
	! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:45'!
tableColumns
	^ tableColumns! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:45'!
tableColumns: anObject
	tableColumns := anObject! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:46'!
tableNames
	^ tableNames! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:46'!
tableNames: anObject
	tableNames := anObject! !

Object subclass: #SqsSearch
	instanceVariableNames: 'searchClass loadStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqsSearch class
	uses: TSqsSearch
	instanceVariableNames: ''!

!SqsSearch class methodsFor: 'access to cache' stamp: 'tkow 12/14/2008 20:51'!
eagerFor: aClass 
	^(self new)
		searchClass: aClass;
		loadStrategy: SqsLoadStrategy eager;
		yourself! !

!SqsSearch class methodsFor: 'as yet unclassified' stamp: 'test 1/22/2009 17:38'!
escapeMethods
	^ Dictionary new
		at: String 
			put: #printString;
		at: Timespan
			put: #asSqlValueString;
		at: DateAndTime
			put: #asSqlValueString;
		at: Time
			put: #asSqlValueString;
		at: Date
			put: #asSqlValueString;
		yourself! !

!SqsSearch class methodsFor: 'access to cache' stamp: 'tkow 9/24/2008 13:49'!
for: aClass
	^(self new)
		searchClass: aClass;
		yourself! !

!SqsSearch class methodsFor: 'access to cache' stamp: 'tkow 12/14/2008 20:51'!
for: aClass withLoadStrategy: anSqsLoadStrategy 
	^(self new)
		searchClass: aClass;
		loadStrategy: anSqsLoadStrategy;
		yourself! !

!SqsSearch class methodsFor: 'constants' stamp: 'tkow 11/4/2008 17:50'!
searchForIdField
	^'oid'! !

!SqsSearch methodsFor: 'block-searching' stamp: 'tkow 10/13/2008 16:48'!
anySatisfy: aBlock
	self detect: aBlock ifNone: [^false].
	^true! !

!SqsSearch methodsFor: 'value-searching' stamp: 'test 1/22/2009 17:42'!
blocksForAttributes: attributes andValues: values 
	| function |
	^ attributes withIndexCollect: 
		[ :attr :index | 
		| value escapedValue |
		value := values at: index.
		escapedValue := (value respondsTo: SqsDescriptionHandler sqlValueStringFunction) 
			ifTrue: 
				[ function := self class escapeMethods 
					keysAndValuesDetect: [ :classKey :functionName | value class includesBehavior: classKey]
					ifNone: [ #asString ].
				value perform: function ]
			ifFalse: [ value oid asString ].
		Compiler evaluate: '[:anObject | anObject ' , attr , ' = ' , escapedValue , ']' ]! !

!SqsSearch methodsFor: 'value-searching' stamp: 'tkow 10/14/2008 11:12'!
detect: aBlock 
	| |
	^self detect: aBlock ifNone: [self error: 'no results found']
	
	
	
! !

!SqsSearch methodsFor: 'value-searching' stamp: 'tkow 1/9/2009 13:46'!
detect: aBlock ifNone: errorBlock 
	"we could somehow rty to leave out the objects we already have locally
	 but for now we'll query them anyway because they won't be instantiated 
	 again anyways"
	| query results base |
	query := (SqsQuery on: self searchClass) analyze: aBlock.
	base := SqsClassInfo for: self searchClass.
	results := base sqsSession 
		performSearch: query
		withLimit: 1.
	^ results ifEmpty: [ errorBlock value ] ifNotEmpty: [results first]! !

!SqsSearch methodsFor: 'as yet unclassified' stamp: 'tkow 1/9/2009 19:02'!
doesNotUnderstand: aMessage
	| attributes limit |
	attributes := self class findAttributesInSelector: aMessage selector forClass: self searchClass.
	attributes ifNil: [
		^super doesNotUnderstand: aMessage.
	] ifNotNil: [
		limit := self class findLimitInSelector: aMessage selector.
		^self searchBy: attributes withValues: (aMessage arguments) limit: limit.
	].! !

!SqsSearch methodsFor: 'value-searching' stamp: 'test 1/23/2009 17:49'!
ofResult: result extract: anInteger
	^ anInteger ifNil: [ 
		result 
	] ifNotNil: [ 
		(anInteger = 1) ifTrue: [ 
			result at: 1 ifAbsent: [ nil ] 
		] ifFalse: [ 
			(anInteger < result size) 	ifTrue: [ 
				result copyFrom: 1 to: anInteger 
			] ifFalse: [ 
				result 
			] 
		] 
	] ! !

!SqsSearch methodsFor: 'value-searching' stamp: 'test 1/22/2009 17:41'!
queryUsingAttributes: attributes withValues: values 
	| blocks queries superWhereBuffer jointQuery |
	blocks := self 
		blocksForAttributes: attributes
		andValues: values.
	queries := blocks collect: 
		[ :aBlock | 
		| query |
		query := SqsQuery on: self searchClass.
		query analyze: aBlock.
		query ].
	superWhereBuffer := (queries collect: [ :query | query whereBuffer ]) join: ' AND '.
	jointQuery := SqsQuery on: self searchClass.
	jointQuery whereBuffer: superWhereBuffer.
	jointQuery valueTables: queries first valueTables.
	jointQuery queryTables: queries first queryTables.
	^ jointQuery! !

!SqsSearch methodsFor: 'value-searching' stamp: 'test 1/23/2009 17:47'!
searchBy: attributes withValues: values limit: anInteger 
	| base query result |
	base := SqsClassInfo for: self searchClass.
	^ base tableForClassExists ifTrue: [ 
		query := self queryUsingAttributes: attributes withValues: values.
		result := base sqsSession performSearch: query.
		self ofResult: result extract: anInteger.
	] ifFalse: [ 
		#() 
	]! !

!SqsSearch methodsFor: 'accessing' stamp: 'tkow 9/24/2008 14:07'!
searchClass
	^ searchClass! !

!SqsSearch methodsFor: 'accessing' stamp: 'tkow 9/24/2008 14:07'!
searchClass: anObject
	searchClass := anObject! !

!SqsSearch methodsFor: 'value-searching' stamp: 'tkow 1/9/2009 13:41'!
select: aBlock 
	"we could somehow rty to leave out the objects we already have locally
	 but for now we'll query them anyway because they won't be instantiated 
	 again anyways"
	| query results classInfo |
	query := (SqsQuery on: self searchClass) analyze: aBlock.
	classInfo := SqsClassInfo for: self searchClass.
	results := classInfo sqsSession performSearch: query.
	^ results! !

Object subclass: #SqsSession
	instanceVariableNames: 'objectCache sqsDbAdapter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsSession methodsFor: 'database operations' stamp: 'tkow 12/12/2008 22:56'!
assembleObjectFrom: splitRows forSearch: anSqsQuery 
	| targetClass targetObject currentValues oid tableConf |
	anSqsQuery valueTables withIndexDo: 
		[ :aliasedTable :index | 
		currentValues := splitRows at: index.
		tableConf := (SqsClassInfo for: aliasedTable queryClass) configuration tableConfiguration.
		oid := currentValues at: tableConf idField.
		targetClass := self 
			objectClassForRow: currentValues
			ofAliasedTable: aliasedTable
			withConfiguration: tableConf.
		targetClass ifNil: [ ^ nil ].
		targetObject := self 
			cachedObjectOf: targetClass
			withOid: oid.
		targetObject ifNil: 
			[ targetObject := self 
				newObjectWithOid: oid
				ofClass: targetClass
				fromRow: currentValues
				ofTable: aliasedTable ] ].
	^ targetObject! !

!SqsSession methodsFor: 'transaction' stamp: 'tkow 12/15/2008 10:51'!
beginTransaction
	sqsDbAdapter beginTransaction! !

!SqsSession methodsFor: 'object-caching' stamp: 'tkow 12/12/2008 22:58'!
cacheObject: anObject withOid: oid 
	SqsStorage 
		cacheObject: anObject
		withOid: oid! !

!SqsSession methodsFor: 'object-caching' stamp: 'tkow 12/12/2008 22:57'!
cachedObjectOf: targetClass withOid: oid 
	^ SqsStorage 
		cachedObjectOfClass: targetClass
		withOid: oid! !

!SqsSession methodsFor: 'transaction' stamp: 'tkow 12/15/2008 10:51'!
commitTransaction
	sqsDbAdapter commitTransaction! !

!SqsSession methodsFor: 'as yet unclassified' stamp: 'tkow 12/13/2008 11:17'!
connectionIdentityString
	^ sqsDbAdapter 
		ifNil: [nil]
		ifNotNil: [sqsDbAdapter connectionIdentityString]! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 12/13/2008 11:12'!
createObjectsFrom: rowDictionaries forSearch: anSqsQuery
	
	| objects prefixIndexes splitRows splitColName ix |
	objects := OrderedCollection new.
	prefixIndexes := Dictionary new.
	anSqsQuery valueTables withIndexDo: [:aliasedTable :index |
		aliasedTable allAliasedNames do: [ :aliasedName |
			prefixIndexes at: aliasedName put: index	
		]
	].

	rowDictionaries do: [:rowDict |
		splitRows := OrderedCollection new.
		1 to: anSqsQuery valueTables size do: [:i | splitRows add: Dictionary new].
		rowDict associationsDo: [:column |
			splitColName := column key splitBy: (self sqsDbAdapter class columnTableSeperator).
			ix := prefixIndexes at: (splitColName first) ifAbsent: [self error: 'oopsie'].
			(splitRows at: ix) at: splitColName last put: column value.
		].
		objects add: (self assembleObjectFrom: splitRows forSearch: anSqsQuery).
	].
	^objects! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 12/13/2008 11:31'!
deleteObject: anSqsStorage
	sqsDbAdapter
		removeObjectWithId: anSqsStorage oid
		fromTable: anSqsStorage classInfo classTable.
	"TODO: remove the object from cache here"! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 12/13/2008 11:14'!
getCollectionDescribedBy: descr forObject: anObject 
	| searchQuery |
	
	^ descr simpleValues ifTrue: [ 
		sqsDbAdapter 
			getSimpleCollectionDescribedBy: descr
			forObject: anObject
	] ifFalse: [ 
		searchQuery := sqsDbAdapter 
			searchForCollectionDescribedBy: descr
			ofObject: anObject.
		self performSearch: searchQuery
	]! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 12/15/2008 10:51'!
inTransactionDo: aBlock
	self inTransactionDo: aBlock onError: [sqsDbAdapter rollback].! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 12/15/2008 10:50'!
inTransactionDo: aBlock onError: anErrorBlock
	[sqsDbAdapter beginTransaction.
	aBlock value.
	sqsDbAdapter commitTransaction] ifError: [anErrorBlock value]
	! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 12/12/2008 22:57'!
newObjectWithOid: oid ofClass: targetClass fromRow: currentValues ofTable: aliasedTable 
	| newObject storageHelper |
	newObject := targetClass basicNew.
	self 
		cacheObject: newObject
		withOid: oid.
	storageHelper := SqsStorage for: newObject.
	aliasedTable originalTable allColumns do: 
		[ :col | 
		storageHelper 
			setInstVarNamed: col linkedVariable
			withValue: (currentValues at: col columnName) ].
	storageHelper indirectlyReferencedObjects do: 
		[ :collectionDescr | 
		storageHelper 
			setInstVarNamed: collectionDescr collectionDescription linkedVariable
			withValue: nil ].
	^ newObject! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 12/12/2008 22:01'!
objectCache
	^ objectCache! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 12/12/2008 22:01'!
objectCache: anObject
	objectCache := anObject! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 12/12/2008 22:57'!
objectClassForRow: currentValues ofAliasedTable: aliasedTable withConfiguration: tableConf
	| targetClassName |
	targetClassName := currentValues at: tableConf typeField ifAbsent: [self error: 'no type field found'].
	targetClassName ifNil:[
		^ nil	
	] ifNotNil: [
		^ Smalltalk at: targetClassName asSymbol ifAbsent: [aliasedTable queryClass].
	]
	! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 12/12/2008 22:57'!
performSearch: anSqsQuery
	^ self performSearch: anSqsQuery withLimit: nil! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 12/12/2008 22:57'!
performSearch: anSqsQuery withLimit: aLimit
	| rowDicts |
	rowDicts := self sqsDbAdapter performSearch: anSqsQuery withLimit: aLimit.
	^ self createObjectsFrom: rowDicts forSearch: anSqsQuery.! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 12/12/2008 22:01'!
sqsDbAdapter
	^ sqsDbAdapter! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 12/12/2008 22:01'!
sqsDbAdapter: anObject
	sqsDbAdapter := anObject! !

Object subclass: #SqsStorage
	instanceVariableNames: 'storedObject oid classInfo tableStructureHandler descriptionHandler stored sqsSession instVarMap'
	classVariableNames: 'ObjectCache ObjectIdCache TableCache'
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqsStorage class
	instanceVariableNames: 'InstanceCache'!

SqsStorage class
	instanceVariableNames: 'InstanceCache'!

SqsStorage subclass: #SqsDevStorage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsDevStorage methodsFor: 'object-persistence' stamp: 'tkow 1/18/2009 15:39'!
saveObject
	self createClassDescription.
	self tableForClassExists
		ifTrue: [self tableStructureHandler updateTableStructure]
		ifFalse: [self tableStructureHandler createTableStructure].
	self newRecord
		ifTrue: [self createRecord]
		ifFalse: [self updateRecord].! !

SqsStorage subclass: #SqsProductionStorage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsProductionStorage methodsFor: 'as yet unclassified' stamp: 'tkow 1/6/2009 16:12'!
saveObject
	self newRecord
		ifTrue: [self createRecord]
		ifFalse: [self updateRecord].! !

!SqsStorage class methodsFor: 'object-caching' stamp: 'tkow 12/4/2008 17:13'!
cacheObject: anObject withOid: oid
	self objectCache cacheObject: anObject withOid: oid.
! !

!SqsStorage class methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:18'!
cachedObjectOfClass: aClass withOid: oid 
	^self objectCache cachedObjectOfClass: aClass withOid: oid! !

!SqsStorage class methodsFor: 'proxy-creation' stamp: 'tkow 12/12/2008 17:43'!
createCollectionProxyFor: ivarName with: anObject in: proxyHolder description: description 
	^ (anObject class includesBehavior: SqsProxy) 
		ifTrue: [ anObject ]
		ifFalse: 
			[ SqsCollectionProxy 
				for: anObject
				ofInstVar: ivarName
				in: proxyHolder
				simpleValues: description simpleValues ]! !

!SqsStorage class methodsFor: 'proxy-creation' stamp: 'tkow 12/12/2008 17:42'!
createProxyFor: ivarName with: anObject in: proxyHolder 
	^ (anObject class includesBehavior: SqsProxy) 
		ifTrue: [ anObject ]
		ifFalse: 
			[ SqsProxy 
				for: anObject
				ofInstVar: ivarName
				in: proxyHolder ]! !

!SqsStorage class methodsFor: 'as yet unclassified' stamp: 'tkow 1/6/2009 15:57'!
development
	"this somewhat brakes the iron 'no magic values' rule, but I think it is more elegant
	 than the if else stuff..."
	^ SqsDevStorage! !

!SqsStorage class methodsFor: 'cache-flushing' stamp: 'tkow 10/10/2008 14:59'!
flushInstanceCache
	InstanceCache := nil! !

!SqsStorage class methodsFor: 'cache-flushing' stamp: 'tkow 12/4/2008 17:11'!
flushObjectCache
	self objectCache clear.! !

!SqsStorage class methodsFor: 'access to cache' stamp: 'tkow 1/6/2009 14:57'!
for: anObject
	^ (self instanceCacheFor: anObject class) 
		at: anObject
		ifAbsentPut: 
			[ (self storageClassFor: anObject) new
				storedObject: anObject;
				classInfo: (SqsClassInfo for: anObject class);
				yourself ]! !

!SqsStorage class methodsFor: 'access to cache' stamp: 'tkow 1/6/2009 14:34'!
instanceCacheFor: aClass
	InstanceCache ifNil: [
		InstanceCache := Dictionary new.	
	].
	^ InstanceCache at: aClass name ifAbsentPut: [WeakIdentityKeyDictionary new]! !

!SqsStorage class methodsFor: 'cache-flushing' stamp: 'tkow 12/12/2008 17:42'!
objectCache
	ObjectCache ifNil: [ ObjectCache := SqsObjectCache new ].
	^ ObjectCache! !

!SqsStorage class methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:22'!
oidFor: anObject
	^ self objectCache oidFor: anObject! !

!SqsStorage class methodsFor: 'as yet unclassified' stamp: 'tkow 1/6/2009 15:53'!
production
	^ SqsProductionStorage! !

!SqsStorage class methodsFor: 'access to cache' stamp: 'tkow 1/6/2009 15:08'!
storageClassFor: anObject
	| configuration |
	"instead of putting some sort of if-then-else here, I rely on the fact that the respective
	 storage classes will respond to a message named like the chosen mode"
	configuration := (SqsClassInfo for: anObject class) configuration. 
	^ self perform: configuration environment! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:35'!
baseClass
	^self classInfo baseClass! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:28'!
classInfo
	^classInfo ! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:26'!
classInfo: anObject
	classInfo := anObject! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 11/21/2008 22:11'!
configuration
	^self classInfo configuration! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 10/10/2008 11:07'!
createClassDescription
	self descriptionHandler createDescriptions! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 1/19/2009 17:27'!
createInstVarMap
	| |
	self storedObject instVarDict associationsDo: [:assoc |
		(assoc value class respondsTo: (SqsDescriptionHandler sqlValueStringFunction)) ifTrue: [
			instVarMap at: assoc key put: assoc value	
		]	
	].! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 12/15/2008 11:45'!
createRecord
	self directlyReferencedObjects do: [ :obj | obj save: sqsSession ].
	"next store the object itself"
	self oid: self tableStructureHandler insertCurrentObject.
	"store all objects the sample object holds within one-to-many associations"
	self tableStructureHandler insertOwnedCollections.! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 14:10'!
descriptionHandler
	descriptionHandler ifNil: [
		descriptionHandler := self classInfo descriptionHandlerClass forObject: self
	].
	^descriptionHandler
	! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 13:17'!
descriptionHandler: anObject
	descriptionHandler := anObject! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 12/13/2008 10:48'!
destroy
	self oid ifNotNil: [ 
		self sqsSession deleteObject: self	
	]! !

!SqsStorage methodsFor: 'object-information' stamp: 'tkow 9/29/2008 15:29'!
directlyReferencedObjects
	^self descriptionHandler directlyReferencedObjects! !

!SqsStorage methodsFor: 'iterating' stamp: 'tkow 9/30/2008 14:21'!
doForAllSuperclasses: aBlock
	self classInfo doForAllSuperclasses: aBlock! !

!SqsStorage methodsFor: 'object-access' stamp: 'tkow 10/9/2008 16:43'!
escapedValueForInstVar: instVarName 
	| ivarValue objectId |
	" get the current value of the instance variable"
	ivarValue := self valueOfInstVar: instVarName.

	" if an object has an asSqlValueString method, fine - use this
	 the other objects are treated as complex ones and we should already have an oid for them"
	^ (ivarValue respondsTo: #asSqlValueString) 
		ifTrue: [ ivarValue asSqlValueString ]
		ifFalse: 
			[ objectId := self class oidFor: ivarValue.
			objectId 
				ifNil: [ nil asSqlValueString ]
				ifNotNil: [ objectId ] ]! !

!SqsStorage methodsFor: 'object-information' stamp: 'tkow 9/29/2008 15:30'!
indirectlyReferencedObjects
	^self descriptionHandler indirectlyReferencedObjects! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 1/19/2009 17:28'!
initialize
	super initialize.
	instVarMap := Dictionary new.! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 1/19/2009 17:35'!
isDirty
	self newRecord ifTrue: [^ true].
	self storedObject instVarDict associationsDo: [:assoc |
		(assoc value class respondsTo: (SqsDescriptionHandler sqlValueStringFunction)) ifTrue: [
			(instVarMap includesKey: assoc key) ifTrue: [
				(assoc value = (instVarMap at: assoc key)) ifFalse: [
					^ true	
				]
			] ifFalse: [
				^ true
			]
		]	
	].
	^ false! !

!SqsStorage methodsFor: 'object-access' stamp: 'test 1/24/2009 15:35'!
loadProxiedCollectionFor: ivarName 
	| descr collectionElements |
	descr := self descriptionHandler sqsDescriptionForInstVar: ivarName.
	collectionElements := self sqsSession 
		getCollectionDescribedBy: descr
		forObject: self.
	^ descr collectionClass withAll: collectionElements! !

!SqsStorage methodsFor: 'object-access' stamp: 'test 1/24/2009 15:35'!
loadProxiedObjectFor: ivarName withOid: anObjectId 
	| descr |
	descr := self descriptionHandler sqsDescriptionForInstVar: ivarName.
	^ (Smalltalk at: descr associatedClass) 
		perform: #findByOid
		with: anObjectId! !

!SqsStorage methodsFor: 'accessing' stamp: 'tk 5/26/2008 15:18'!
newRecord
	^self oid isNil.! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 14:29'!
oid
	oid ifNil: [
		oid := self class oidFor: self storedObject.
	].
	^oid! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 14:30'!
oid: anInteger
	oid := anInteger.
	self class cacheObject: self storedObject withOid: oid.! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 1/19/2009 17:36'!
save
	"just to avoid circular calls of the save function"
	self stored ifFalse: [
		self stored: true.
		self saveObject.
		self createInstVarMap.
		self stored: false
	].
! !

!SqsStorage methodsFor: 'as yet unclassified' stamp: 'tkow 1/6/2009 16:12'!
saveObject
	self subclassResponsibility! !

!SqsStorage methodsFor: 'object-access' stamp: 'tkow 1/19/2009 17:24'!
setInstVarNamed: ivarName withValue: anObject 
	"only set instvars of ourselves and ignore those of subclasses"
	| object |
	(self storedObject class allInstVarNames includes: ivarName) ifTrue: [ 
		object := self descriptionHandler 
			adaptObject: anObject
			toSpecificationOfInstVar: ivarName.
		self descriptionHandler useInstVarAccessors ifTrue: [ 
			self storedObject 
				perform: (ivarName , ':') asSymbol
				with: object 
		] ifFalse: [ 
			self storedObject 
				instVarNamed: ivarName
				put: object 
		]
	].
	"and update the instvarmap if we don't have a proxy or another complex object'"	
	(anObject class includesSelector: SqsDescriptionHandler sqlValueStringFunction) ifTrue: [
		instVarMap at: ivarName put: anObject
	].! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 12/12/2008 23:14'!
sqsSession
	sqsSession ifNil: [ sqsSession := self classInfo sqsSession ].
	^ sqsSession! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 12/12/2008 23:09'!
sqsSession: aConnection 
	sqsSession := aConnection! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 16:35'!
stored
	stored ifNil: [stored := false].
	^stored! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 16:26'!
stored: anObject
	stored := anObject! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:33'!
storedObject
	^ storedObject! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 1/19/2009 17:34'!
storedObject: anObject
	storedObject := anObject.
	self createInstVarMap.! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 1/18/2009 16:06'!
tableForClassExists
	^ self tableStructureHandler tableForClassExists! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 12/12/2008 17:44'!
tableStructureHandler
	tableStructureHandler ifNil: [ tableStructureHandler := SqsTableStructureHandler forObject: self ].
	^ tableStructureHandler! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 13:17'!
tableStructureHandler: anObject
	tableStructureHandler := anObject! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 1/17/2009 15:38'!
updateRecord
	self directlyReferencedObjects do: [:obj | obj save].
	"self isDirty ifTrue: [
	"	self tableStructureHandler updateObject.	
	"]."
	self tableStructureHandler updateOwnedCollections.
	! !

!SqsStorage methodsFor: 'object-access' stamp: 'tkow 10/7/2008 18:46'!
valueOfInstVar: instVarName 
	^(self storedObject class allInstVarNames includes: instVarName) ifTrue: [
		self descriptionHandler useInstVarAccessors 
			ifTrue: [ self storedObject perform: instVarName asSymbol ]
			ifFalse: [ self storedObject instVarNamed: instVarName asSymbol ].
	] ifFalse: [
		nil
	]! !

Object subclass: #SqsTableCache
	instanceVariableNames: 'tableCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsTableCache class methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:00'!
classTableKey
	^ #classTable! !

!SqsTableCache class methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
existenceKey
	^ #exists! !

!SqsTableCache class methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
joinTableKey
	^ #joinTables! !

!SqsTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 12/6/2008 15:48'!
cacheForClass: aClassName
	^ self tableCache at: aClassName ifAbsentPut: [Dictionary new]! !

!SqsTableCache methodsFor: 'accessing' stamp: 'tkow 12/6/2008 11:16'!
initialize
	super initialize.
	self tableCache: Dictionary new. ! !

!SqsTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
insertJoinTable: joinTable forClass: aClassName 
	| tCache jtCache |
	tCache := self cacheForClass: aClassName.
	jtCache := tCache 
		at: self class joinTableKey
		ifAbsentPut: [ Dictionary new ].
	jtCache 
		at: joinTable tableName
		ifAbsentPut: joinTable! !

!SqsTableCache methodsFor: 'as yet unclassified' stamp: 'test 1/22/2009 19:43'!
insertTable: classTable forClass: aClassName 
	| tCache |
	tCache := self cacheForClass: aClassName.
	tCache 
		at: self class existenceKey
		put: true.
	tCache 
		at: self class classTableKey
		put: classTable! !

!SqsTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
joinTableNamed: aName forClass: aClassName 
	| tCache jCache |
	tCache := self cacheForClass: aClassName.
	tCache 
		at: self class existenceKey
		put: true.
	jCache := tCache 
		at: self class joinTableKey
		ifAbsentPut: [ Dictionary new ].
	^ jCache 
		at: aName
		ifAbsent: [ nil ]! !

!SqsTableCache methodsFor: 'accessing' stamp: 'tkow 12/5/2008 21:01'!
tableCache
	^ tableCache! !

!SqsTableCache methodsFor: 'accessing' stamp: 'tkow 12/5/2008 21:01'!
tableCache: anObject
	tableCache := anObject! !

!SqsTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
tableExistsForClass: aClassName 
	^ (self cacheForClass: aClassName) 
		at: self class existenceKey
		ifAbsent: [ false ]! !

!SqsTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:00'!
tableForClass: aClassName 
	^ (self cacheForClass: aClassName) 
		at: self class classTableKey
		ifAbsent: [ nil ]! !

Object subclass: #SqsTableChanges
	instanceVariableNames: 'oldTable newTable addedColumns removedColumns alteredColumns renamedColumns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsTableChanges class methodsFor: 'as yet unclassified' stamp: 'tkow 10/9/2008 11:29'!
oldTable: anSqSTable newTable: anotherSqSTable
	^self new
		oldTable: anSqSTable;
		newTable: anotherSqSTable;
		yourself! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
addedColumns
	^ addedColumns! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
addedColumns: anObject
	addedColumns := anObject! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
alteredColumns
	^ alteredColumns! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
alteredColumns: anObject
	alteredColumns := anObject! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:53'!
calculateChanges
	| oldColumns newColumns |
	oldColumns := self oldTable columns.
	newColumns := self newTable columns.
	oldColumns do: [ :oldColumn | 
		| curColumn |
		curColumn := newColumns detect: [:col | col linkedVariable = oldColumn linkedVariable] ifNone: [nil].
		curColumn ifNil: [ 
			self removedColumns add: oldColumn
		] ifNotNil: [ 
			curColumn columnName ~= oldColumn columnName ifTrue: [ 
				self renamedColumns add: (OrderedCollection 
					with: oldColumn
					with: curColumn) 
			].
			(curColumn sqlType ~= oldColumn sqlType and: [ curColumn sqlType isNil not ]) ifTrue: [ 
				self alteredColumns add: curColumn 
			] 
		] 
	].
	self addedColumns addAll: (newColumns select: [ :newColumn | 
		(oldColumns anySatisfy: [:oldColumn | oldColumn linkedVariable = newColumn linkedVariable]) not 
	]).! !

!SqsTableChanges methodsFor: 'initialization' stamp: 'tkow 10/9/2008 11:21'!
initialize
	super initialize.
	addedColumns := OrderedCollection new.
	alteredColumns := OrderedCollection new.
	removedColumns := OrderedCollection new.
	renamedColumns := OrderedCollection new.! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:30'!
newTable
	^ newTable! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:30'!
newTable: anObject
	newTable := anObject! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 14:46'!
newTableName
	^(self oldTable tableName ~= self newTable tableName) ifTrue: [
		self newTable tableName
	] ifFalse: [
		nil
	]! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:30'!
oldTable
	^ oldTable! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:30'!
oldTable: anObject
	oldTable := anObject! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
removedColumns
	^ removedColumns! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
removedColumns: anObject
	removedColumns := anObject! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
renamedColumns
	^ renamedColumns! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
renamedColumns: anObject
	renamedColumns := anObject! !

Object subclass: #SqsTableConfiguration
	uses: TSqsSelfPrinting
	instanceVariableNames: 'inheritanceMode typeField idField tableName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

SqsTableConfiguration class
	uses: TSqsSelfPrinting classTrait
	instanceVariableNames: ''!

!SqsTableConfiguration class methodsFor: 'presets' stamp: 'tkow 12/12/2008 17:44'!
activeRecordStyle
	^ self new
		typeField: 'type';
		idField: 'id';
		inheritanceMode: SqsTableStructureHandler singleTableInheritance;
		yourself! !

!SqsTableConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:09'!
standardIdField
	^'sqs_oid'! !

!SqsTableConfiguration class methodsFor: 'standard values' stamp: 'tkow 12/12/2008 17:44'!
standardInheritanceMode
	^ SqsTableStructureHandler singleTableInheritance! !

!SqsTableConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:09'!
standardTypeField
	^'sqs_type_field'! !

!SqsTableConfiguration methodsFor: 'printing' stamp: 'test 1/27/2009 11:29'!
codeForObjectCreation
	| aStream |
	aStream := TextStream on: String new.
	aStream nextPut: $(.
	aStream nextPutAll: self class name , ' new'.
	aStream nextPutAll: String crlf , String tab.
	1 
		to: self class instSize
		do: 
			[ :i | 
			(self instVarAt: i) ifNotNil: 
				[ aStream
					nextPutAll: String cr , String tab;
					nextPutAll: ' ' , (self class allInstVarNames at: i) , ': ';
					store: (self instVarAt: i);
					nextPut: $; ] ].
	aStream nextPutAll: String cr , String tab , ' yourself)'.
	^ aStream contents! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
idField
	^ idField! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
idField: anObject
	idField := anObject! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
inheritanceMode
	^ inheritanceMode! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
inheritanceMode: anObject
	inheritanceMode := anObject! !

!SqsTableConfiguration methodsFor: 'as yet unclassified' stamp: 'tkow 11/7/2008 15:06'!
initialize
	super initialize.
	self idField: self class standardIdField.
	self inheritanceMode: self class standardInheritanceMode.
	self typeField: self class standardTypeField.! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:07'!
tableName
	^ tableName! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:07'!
tableName: anObject
	tableName := anObject! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
typeField
	^ typeField! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
typeField: anObject
	typeField := anObject! !

Object subclass: #SqsTableLink
	instanceVariableNames: 'joinDirection fromFields toFields toTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsTableLink class methodsFor: 'as yet unclassified' stamp: 'tkow 11/25/2008 13:12'!
table: aTable fromField: aString toField: anotherString direction: joinSql
	| instance |
	instance := self new
		toTable: aTable;
		joinDirection: joinSql;
		yourself.
		
	instance fromFields add: aString.
	instance toFields add: anotherString.
	^ instance! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 13:10'!
fromFields
	^ fromFields! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 13:10'!
fromFields: anObject
	fromFields := anObject! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 14:23'!
initialize
	super initialize.
	self fromFields: OrderedCollection new.
	self toFields: OrderedCollection new.! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:34'!
joinDirection
	^ joinDirection! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:34'!
joinDirection: anObject
	joinDirection := anObject! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 13:10'!
toFields
	^ toFields! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 13:10'!
toFields: anObject
	toFields := anObject! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:34'!
toTable
	^ toTable! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:34'!
toTable: anObject
	toTable := anObject! !

Object subclass: #SqsTableStructureHandler
	instanceVariableNames: 'currentObject classInfo'
	classVariableNames: 'TableCache'
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqsTableStructureHandler subclass: #SqsClassTableInheritanceHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsClassTableInheritanceHandler methodsFor: 'table-operations' stamp: 'tkow 10/21/2008 17:42'!
classTable
	| table |
	table := self tableForClassInfo: self classInfo.
	self createParentsForTable: table ofClass: self classInfo.
	self createChildrenForTable: table ofClass: self classInfo.
	^table
! !

!SqsClassTableInheritanceHandler methodsFor: 'table-operations' stamp: 'tkow 12/12/2008 17:38'!
createChildrenForTable: table ofClass: baseInfo 
	| childInfo childTable |
	baseInfo currentClass subclasses do: 
		[ :subClass | 
		childInfo := SqsClassInfo for: subClass.
		childTable := self tableForClassInfo: childInfo.
		childTable parent: table.
		self 
			createChildrenForTable: childTable
			ofClass: childInfo ]! !

!SqsClassTableInheritanceHandler methodsFor: 'table-operations' stamp: 'tkow 12/12/2008 17:38'!
createParentsForTable: table ofClass: classInf 
	| parentInfo parentTable |
	classInf currentClass ~= classInf baseClass ifTrue: 
		[ parentInfo := SqsClassInfo for: classInf currentClass superclass.
		parentTable := self tableForClassInfo: parentInfo.
		table parent: parentTable.
		self 
			createParentsForTable: parentTable
			ofClass: parentInfo ]! !

SqsTableStructureHandler subclass: #SqsSingleTableInheritanceHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsSingleTableInheritanceHandler methodsFor: 'table-operations' stamp: 'tkow 12/12/2008 17:38'!
classTable
	| table baseClassInfo newColumns |
	baseClassInfo := SqsClassInfo for: self classInfo baseClass.
	table := self tableForClassInfo: baseClassInfo.
	baseClassInfo currentClass allSubclasses do: 
		[ :subClass | 
		newColumns := (SqsClassInfo for: subClass) classTableColumns.
		table columns addAll: newColumns ].
	table columns do: [ :column | column tableName: table tableName ].
	^ table! !

!SqsSingleTableInheritanceHandler methodsFor: 'as yet unclassified' stamp: 'tkow 1/18/2009 17:00'!
tableForClassExists
	^ self tableCache tableExistsForClass: self classInfo baseClass name.! !

!SqsSingleTableInheritanceHandler methodsFor: 'accessing' stamp: 'tkow 9/30/2008 13:14'!
tableName
	^self classInfo baseClass name asSqSaveTableName! !

!SqsTableStructureHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 15:56'!
classTableInheritance
	^#classTableInheritance! !

!SqsTableStructureHandler class methodsFor: 'cache-access' stamp: 'tkow 12/4/2008 18:11'!
clearTableCache
	TableCache := nil.! !

!SqsTableStructureHandler class methodsFor: 'cache-access' stamp: 'tkow 12/4/2008 18:13'!
clearTableCacheFor: aClass
	TableCache at: aClass name put: [Dictionary new]! !

!SqsTableStructureHandler class methodsFor: 'cached-creation' stamp: 'tkow 10/6/2008 18:25'!
forClassInfo: aClassInfo
	| targetClass |
	targetClass := self targetClassForClassInfo: aClassInfo.
	"initialize the table cache (if not already done...)"
	TableCache ifNil: [TableCache := Dictionary new].
	^ targetClass new 
		classInfo: aClassInfo;
		yourself! !

!SqsTableStructureHandler class methodsFor: 'cached-creation' stamp: 'tkow 9/30/2008 11:47'!
forObject: anSqSStorageObject 
	| targetClass |
	targetClass := self targetClassForClassInfo: anSqSStorageObject classInfo.
	TableCache ifNil: [TableCache := Dictionary new].
	^ targetClass new 
		currentObject: anSqSStorageObject;
		classInfo: anSqSStorageObject  classInfo;
		yourself! !

!SqsTableStructureHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 15:56'!
singleTableInheritance
	^#singleTableInheritance! !

!SqsTableStructureHandler class methodsFor: 'cache-access' stamp: 'tkow 12/6/2008 15:20'!
tableCache
	^TableCache! !

!SqsTableStructureHandler class methodsFor: 'cached-creation' stamp: 'tkow 12/12/2008 17:47'!
targetClassForClassInfo: classInfo 
	| targetClass |
	targetClass := SqsSingleTableInheritanceHandler.
	classInfo inheritanceMode = self classTableInheritance ifTrue: [ targetClass := SqsClassTableInheritanceHandler ].
	^ targetClass! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'test 1/22/2009 19:43'!
changesOfClassTable: anSqSTable 
	| oldTable changes |
	oldTable := self tableCache tableForClass: anSqSTable associatedClass.
	oldTable 
		ifNil: [ self createTable: anSqSTable ]
		ifNotNil: 
			[ changes := (SqsTableChanges 
				oldTable: oldTable
				newTable: anSqSTable) calculateChanges ].
	^ changes! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/12/2008 17:40'!
changesOfJoinTable: joinTable 
	| oldTable changes |
	oldTable := self tableCache 
		joinTableNamed: joinTable tableName
		forClass: self classInfo baseClass name.
	oldTable 
		ifNil: [ self createTable: joinTable ]
		ifNotNil: 
			[ changes := (SqsTableChanges 
				oldTable: oldTable
				newTable: joinTable) calculateChanges ].
	^ changes! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 9/29/2008 17:30'!
classInfo
	^classInfo! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 9/29/2008 17:26'!
classInfo: anObject 
	classInfo := anObject! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 10/6/2008 17:40'!
classTable
	^self subclassResponsibility! !

!SqsTableStructureHandler methodsFor: 'object-access' stamp: 'tkow 12/11/2008 15:21'!
columnValueDictionaryFor: classTable
	| columnValueDictionary |
	columnValueDictionary := Dictionary new.
	classTable columns do: [:column |
		| value |
		column ~= classTable oidColumn ifTrue: [
			value := self currentObject escapedValueForInstVar: column linkedVariable.
			columnValueDictionary at: column columnName put: value.
		]
	].
	^columnValueDictionary! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/6/2008 15:39'!
createClassTable: anSqSTable
	self createTable: anSqSTable.
	self insertClassTableToCache: anSqSTable.
	anSqSTable children do: [ :childTable | self createClassTable: childTable ].! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/13/2008 10:46'!
createJoinTableFromDescription: collectionDescription 
	| joinTable |
	joinTable := self joinTableForDescription: collectionDescription.
	self currentAdapter createTable: joinTable.
	self insertJoinTableToCache: joinTable! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/13/2008 10:44'!
createTable: anSqSTable 
	| |
	self currentAdapter createTable: anSqSTable! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/6/2008 15:38'!
createTableStructure
	| table |
	table := self classTable baseTable.
	self createClassTable: table.
	
	self currentObject indirectlyReferencedObjects do: [ :collectionInfo | 
		self createJoinTableFromDescription: (collectionInfo collectionDescription) 
	]! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 1/18/2009 16:22'!
currentAdapter
	^ classInfo sqsSession sqsDbAdapter! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:05'!
currentObject
	^ currentObject! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:04'!
currentObject: anObject 
	currentObject := anObject! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 12/13/2008 10:45'!
currentSession
	^currentObject sqsSession! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'test 1/22/2009 19:51'!
getTableChanges
	| allChanges classTable curChanges |
	allChanges := OrderedCollection new.

	"first collect the change objects for all class tables"
	classTable := self classTable.
	
	[ curChanges := self changesOfClassTable: classTable.
	curChanges ifNotNil: [ allChanges add: curChanges ].
	self insertClassTableToCache: classTable.
	classTable := classTable parent ] doWhileTrue: [ classTable isNil not ].

	"but also the join tables can change, so we have to take this into account, too"
	self currentObject indirectlyReferencedObjects do: 
		[ :collectionInfo | 
		| joinTable |
		joinTable := self joinTableForDescription: collectionInfo collectionDescription.
		curChanges := self changesOfJoinTable: joinTable.
		curChanges ifNotNil: [ allChanges add: curChanges ].
		self insertJoinTableToCache: joinTable ].
	^ allChanges! !

!SqsTableStructureHandler methodsFor: 'cache-operations' stamp: 'test 1/22/2009 19:43'!
insertClassTableToCache: classTable
	| |
	self tableCache insertTable: classTable forClass: classTable associatedClass! !

!SqsTableStructureHandler methodsFor: 'object-insertion' stamp: 'tkow 12/13/2008 10:52'!
insertCurrentObject
	| baseTable classTable adapter columnDictionary oid |
	classTable := self classInfo classTable.
	baseTable := classTable baseTable.
	adapter := self currentAdapter.
	"first store the data that belongs into the base table along with the type field"
	columnDictionary := self columnValueDictionaryFor: baseTable.
	columnDictionary 
		at: baseTable typeColumn columnName
		put: self currentObject storedObject class name asSqlValueString.
	oid := adapter 
		storeColumns: columnDictionary
		inTable: baseTable
		andReturnOId: true.
	
	"then walk the inheritance chain up from the real class table and insert those values, too"
	[ classTable = baseTable ] whileFalse: 
		[ columnDictionary := self columnValueDictionaryFor: classTable.
		columnDictionary 
			at: classTable oidColumn columnName
			put: oid asSqlValueString.
		adapter 
			storeColumns: columnDictionary
			inTable: classTable.
		classTable := classTable parent ].
	^ oid! !

!SqsTableStructureHandler methodsFor: 'object-insertion' stamp: 'tkow 12/13/2008 10:52'!
insertIndirectlyReferencedObject: collectionInformation 
	| connection columnDict collectionDescription counter collection |
	connection := self currentAdapter.
	columnDict := Dictionary new.
	collectionDescription := collectionInformation collectionDescription.
	counter := 1.
	collection := collectionInformation collection ifNil: [ OrderedCollection new ].
	collection do: 
		[ :obj | 
		| index |
		collection isDictionary 
			ifTrue: [ index := collection keyAtValue: obj ]
			ifFalse: [ index := counter ].
		columnDict := Dictionary new.
		columnDict 
			at: collectionDescription referenceColumn columnName
			put: (self 
					valueForObject: obj
					ofCollectionDescribedBy: collectionDescription).
		columnDict 
			at: collectionDescription ownerColumn columnName
			put: self currentObject oid.
		collectionDescription maintainOrder ifTrue: 
			[ columnDict 
				at: collectionDescription configuration orderField
				put: index asSqlValueString ].
		counter := counter + 1.
		connection 
			storeColumns: columnDict
			inTable: (self joinTableForDescription: collectionDescription) ]! !

!SqsTableStructureHandler methodsFor: 'cache-operations' stamp: 'tkow 12/6/2008 15:47'!
insertJoinTableToCache: anSqSTable
	| |
	self tableCache insertJoinTable: anSqSTable forClass: self classInfo baseClass name.! !

!SqsTableStructureHandler methodsFor: 'object-insertion' stamp: 'tkow 12/12/2008 17:45'!
insertOwnedCollections
	self currentObject indirectlyReferencedObjects do: 
		[ :collectionInfo | 
		self insertIndirectlyReferencedObject: collectionInfo.
		self currentObject 
			setInstVarNamed: collectionInfo collectionDescription linkedVariable
			withValue: (SqsStorage 
					createCollectionProxyFor: collectionInfo collectionDescription linkedVariable
					with: collectionInfo collection
					in: self currentObject storedObject
					description: collectionInfo collectionDescription) ]! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'test 1/26/2009 17:07'!
joinTableForDescription: collectionDescription 
	| table orderColumn |
	table := SqsTable new
		tableName: collectionDescription tableName;
		associatedClass: self classInfo baseClass name.
	collectionDescription ownerColumn isPrimaryKey: true.
	table columns add: collectionDescription ownerColumn.
	collectionDescription referenceColumn isPrimaryKey: true.
	table columns add: collectionDescription referenceColumn.
	collectionDescription maintainOrder ifTrue: 
		[ orderColumn := SqsColumn new
			columnName: collectionDescription configuration orderField;
			sqlType: collectionDescription indexType;
			isPrimaryKey: true.
		table columns add: orderColumn ].
	table columns do: [ :col | col tableName: table tableName ].
	"the oid field is there to merely maintain compatibility with AR
	 the join table objects can be instances of separate classes if they have a unique id"
	" Unfortunately this leads to errors, since the primary key for some reason can't be composed 
	 of an auto increment serial field and other fields..."
	"table addOidColumnNamed: self classInfo configuration tableConfiguration idField."
	^ table! !

!SqsTableStructureHandler methodsFor: 'object-updating' stamp: 'tkow 12/13/2008 10:53'!
storeCollectionChanges: collectionChanges withDescription: aDescription 
	| adapter oid |
	adapter := self currentAdapter.
	oid := self currentObject oid.
	collectionChanges deletedObjects ifNotEmpty: 
		[ adapter 
			removeEntries: collectionChanges deletedObjects
			fromJoinTable: aDescription
			forOwnerId: oid ].

	"only move the Entries if the order is important"
	(collectionChanges movedObjects isEmpty not and: [ aDescription maintainOrder ]) ifTrue: 
		[ adapter 
			moveEntries: collectionChanges movedObjects
			inJoinTable: aDescription
			forOwnerId: oid ].
	collectionChanges addedObjects ifNotEmpty: 
		[ adapter 
			addEntries: collectionChanges addedObjects
			inJoinTable: aDescription
			forOwnerId: oid ]! !

!SqsTableStructureHandler methodsFor: 'cache-operations' stamp: 'tkow 12/13/2008 10:54'!
tableCache
	TableCache ifNil: [ TableCache := Dictionary new ].
	^ TableCache 
		at: self currentAdapter connectionIdentityString
		ifAbsentPut: [ SqsTableCache new ]! !

!SqsTableStructureHandler methodsFor: 'cache-operations' stamp: 'tkow 10/7/2008 17:05'!
tableCacheForClass: aClass
	^TableCache at: aClass name ifAbsentPut: [Dictionary new].
! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 1/18/2009 16:21'!
tableForClassExists
	^ self tableCache tableExistsForClass: self classInfo currentClass name.
	"TODO: if there is no entry in the cache, we should ask the adapter and create reverse
	engineer the current table structure"! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'test 1/22/2009 19:51'!
tableForClassInfo: classInf 
	| table baseTableName oidColumnName typeColumnName |
	table := SqsTable new.
	table tableName: classInf tableName.
	table structure: self class classTableInheritance.
	table columns: classInf classTableColumns.
	oidColumnName := self classInfo configuration tableConfiguration idField.
	typeColumnName := self classInfo configuration tableConfiguration typeField.

	table columns do: [ :col | col tableName: table tableName ].

	table associatedClass: classInf currentClass name.
	classInf baseClass = classInf currentClass 
		ifTrue: 
			[ table addTypeColumnNamed: typeColumnName.
			table addOidColumnNamed: oidColumnName ]
		ifFalse: 
			[ baseTableName := (SqsClassInfo for: classInf baseClass) tableName.
			table 
				addLightOidColumnNamed: oidColumnName
				linkedTo: baseTableName ].
	classInf cachedClassTable: table.
	^ table! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 9/30/2008 13:14'!
tableName
	^self classInfo currentClass name asSqSaveTableName ! !

!SqsTableStructureHandler methodsFor: 'object-updating' stamp: 'tkow 12/15/2008 11:41'!
updateObject
	"store all directly associated objects right now"
	| adapter classTable columnValueDictionary typeField oidField |
	adapter := self currentAdapter.
	oidField := self classInfo configuration tableConfiguration idField.
	typeField := self classInfo configuration tableConfiguration typeField.

	"the go along for each class table and insert the values into the table"
	classTable := self classInfo classTable.
	
	[ columnValueDictionary := self columnValueDictionaryFor: classTable.
	columnValueDictionary 
		removeKey: typeField
		ifAbsent: [  ].
	columnValueDictionary 
		removeKey: oidField
		ifAbsent: [  ].
	adapter 
		updateFields: columnValueDictionary
		ofObjectWithId: self currentObject oid
		inTable: classTable.
	classTable := classTable parent ] doWhileTrue: [ classTable isNil not ].
! !

!SqsTableStructureHandler methodsFor: 'object-updating' stamp: 'tkow 12/13/2008 10:56'!
updateOwnedCollections
	| proxy colChanges descr |
	self currentObject indirectlyReferencedObjects do: 
		[ :collectionInfo | 
		"this object should always be an SqSaveCollectionProxy that 
		knows how the object looked like at the last save"
		proxy := collectionInfo collection ifNil: [ OrderedCollection new ].
		descr := collectionInfo collectionDescription.
		descr simpleValues ifFalse: 
			[ proxy do: [ :collectionObj | collectionObj ifNotNil: [ collectionObj save ] ] ].
		proxy class = SqsCollectionProxy 
			ifTrue: 
				[ colChanges := proxy sqsGetCollectionChanges.
				self 
					storeCollectionChanges: colChanges
					withDescription: descr ]
			ifFalse: 
				[ "some removed the proxy ... bastard ... well, then. 
				drop all objects and insert the collection once again"
				self currentAdapter log: 'proxy removed from object'.
				self currentAdapter 
					deleteEntriesFromJoinTable: descr
					forObjectId: self currentObject oid.
				self insertIndirectlyReferencedObject: collectionInfo ] ]! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/13/2008 10:56'!
updateTableStructure
	| tableChanges adapter |
	tableChanges := self getTableChanges.
	adapter := self currentAdapter.
	tableChanges do: 
		[ :tableChange | 
		tableChange newTableName ifNotNil: 
			[ adapter 
				renameTable: tableChange oldTable tableName
				to: tableChange newTableName ].
		adapter renameColumns: tableChange renamedColumns.
		adapter alterColumns: tableChange alteredColumns.
		adapter removeColumns: tableChange removedColumns.
		adapter addColumns: tableChange addedColumns ]! !

!SqsTableStructureHandler methodsFor: 'object-access' stamp: 'tkow 12/13/2008 10:58'!
valueForObject: anObject ofCollectionDescribedBy: collectionDescription 
	| objectValue |
	"return the object itself if it is a simple one
	or the oid on complex objects"
	collectionDescription simpleValues ifTrue: [ 
		objectValue := anObject 
	] ifFalse: [ 
		anObject ifNil: [ 
			objectValue := collectionDescription configuration nilValue 
		] ifNotNil: [ 
			anObject save: self currentSession.
			objectValue := anObject oid 
		] 
	].
	^ objectValue asSqlValueString! !

Object subclass: #SqsTestObject
	instanceVariableNames: 'testInteger testString testDate testSomething testBool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqsTestObject class
	uses: TSqsSearch
	instanceVariableNames: ''!

!SqsTestObject class methodsFor: 'compiling' stamp: 'tk 8/25/2008 12:03'!
acceptsLoggingOfCompilation
	^false! !

!SqsTestObject class methodsFor: 'persistence-description' stamp: ''!
sqsConfiguration
	^ SqsConfiguration new descriptionHandlerClass: SqsStandardExternDescriptionHandler;
		 collectionConfiguration: (SqsCollectionConfiguration new valueField: 'value';
			 orderedCollections: true;
			 orderField: 'sqs_order_number';
			 nilValue: 0;
			 yourself);
		 tableConfiguration: (SqsTableConfiguration new inheritanceMode: #singleTableInheritance;
			 typeField: 'type';
			 idField: 'id';
			 yourself);
		 environment: #development;
		 useInstVarAccessors: true;
		 warnOnAlteration: false;
		 yourself! !

!SqsTestObject class methodsFor: 'persistence-description' stamp: ''!
tableInheritance
	^ #classTableInheritance! !

!SqsTestObject class methodsFor: 'compiling' stamp: ''!
wantsChangeSetLogging
	^ false! !

!SqsTestObject methodsFor: 'comparing' stamp: ''!
= t1 
	self class instVarNames
		do: [:t2 | (t1 class instVarNames includes: t2)
				and: [(self instVarNamed: t2)
							= (t1 instVarNamed: t2)
						ifFalse: [^ false]]].
	^ true! !

!SqsTestObject methodsFor: 'accessing' stamp: ''!
testBool
	^ testBool! !

!SqsTestObject methodsFor: 'accessing' stamp: ''!
testBool: t1 
	testBool := t1! !

!SqsTestObject methodsFor: 'accessing' stamp: ''!
testDate
	<type: #dateTime>
	<linkTo: #SqSaveTestObject>
	^ testDate! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testDate: anObject
	testDate := anObject! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger
	^ testInteger! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger: anObject
	testInteger := anObject! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething
	^ testSomething! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething: anObject
	testSomething := anObject! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString
	^ testString! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString: anObject
	testString := anObject! !

SqsTestObject subclass: #SqsTestObjectChild
	instanceVariableNames: 'testSubString testUnstoredVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTestObjectChild class methodsFor: 'magritte-description' stamp: ''!
sqSaveUnpersistedInstVars
	^ #('testUnstoredVariable' )! !

!SqsTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString
	^ testSubString! !

!SqsTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString: anObject
	testSubString := anObject! !

SqsTestObjectChild subclass: #SqsTestObjectEvenDeeperChild
	instanceVariableNames: 'testExtremelyDeepSubString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString
	^ testExtremelyDeepSubString! !

!SqsTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString: anObject
	testExtremelyDeepSubString := anObject! !

Object subclass: #SqsTestObjectPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqsTestObjectPersistenceDescriptor subclass: #SqsTestObjectChildPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqsTestObjectChildPersistenceDescriptor subclass: #SqsTestObjectEvenDeeperChildPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTestObjectPersistenceDescriptor class methodsFor: 'compiling' stamp: 'tkow 10/10/2008 14:17'!
acceptsLoggingOfCompilation
	^false! !

!SqsTestObjectPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestInteger
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'test_integer';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'sqs_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testInteger';
		 yourself! !

!SqsTestObjectPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestSomething
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: OrderedCollection;
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'sqs_test_object_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (OrderedCollection new add: 'id';
					 yourself);
				 referencedTable: 'sqs_test_objects';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'value';
			 sqlType: #integer;
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 configuration: (SqsCollectionConfiguration new valueField: 'value';
			 orderedCollections: true;
			 orderField: 'sqs_order_number';
			 nilValue: 0;
			 yourself);
		 simpleValues: true;
		 indexType: #integer;
		 referencedClass: #SmallInteger;
		 linkedVariable: 'testSomething';
		 yourself! !

!SqsTestObjectPersistenceDescriptor class methodsFor: 'compiling' stamp: ''!
wantsChangeSetLogging
	^ false! !

Object subclass: #SqsUsageAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Analysis'!

Object subclass: #SqsUsageOptimizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Analysis'!

Object subclass: #SqsUsageStatistic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Analysis'!

Object subclass: #StSqueakSaveDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-UsageExamples'!

!StSqueakSaveDatabase commentStamp: 'tkow 9/24/2008 16:51' prior: 0!
A StSqueakSaveDatabase is another database variation for the SWA Seaside Tutorial application.

Instance Variables
!

!StSqueakSaveDatabase methodsFor: 'public' stamp: 'tkow 11/11/2008 13:42'!
addTask: aTask toUser: aUser
	aUser addTask: aTask.
	aTask save.
	aUser save.
	^aTask! !

!StSqueakSaveDatabase methodsFor: 'public' stamp: 'tkow 9/24/2008 15:00'!
addUser: aUser
	aUser save.
	^aUser! !

!StSqueakSaveDatabase methodsFor: 'accessing' stamp: 'tkow 9/24/2008 14:06'!
connectionFailed
	^ false! !

!StSqueakSaveDatabase methodsFor: 'connection' stamp: 'tkow 9/24/2008 16:05'!
disconnect
	^true! !

!StSqueakSaveDatabase methodsFor: 'public' stamp: 'tkow 12/12/2008 17:45'!
findUserByEmail: anEmail 
	^ (SqsSearch for: StUser) 
		findBy: #email
		withValues: anEmail! !

!StSqueakSaveDatabase methodsFor: 'initialization' stamp: 'tkow 12/13/2008 10:33'!
initialize
	| conSpec |
	super initialize.
	conSpec := SqsConnectionSpecification 
		user: 'thomas'
		password: 'test'
		database: 'ToDoApp'.
	SqsConnectionManager getInstance 
		setConSpec: conSpec
		for: 'STTutTodoApp'! !

!StSqueakSaveDatabase methodsFor: 'public' stamp: 'tkow 9/24/2008 13:58'!
save: anObject
	anObject save! !

!UndefinedObject methodsFor: '*sqsave' stamp: 'wh 8/10/2006 11:38'!
asSqlValueString
	^'NULL'.! !

!Date class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:24'!
sqsType
	^#date! !

!Date methodsFor: '*sqsave' stamp: 'wh 3/2/2006 15:23'!
asSqlValueString
	^'''', self yyyymmdd,''''. ! !

!Dictionary methodsFor: '*sqsave' stamp: 'test 1/22/2009 17:33'!
keysAndValuesDetect: aBlock 
	"returns not the association but the value of the association for which aBlock
	 evaluates to true for the first time"
	^ self 
		keysAndValuesDetect: aBlock
		ifNone: [ self errorNoMatch ]! !

!Dictionary methodsFor: '*sqsave' stamp: 'test 1/22/2009 17:34'!
keysAndValuesDetect: aBlock ifNone: errorBlock 
	"returns not the association but the value of the association for which aBlock
	 evaluates to true for the first time"
	self associationsDo: [ :assoc | 
		(aBlock value: assoc key value: assoc value) ifTrue: [ ^ assoc value ] 
	].
	^ errorBlock value! !

!Dictionary methodsFor: '*sqsave' stamp: 'tkow 9/12/2008 17:10'!
keysSelect: aBlock
	| newCollection |

	newCollection := self species new.
	self associationsDo: 
		[:each | 
		(aBlock value: each key) ifTrue: [newCollection add: each]].
	^newCollection! !

!Dictionary methodsFor: '*sqsave' stamp: 'tk 8/15/2008 14:55'!
valueJoin: anotherDictionary
	"really joins two dictionaries with collections as values"
	| ownValue mergeValue |
	anotherDictionary associationsDo: [ :assoc |
		(self includesKey: assoc key) ifTrue: [
			ownValue := (self at: assoc key) isCollection ifTrue:[
				self at: assoc key
			] ifFalse: [
				OrderedCollection with: (self at: assoc key)
			].
			mergeValue := (assoc value) isCollection ifTrue:[
				assoc value
			] ifFalse: [
				OrderedCollection with: (assoc value).
			].
			self at: assoc key put: (ownValue union: mergeValue).
		] ifFalse: [
			self at: assoc key put: assoc value
		]
	].
	^self! !

!Integer class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:28'!
sqsType
	^#integer ! !

!Integer methodsFor: '*sqsave' stamp: 'wh 8/8/2006 15:44'!
asSqlValueString
	^self asString.! !

!Collection methodsFor: '*sqsave' stamp: 'tk 7/14/2008 19:02'!
join: joinString
	| joiner |
	joiner := joinString ifNil:[''] ifNotNil: [joinString].
	^String streamContents: [:s | self asStringOn: s delimiter: joiner]! !

!Boolean class methodsFor: '*sqsave' stamp: 'test 1/19/2009 17:56'!
fromSqlValue: anObject
	(anObject class includesBehavior: Boolean) ifTrue: [
		^ anObject	
	] ifFalse: [
		anObject = 1 ifTrue: [
			^ true	
		] ifFalse: [
			^ false
		]
	]
	! !

!Boolean class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:27'!
sqsType
	^#boolean! !

!Boolean methodsFor: '*sqsave' stamp: 'wh 8/8/2006 15:57'!
asSqlValueString
	self ifTrue:[
		^'TRUE'.
	] ifFalse:[
		^'FALSE'.
	].! !

!Float class methodsFor: '*sqsave' stamp: 'tkow 1/20/2009 14:33'!
sqsType
	^#float! !

!Float methodsFor: '*sqsave' stamp: 'wh 8/8/2006 15:46'!
asSqlValueString
	^self asString.! !
